unit ape_u;

interface

{ test ob prog schon lft

	hTargetWnd := FindWindowEx(0, 0, nil, 'Fenstertitel');
	if hTargetWnd <> 0
	then begin
		PostMessage(hTargetWnd, PM_ActivateApp, 111, 111)
	end
	else begin
		Application.Initialize;
		Application.CreateForm(TFormLogin, FormLogin);
		Application.Run;
	end;
}
{
	Application.Initialize;
			Application.Title := 'pi_LOK';
			Application.Name := 'pi_BHS';
			ape_f := Tape_f.Create(nil);
			ape_f.show;
	Application.CreateForm(Tpi_lok_f, pi_lok_f);
	Application.CreateForm(Tbooster, booster);
	Application.CreateForm(Tpi_LOK_bf, pi_LOK_bf);
			ape_f.close;
	Application.CreateForm(Tape_f, ape_f);
			ape_f.AddText(1, 'Modell');
			ape_f.AddText(2, 'Bahn');
			ape_f.addtext(3, 'Steuerung');
			ape_f.AddText(4, 'DCC Daten erzeugen');
			ape_f.AddText(5, 'und auf COM ausgeben');
	Application.Run;
}
         
uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
	Clipbrd, Registry, shellapi, menus, winsock,
	filectrl, ScktComp, ComCtrls, Psock, NMsmtp, AppEvnts;
	
const
   CompileDate = 40988;	// 20.03.2012
	RegK = '\Software\APE Soft\';
//	RegED = '\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders';
//	RegEDS = 'Personal';
type
	Tape_f =
	class(TForm)
		Panel1: 		TPanel;
		z11: 			TLabel;
		z12: 			TLabel;
		z21: 			TLabel;
		z22: 			TLabel;
		z31: 			TLabel;
		z32: 			TLabel;
		z4: 			TLabel;
		Image1: 		TImage;
		Label7: 		TLabel;
		Label8: 		TLabel;
		vdate: 		TLabel;
		labm: 		TLabel;
		labw: 		TLabel;
		OK: 			TButton;
		Label4: 		TLabel;
		vyear: 		TLabel;
		cs: 			TClientSocket;
		Image2: 		TImage;
		vinfo: TLabel;
		ma: TNMSMTP;
		ae: TApplicationEvents;
		procedure 	FormCreate(Sender: TObject);
		procedure 	labwClick(Sender: TObject);
		procedure 	FormDestroy(Sender: TObject);
		procedure 	FormActivate(Sender: TObject);
		procedure 	OKClick(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
		procedure labmClick(Sender: TObject);
		procedure aeException(Sender: TObject; E: Exception);
	private	{ Private-Deklarationen}
		mitm:			tmenuitem;
		meni:			integer;
		histlist:	tstringlist;
		procedure	getPorts(FTDI: boolean);
		procedure	getNames;
		procedure	ShowHist();
		procedure	getipadr();
		procedure 	rm(mi: tmenuitem);
		procedure 	sm(mi: tmenuitem);
		function 	setregnam(nam: string): string;
	public	{ Public-Deklarationen}
		Namelist:	tstringlist;
		Addrlist:	tstringlist;
		PortList:	tstringlist;
		procedure	AddText(
						zei: byte;
						txt: string);
		procedure 	execcmd(
						cmd,
						par: string;
						ts: tstrings);
		procedure	Names(
						pm: TMenuItem;
						onclick: tnotifyevent);
		procedure	Ports(
						FTDIonly: boolean;
						pm: TMenuItem;
						onclick: tnotifyevent);
		function 	adr2num(adr: string): longint;
		function 	num2adr(adr: longint): string;
		procedure	AddHist(Filename: string);
		procedure	SetHistMenu(menuitem: tmenuitem);

		procedure   RForm;					overload;
		procedure   RForm(f: tform);		overload;
		function 	RdB(nam: string; wrt: boolean): boolean;
		function 	RdI(nam: string; wrt: integer): integer;
		function 	RdS(nam: string; wrt: string): string;

		procedure   SForm;             	overload;
		procedure   SForm(f: tform);		overload;
		procedure 	WrB(nam: string; wrt: boolean);
		procedure 	WrI(nam: string; wrt: integer);
		procedure 	WrS(nam: string; wrt: string);
	end;

var
	ape_f: 		Tape_f;
	cmd,
	par:			string;
	freg:			Tregistry;
	regkey1,
	regkey2,
	regold:		string;
	Form: Tform;

implementation

{$R *.DFM}

function Tape_f.setregnam(nam: string): string;
var
	n:			integer;
begin
	result := nam;
	if nam = ''
	then exit;
	regold := freg.CurrentPath;
	if nam[1] = '\'
	then begin
		freg.OpenKey(regkey1, true);
		result := copy(nam, 2, 255);
	end
	else begin
		freg.OpenKey(regkey2, true);
		if assigned(form)
		then freg.OpenKey(form.name, true);
	end;
	n := pos('\', result);
	while n > 0
	do begin
		freg.OpenKey(copy(result, 1, n), true);
		delete(result, 1, n);
		n := pos('\', result);
	end;
end;

procedure Tape_f.addtext(zei: byte; txt: string);
begin
	if txt = ''
	then exit;
	case zei of
	1:
		begin
			z11.Caption := txt[1];
			z12.Caption := copy(txt, 2, 32);
			z12.Left := z11.Left + z11.Width;
		end;
	2:
		begin
			z21.Caption := txt[1];
			z22.Caption := copy(txt, 2, 32);
			z22.Left := z21.Left + z21.Width;
		end;
	3:
		begin
			z31.Caption := txt[1];
			z32.Caption := copy(txt, 2, 32);
			z32.Left := z31.Left + z31.Width;
		end;
	4:
		begin
			z4.Caption := txt;
		end;
	5:
		begin
			z4.Caption := z4.Caption + #13 + #10 + txt;
		end;
	end;
end;

function Tape_f.adr2num(adr: string): longint;
var
	i,
	v,
	b:			integer;
begin
	result := 0;
	v := 1;
	for i := 0 to 3
	do begin
		b := pos('.', adr);
		if b = 0
		then b := length(adr) + 1;
		result := (result shl 8) + strtoint(copy(adr, v, b - 1));
		delete(adr, 1, b);
	end;
end;

function Tape_f.num2adr(adr: longint): string;
begin
	result := format('%d.%d.%d.%d',
				[adr shr 24,
				(adr shr 16) and $FF,
				(adr shr 8) and $FF,
				adr and $FF]);
end;

procedure Tape_f.execcmd(cmd, par: string; ts: tstrings);
var
	sa:		SECURITY_ATTRIBUTES;
	si:		STARTUPINFO;
	pi:		PROCESS_INFORMATION;
	hw,
	hr:		THandle;
//	com,
	buf:		array [0..255] of char;
	res:		boolean;
	dw:		dword;
	s:			string;
	n:			integer;
begin
//	getsystemdirectory(com, sizeof(com));
//	strcat(com, '\');
//	strcat(com, pchar(cmd));
	fillchar(sa, sizeof(sa), 0);
	sa.nLength := sizeof(sa);
	sa.bInheritHandle := TRUE;
	createpipe(hr, hw, @sa, 0);
	fillchar(si, sizeof(si), 0);
	fillchar(pi, sizeof(pi), 0);
	si.cb := sizeof(si);
	si.dwFlags := STARTF_USESTDHANDLES;
	si.hStdInput := 0;
	si.hStdOutput := hw;
	si.hStdError := hw;
	ts.Clear;
	if CreateProcess(nil,
				pchar(cmd + ' ' + par),   //
				nil,
				nil,
				TRUE,
				NORMAL_PRIORITY_CLASS or CREATE_NO_WINDOW,
				nil,
				nil,
				si,
				pi)
	then begin
		CloseHandle(hw);
		s := '';
		res := ReadFile(hr, buf, sizeof(buf), dw, nil);
		while res
		do begin
			s := s + copy(buf, 1, dw);
			res := ReadFile(hr, buf, sizeof(buf), dw, nil);
		end;
		n := pos(#10, s);
		while n > 0
		do begin
			ts.add(copy(s, 1, n - 2));
			delete(s, 1, n);
			n := pos(#10, s);
		end;
		CloseHandle(hr);
	end
	else begin
		dw := getlasterror();
		formatmessage(FORMAT_MESSAGE_FROM_SYSTEM,
					nil,
					dw,
					0,
					buf,
					sizeof(buf),
					nil);
		s := buf;
		showmessage(cmd + #13
						+ par + #13
						+ s);
		CloseHandle(hw);
		CloseHandle(hr);
	end;
end;

procedure Tape_f.getipadr;
var
	p:			PHostEnt;
	s: 		array[0..128] of char;
	p2:		PChar;
begin
	{Computer Name}
	GetHostName(s, sizeof(s));
	p := GetHostByName(s);
	{IpAddress}
	if assigned(p)
	then begin
		p2 := iNet_ntoa(PInAddr(p^.h_addr_list^)^);
		caption := caption + p^.h_name + ' (' + p2 + ')';
	end;
end;

procedure Tape_f.FormCreate(Sender: TObject);
var
	FileName: 	string;
	VerSize,
	InfoSize,
	Wnd: 			DWORD;
	VerBuf: 		Pointer;
	FI: 			PVSFixedFileInfo;
begin
	tag := 0;
	vinfo.caption := '';
	wnd := 0;
	try
		FileName := Application.ExeName;
		InfoSize := GetFileVersionInfoSize(PChar(FileName), Wnd);
		if InfoSize > 0
		then begin
			GetMem(VerBuf, InfoSize);
			try
				if GetFileVersionInfo(
						PChar(FileName),
						Wnd,
						InfoSize,
						VerBuf)
				then begin
					if VerQueryValue(VerBuf, '\', Pointer(FI), VerSize)
					then begin
						vinfo.Caption :=
							  '(' + IntToStr(FI.dwFileVersionMS shr 16)
							+ '.' + IntToStr((FI.dwFileVersionMS shl 16) shr 16)
							+ '.' + IntToStr(FI.dwFileVersionLS shr 16)
							+ '.' + IntToStr((FI.dwFileVersionLS shl 16) shr 16)
							+ ')';
					end;
				end;
			finally
				FreeMem(VerBuf);
			end;
		end;
	except
		vinfo.caption := '';
	end;
	vdate.Caption := FormatDateTime('d.m.yyyy', Compiledate);
	vyear.Caption := FormatDateTime('yyyy', Compiledate);
   getipadr();
	histlist := tstringlist.Create;
	meni := 0;
	NameList := tstringlist.Create;
	AddrList := tstringlist.Create;
	PortList := tstringlist.Create;
	PortList.Duplicates := dupIgnore;
	PortList.Sorted := true;
	if application.Title = ''
	then begin
		showmessage('Application.Title leer');
		application.terminate;
	end;
	regkey1 := regk + application.Title + '\';
	regkey2 := regk + application.Title + '\';
	if pos('\', application.Title) > 0
	then begin
		regkey1 := regk + copy(application.title,
							1,
							pos('\', application.Title));
	end;
	freg := tregistry.Create;
	freg.RootKey := HKEY_CURRENT_USER;
	freg.openkey(RegKey1, true);
//	comalist := tstringlist.Create;
end;

function Tape_f.rdb(nam: string;	wrt: boolean): boolean;
begin
	nam := setregnam(nam);
	if freg.ValueExists(nam)
	then result := freg.ReadBool(nam)
	else result := wrt;
	freg.OpenKey(regold, false);
end;

function Tape_f.rdi(nam: string; wrt: integer): integer;
begin
	nam := setregnam(nam);
	if freg.ValueExists(nam)
	then result := freg.ReadInteger(nam)
	else result := wrt;
	freg.OpenKey(regold, false);
end;

function Tape_f.rds(nam: string; wrt: string): string;
begin
	nam := setregnam(nam);
	if freg.ValueExists(nam)
	then result := freg.ReadString(nam)
	else result := wrt;
	freg.OpenKey(regold, false);
end;

procedure tape_f.rm(mi: tmenuitem);
var
	i:			integer;
begin
	if mi.Count > 0
	then begin
		for i := 0 to mi.Count - 1
		do begin
			rm(mi.items[i])
		end;
	end
	else begin
		if mi.Name > ''
		then begin
			mi.Enabled := rdb(mi.Name + '_en', mi.Enabled);
			mi.Tag := rdi(mi.Name + '_tg', mi.Tag);
			if rdb(mi.Name + '_ch', mi.Checked) <> mi.checked
			then mi.Click;
		end;
	end;
end;

procedure tape_f.sm(mi: tmenuitem);
var
	i:			integer;
begin
	if mi.Count > 0
	then begin
		for i := 0 to mi.Count - 1
		do begin
			sm(mi.items[i])
		end;
	end
	else begin
		if (mi.Name > '')
		and (mi.Caption <> '-')
		then begin
			wrb(mi.Name + '_en', mi.Enabled);
			wrb(mi.Name + '_ch', mi.Checked);
			wri(mi.Name + '_tg', mi.Tag);
		end;
	end;
end;

procedure tape_f.sform(f: tform);
var
	c2:		integer;
begin
	form := f;
	if f.Name = 'apef'
	then exit;
	if f.Name = 'ape_f'
	then exit;
	freg.OpenKey(RegKey2 + f.name, true);
	freg.WriteInteger('Left', f.Left);
	freg.WriteInteger('Top', f.Top);
	freg.WriteInteger('Height', f.Height);
	freg.WriteInteger('Width', f.Width);
	freg.WriteInteger('WindowState'
				, integer(f.windowstate));
	if assigned(f.menu)
	then begin
		for c2 := 0 to f.menu.componentcount - 1
		do begin
			sm(tmenuitem(f.menu.components[c2]));
		end;
	end;
	for c2 := 0 to f.componentcount - 1
	do begin
		if f.components[c2] is tdirectorylistbox
		then begin
			with f.components[c2] as tdirectorylistbox
			do begin
				freg.WriteInteger(Name + '_tg', Tag);
				freg.WriteString(Name + '_di', Directory);
			end;
		end;
		if f.components[c2] is tfilelistbox
		then begin
			with f.components[c2] as tfilelistbox
			do begin
				freg.WriteInteger(Name + '_tg', Tag);
				freg.WriteString(Name + '_di', Directory);
				freg.WriteString(Name + '_fi', FileName);
			end;
		end;
		if f.components[c2] is topendialog
		then begin
			with f.components[c2] as topendialog
			do begin
				freg.WriteString(Name + '_id', InitialDir);
				freg.WriteString(Name + '_fn', FileName);
				freg.WriteInteger(Name + '_tg', Tag);
				freg.WriteInteger(Name + '_fi', FilterIndex);
			end;
		end;
		if f.components[c2] is tsavedialog
		then begin
			with f.components[c2] as tsavedialog
			do begin
				freg.WriteString(Name + '_id', InitialDir);
				freg.WriteString(Name + '_fn', FileName);
				freg.WriteInteger(Name + '_tg', Tag);
				freg.WriteInteger(Name + '_fi', FilterIndex);
			end;
		end;
		if (f.components[c2] is tbutton)
		and (f.components[c2].Name = 'rdapesv')
		then begin
			with f.components[c2] as tbutton
			do begin
				enabled := true;
				click;
			end;
		end;
	end;
end;

procedure tape_f.sform;
var
	c1:		integer;
begin
	with application
	do begin
		freg.RootKey := HKEY_CURRENT_USER;
		freg.OpenKey(regkey2, true);
		freg.WriteString('CompileDate', DateToStr(compiledate));
		for c1 := 0 to screen.FormCount - 1
		do begin
			sform(screen.Forms[c1]);
		end;
		freg.OpenKey(RegKey2, false);
	end;
end;

procedure Tape_f.wrb(nam: string; wrt: boolean);
begin
	nam := setregnam(nam);
	freg.WriteBool(nam, wrt);
	freg.OpenKey(regold, false);
end;

procedure Tape_f.wri(nam: string; wrt: integer);
begin
	nam := setregnam(nam);
	freg.WriteInteger(nam, wrt);
	freg.OpenKey(regold, false);
end;

procedure Tape_f.wrs(nam: string; wrt: string);
begin
	if wrt = ''
	then exit;
	nam := setregnam(nam);
	freg.WriteString(nam, wrt);
	freg.OpenKey(regold, false);
end;

procedure tape_f.rform(f: tform);
var
	c2:		integer;
begin
	form := f;
	if f.Name = 'ape_f'
	then exit;
	if not freg.OpenKey(RegKey2 + '\' + f.name, false)
	then exit;
	if f.Name = 'apef'
	then exit;
	if f.AutoSize = false
	then begin
		f.height := rdi('Height', f.height);
		f.width := rdi('Width', f.Width);
	end;
	f.Left := rdi('Left', f.Left);
	f.top := rdi('Top', f.Top);
	f.windowstate := twindowstate(rdi('WindowState'
			, integer(wsnormal)));
	if assigned(f.menu)
	then begin
		for c2 := 0 to f.menu.componentcount - 1
		do begin
			rm(tmenuitem(f.menu.components[c2]));
		end;
	end;
	for c2 := 0 to f.componentcount - 1
	do begin
		if f.components[c2] is tdirectorylistbox
		then begin
			with f.components[c2] as tdirectorylistbox
			do begin
				Directory := rds(Name + '_di', Directory);
				Tag := rdi(Name + '_tg', Tag);
			end;
		end;
		if f.components[c2] is tfilelistbox
		then begin
			with f.components[c2] as tfilelistbox
			do begin
				Directory := rds(Name + '_di', Directory);
				FileName := rds(Name + '_fi', Filename);
				Tag := rdi(Name + '_tg', Tag);
			end;
		end;
		if f.components[c2].Name = 'cb'
		then begin
			with f.components[c2] as tcombobox
			do begin
				Tag := rdi(Name + '_tg', Tag);
			end;
		end;
		if f.components[c2] is topendialog
		then begin
			with f.components[c2] as topendialog
			do begin
				InitialDir := rds(Name + '_id', InitialDir);
				FileName := rds(Name + '_fn', FileName);
				Tag := rdi(Name + '_tg', Tag);
				FilterIndex := rdi(Name + '_fi', FilterIndex);
			end;
		end;
		if f.components[c2] is tsavedialog
		then begin
			with f.components[c2] as tsavedialog
			do begin
				InitialDir := rds(Name + '_id', InitialDir);
				FileName := rds(Name + '_fn', FileName);
				Tag := rdi(Name + '_tg', Tag);
				FilterIndex := rdi(Name + '_fi', FilterIndex);
			end;
		end;
		if (f.components[c2] is tbutton)
		and (f.components[c2].Name = 'rdapesv')
		then begin
			with f.components[c2] as tbutton
			do begin
				enabled := false;
				click;
			end;
		end;
	end;
end;

procedure tape_f.rform;
var
	c1:		integer;
begin
	with application
	do begin
		freg.RootKey := HKEY_CURRENT_USER;
		if Title = ''
		then begin
			showmessage('Application.Title leer');
			terminate;
		end;
		if not freg.KeyExists(regkey2)
		then exit;
		freg.openkey(regkey2, true);
		for c1 := 0 to screen.FormCount - 1
		do begin
			rform(screen.Forms[c1]);
		end;
		freg.OpenKey(RegKey2, false);
	end;
end;

procedure tape_f.addhist(filename: string);
var
	i:			integer;
begin

	if filename = ''
	then exit;
	i := histlist.IndexOf(filename);
	if i > -1
	then histlist.Delete(i);
	histlist.insert(0, filename);
	while histlist.Count > 9
	do histlist.Delete(9);
	if assigned(mitm)
	then showhist();
end;

procedure tape_f.showhist();
var
	i:   		integer;
	mi:		tmenuitem;
begin
	if not assigned(mitm)
	then exit;
	mitm.AutoHotkeys := maManual;
	for i := 0 to mitm.Count - 1
	do mitm.Items[0].Free;
	for i := 0 to histlist.Count - 1
	do begin
		if histlist[i] > ''
		then begin
			mi := tmenuitem.Create(self);
//			mi.ShortCut := shortcut(word(i + 49), [ssCtrl]);
			mi.Caption := histlist[i];
			mi.Hint := histlist[i];
			mi.Name := format('RecFile%d', [i + 1]);
			if fileexists(histlist[i])
			then mi.Enabled := true
			else mi.Enabled := false;
			mi.OnClick := mitm.onclick;
			mitm.Add(mi);
		end;
	end;
end;

procedure tape_f.sethistmenu(menuitem: tmenuitem);
var
	i:			integer;
begin
	mitm := menuitem;
	mitm.AutoHotkeys := maManual;
	if histlist.Count = 0
	then begin
		for i := 8 downto 0
		do begin
			AddHist(RdS(format('\Recfile%d', [i]), ''));
		end;
	end;
	z12.Left := z11.Left + z11.Width;
	z22.Left := z21.Left + z21.Width;
	z32.Left := z31.Left + z31.Width;
	showhist();
end;

procedure tape_f.Ports(
			FTDIonly: boolean;
			pm: tmenuitem;
			onclick: tnotifyevent);
var
	i:			integer;
	m:			tmenuitem;
begin
	getports(ftdionly);
	if not assigned(pm)
	then exit;
	for i := pm.Count - 1 downto 0
	do pm[i].Free;
	m := tmenuitem.Create(self);
	m.Caption := 'kein Port';
	m.RadioItem := true;
	m.checked := true;
	m.GroupIndex := 1;
	m.Name := pm.Name + '00';
	m.Tag := 0;
	m.OnClick := onclick;
	pm.Add(m);
	for i := 0 to PortList.Count - 1
	do begin
		m := tmenuitem.Create(self);
		m.Caption := PortList[i];
		m.AutoHotkeys := mamanual;
		m.RadioItem := true;
		m.GroupIndex := 1;
		m.Tag := i + 1;
		m.OnClick := onclick;
		m.Name := pm.Name + '_' + m.Caption;
		pm.Add(m);
	end;
end;

procedure tape_f.getPorts(ftdi: boolean);
var
	reg:		treginifile;
	i:			integer;
	s:			string;
	h:			thandle;
	p:			array [0..255] of char;
	ts:		TStringList;
	sw:		boolean;
begin
	reg := TReginifile.Create;
	reg.Access := KEY_READ;
	ts := tstringlist.Create;
	try
		reg.RootKey := HKEY_LOCAL_MACHINE;
		if not ftdi
		then begin
			reg.OpenKey('\HARDWARE\DEVICEMAP\SERIALCOMM', false);
			reg.GetValueNames(ts);
			reg.OpenKey('\HARDWARE\DEVICEMAP', false);
			for i := 0 to ts.Count - 1
			do begin
				s := ts[i];
				PortList.Add(reg.ReadString('SERIALCOMM', s, ''));
			end;
		end;
		// win98se
		sw := reg.OpenKey('\Enum', false);
		sw := sw and reg.OpenKey('ftdibus', false);
		if sw
		then begin
			reg.GetKeyNames(ts);
			for i := 0 to ts.Count - 1
			do begin
				s := ts[i];
				PortList.Add(reg.ReadString(s + '\0000', 'PortName', ''));
			end;
		end;
		// winxp
		sw := reg.OpenKey('\system', false);
		sw := sw and reg.OpenKey('currentcontrolset', false);
		sw := sw and reg.OpenKey('Enum', false);
		sw := sw and reg.OpenKey('FTDIBUS', false);
		if sw
		then begin			
			reg.GetKeyNames(ts);
			for i := 0 to ts.Count - 1
			do begin
				s := ts[i];
				PortList.Add(reg.ReadString(s + '\0000\device parameters', 'PortName', ''));
			end;
		end;
	finally
		reg.Free;
		ts.free;
	end;
	for i := PortList.Count - 1 downto 0
	do begin
		if PortList[i] = ''
		then PortList.Delete(i);
	end;
	for i := PortList.Count - 1 downto 0
	do begin
		strPcopy(p, '\\.\' + PortList[i]);
		h := createfile(
					p,
					GENERIC_READ or GENERIC_WRITE,
					0,
					nil,
					OPEN_EXISTING,
					0,
					0);
		if h = INVALID_HANDLE_VALUE
		then begin
			PortList.Delete(i);
{			formatmessage(
					FORMAT_MESSAGE_FROM_SYSTEM,
					nil,
					getlasterror(),
					0,
					p,
					sizeof(p),
					nil);
			comalist[i] := strpas(p);
}		end;
		closehandle(h);
	end;
end;

procedure tape_f.Names(
			pm: tmenuitem;
			onclick: tnotifyevent);
var
	i:			integer;
	m:			tmenuitem;
begin
	exit;
	
	getnames;
	if not assigned(pm)
	then exit;
	for i := pm.Count - 1 downto 0
	do pm[i].Free;
	m := tmenuitem.Create(self);
	m.Caption := 'localhost';
	m.RadioItem := true;
	m.checked := true;
	m.GroupIndex := 1;
	m.Name := pm.Name + '00';
	m.Tag := adr2num('127.0.0.1');
	m.OnClick := onclick;
	pm.Add(m);
	for i := 0 to NameList.Count - 1
	do begin
		m := tmenuitem.Create(self);
		m.Caption := NameList[i];
		m.AutoHotkeys := mamanual;
		m.RadioItem := true;
		m.GroupIndex := 1;
		m.Tag := adr2num(addrlist[i]);
		m.OnClick := onclick;
		m.Name := pm.Name + '_' + m.Caption;
		pm.Add(m);
	end;
end;

procedure tape_f.getnames;
var
	ts:		TStringlist;
	p:			string;
	i:			integer;
	reg:		tregistry;
	ho:		phostent;
	dw:		dword;
	buf:		array [0..255] of char;
begin
	namelist.Clear;
	addrlist.Clear;
	ts := tstringlist.Create;
	reg := tregistry.Create;
	try
		reg.openkey(RegK + 'Rechner', true);
		reg.GetKeyNames(ts);
		for i := 0 to ts.count - 1
		do reg.deletekey(ts[i]);
		execcmd('net.exe', 'view', ts);
		if ts.Count > 3
		then begin
			for i := 0 to ts.Count - 1
			do begin
				if copy(ts[i], 1, 2) = '\\'
				then begin
					p := trim(copy(ts[i], 3, 21));
					namelist.Add(p);
					ho := gethostbyname(pchar(p));
					if assigned(ho)
					then begin
						p := inttostr(byte(ho.h_addr^[0])) + '.'
							+ inttostr(byte(ho.h_addr^[1])) + '.'
							+ inttostr(byte(ho.h_addr^[2])) + '.'
							+ inttostr(byte(ho.h_addr^[3]));
						addrlist.Add(p);
						reg.WriteString(strpas(ho.h_name), p);
					end
					else begin
						dw := wsagetlasterror();
						formatmessage(FORMAT_MESSAGE_FROM_SYSTEM,
									nil,
									dw,
									0,
									buf,
									sizeof(buf),
									nil);
						p := buf;
						showmessage(p);
					end;
				end;
			end;
		end;
	finally
		reg.Free;
		ts.Free;
	end;
end;

procedure Tape_f.FormDestroy(Sender: TObject);
var
	i: integer;
begin
	for i := 0 to histlist.Count - 1
	do begin
		WrS(format('\RecFile%d', [i]), histlist[i]);
	end;
	NameList.Free;
	AddrList.Free;
	PortList.Free;
//	comalist.Free;
end;

procedure Tape_f.FormActivate(Sender: TObject);
begin
	caption := 'ber ' + application.Title;
	if owner = nil
	then begin
		panel1.visible := false;
	end
	else begin
		panel1.visible := true;
		autosize := true;
	end
end;

procedure Tape_f.OKClick(Sender: TObject);
begin
	ape_f.Hide;
end;

procedure Tape_f.FormClose(Sender: TObject; var Action: TCloseAction);
var
	i:			integer;
begin
	for i := 0 to histlist.Count - 1
	do begin
		WrS(format('\RecFile%d', [i]), histlist[i]);
	end;
end;

procedure Tape_f.labwClick(Sender: TObject);
begin
	ShellExecute(application.handle,
			 PChar('open'),
			 PChar(labw.caption),
			 nil,
			 nil,
			 SW_SHOWNORMAL);
end;

procedure Tape_f.labmClick(Sender: TObject);
begin
	ShellExecute(application.handle,
			 PChar('open'),
			 PChar('mailto:' + labm.Caption
				+ '?subject=Nachricht%20zu%20'
				+ application.Title
				+ '&body=%20%0d%0a%20%0d%0a%20%0d%0a'
				+ 'Mit%20freundlichen%20Gr%FC%DFen'),
			 nil,
			 nil,
			 SW_SHOWNORMAL);
end;

procedure Tape_f.aeException(Sender: TObject;
	E: Exception);
var
	s: string;
begin
	s := application.Title + #10#13
		+ vdate.caption + ' ' + vinfo.caption + #10#13
		+ 'Exception: ' + e.message + #10#13
		+ tcomponent(sender).name + #10#13
		+ tcomponent(sender).owner.name + #10#13
		+ format('%8.8x', [longint(exceptaddr())])
		+ #10 + #13;
	if messagedlg(s + 'Fehlermeldung per Mail senden?',
				mtConfirmation,
				[mbyes, mbno],
				0) = mrno
	then begin
		ape_f.Close;
		exit;
	end;
	ShellExecute(application.handle,
			 PChar('open'),
			 PChar('mailto:' + labm.Caption
				+ '?subject=pi_Soft:Fehler%20zu%20'
				+ application.Title
				+ '&body='
				+ application.Title + '%0d%0a'
				+ vdate.caption + ' ' + vinfo.caption + '%0d%0a'
				+ 'Exception:%20' + e.message + '%0d%0a'
				+ tcomponent(sender).name + '%0d%0a'
				+ tcomponent(sender).owner.name + '%0d%0a'
				+ format('%8.8x', [longint(exceptaddr())])),
			 nil,
			 nil,
			 SW_SHOWNORMAL);
	ape_f.Close;
end;

end.

