unit mbs_aus;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Menus, StdCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, ExtCtrls, mbs_epd;

type
	TfAus =
	class(TForm)
	 	par: TGroupBox;
		pin: Tmbs_led;
	 	act: TCheckBox;
		lont: TLabel;
		loft: TLabel;
		now: TCheckBox;
		nfw: TCheckBox;
		lnpn: TLabel;
		pm: TPopupMenu;
		pmn: TMenuItem;
		N1: TMenuItem;
		pma: TMenuItem;
		chc: TStaticText;
		ont: Tmbs_epd;
		oft: Tmbs_epd;
		npn: Tmbs_epd;
		fun: TRadioGroup;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
		procedure pmnClick(Sender: TObject);
		procedure chcClick(Sender: TObject);
	private		{ Private-Deklarationen }
		procedure Setwrt(a: byte);
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure ChngStat;
		procedure draw(f: tmbs_fld);
	end;

var
	fAus: 		TfAus;

implementation

uses mbs_bea_u, mbs_col_u;

{$R *.DFM}

procedure TfAus.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfAus.Setwrt(a: byte);
begin
	act.Checked := mw.dini.ReadInteger(mw.sdev, 'ach', 0) > 0;
end;

procedure TfAus.GetPar;
var
	n: string;
begin
	with mbs_bea_f
	do begin
		par.tag := 1;
		mw.w.Stan := 2;
		if mw.w.Farb = 0
		then mw.w.Farb := $8f;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := false;
		st3.Visible := false;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;
		
		pin.adr := mw.w.ad[dev.ItemIndex];
		iniset(pin.adr.dc, pin.adr.dv, true);

		n := mw.dini.ReadString(mw.sdev, 'nam', '');
		setwrt(0);
		if n = 'ULN'	then setwrt(1);
		if n = 'LED'   then setwrt(0);
		if n = 'UMSCH'	then setwrt(0);
		now.Checked := mw.dini.ReadInteger(mw.sdev, 'non', 0) > 0;
		nfw.Checked := mw.dini.ReadInteger(mw.sdev, 'nof', 0) > 0;
		ont.Value := mw.dini.ReadInteger(mw.sdev, 'ont', 0);
		oft.Value := mw.dini.ReadInteger(mw.sdev, 'oft', 0);
		npn.Value := mw.dini.ReadInteger(mw.sdev, 'ndv', 0);

		fun.ItemIndex := mw.w.GetIpar(tpar(dev.ItemIndex));
		par.Caption := sftab[integer(mw.w.ftyp)];
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		par.tag := 0;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfAus.SetPar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Ad[dev.ItemIndex] := pin.Adr;
		mw.dtab[mw.w.Ad[dev.itemindex].dc].f[mw.w.Ad[dev.itemindex].dv] := mw.w;
		mw.w.DelVerb(true);
		mw.w.SetIpar(tpar(dev.ItemIndex), fun.ItemIndex);

//		mw.w.SetDpar(dev.ItemIndex, par0, byte(act.checked) shl 3
//						  + byte(now.checked) shl 2
//						  + byte(nfw.checked) shl 1);
//		mw.w.SetDpar(dev.ItemIndex, par1, ont.Value);
//		mw.w.SetDpar(dev.ItemIndex, par2, oft.Value);
//		mw.w.SetDpar(dev.ItemIndex, par3, npn.Value);

		if act.Checked
		then mw.dini.WriteInteger(mw.sdev, 'ach', 4)
		else mw.dini.WriteInteger(mw.sdev, 'ach', 0);
		if now.Checked
		then mw.dini.WriteInteger(mw.sdev, 'non', 2)
		else mw.dini.WriteInteger(mw.sdev, 'non', 0);
		if nfw.Checked
		then mw.dini.WriteInteger(mw.sdev, 'nof', 1)
		else mw.dini.WriteInteger(mw.sdev, 'nof', 0);
		mw.dini.WriteInteger(mw.sdev, 'ont', ont.Value);
		mw.dini.WriteInteger(mw.sdev, 'oft', oft.Value);
		mw.dini.WriteInteger(mw.sdev, 'ndv', npn.Value);

		if (ont.Value <> leer)		// schuss
		and (oft.Value = leer)
		and (npn.Value = leer)
		then begin
			fun.ItemIndex := 2;
			mw.w.SetMess(dev.ItemIndex, sta0, leer);
		end
		else mw.w.SetMess(dev.ItemIndex, sta0, 0);
		mw.w.SetMess(dev.ItemIndex, sta1, 1);
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfAus.draw(f: tmbs_fld);
const
	d = gr div 3 - 1;
	r: TRect = (left: d + 1;		Top: d + 1;
					Right: gr - d; 	bottom: gr - d);
begin
	with mw.bm.Canvas
	do begin
		pen.Width := 2;
		pen.Color := clgray;
		if f.stat = sta1
		then brush.Color :=
					mbs_col_f.Getcolor(F.Farb and $0f)
		else brush.Color :=
					mbs_col_f.Getcolor(F.Farb shr 4);
		rectangle(r);
	end;
end;

// statusnderung
procedure TfAus.SetStat(fld: tmbs_fld; stat: tsta);
begin
	fld.setstatcom(stat);
end;

// statusnderung durch Click
procedure TfAus.ChngStat;
var
	p:			TPoint;
begin
	mw.w.NextStat;			// umschalten
	exit;

	pmn.Visible := mw.test;
	p.x := mw.w.X * gr;
	p.y := mw.w.Y * gr;
	if mw.w.X < mw.trenn
	then p := mw.i1.ClientToScreen(p)
	else p := mw.i2.ClientToScreen(p);
	pm.Popup(p.x, p.y);
end;

// statustabelle versorgen
procedure TfAus.SetStab(fld: tmbs_fld);
begin
	fld.PTyp := ptout;
	fld.stan := 2;
end;

procedure TfAus.pmnClick(Sender: TObject);
begin
	mw.w.NextStat;			// umschalten
end;

procedure TfAus.chcClick(Sender: TObject);
begin
	with mbs_col_f
	do begin
		top := chc.clienttoscreen(point(0, 0)).y;
		left := chc.clienttoscreen(point(0, 0)).x;
		Tag := mw.w.Farb;
		showmodal;
		mw.w.Farb := Tag;
		setpar(self);
	end;
end;

end.
