unit mbs_col_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
  	Controls, Forms, Dialogs, StdCtrls, ColorGrd;

type
	Tmbs_col_f =
	class(TForm)
		colg:	TColorGrid;
		colo:	TButton;
		colc:	TButton;
		procedure coloClick(Sender: TObject);
		procedure FormShow(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		function	Getcolor(i: integer): tcolor;
	end;

var
	mbs_col_f: Tmbs_col_f;

implementation

uses ape_u;

{$R *.DFM}

function	Tmbs_col_f.Getcolor(i: integer): tcolor;
begin
	colg.ForegroundIndex := i;
	result := colg.ForegroundColor;
end;

procedure Tmbs_col_f.coloClick(Sender: TObject);
begin
	tag := colg.ForegroundIndex
			+ colg.BackgroundIndex shl 4;
end;

procedure Tmbs_col_f.FormShow(Sender: TObject);
begin
	if tag > 0
	then begin
		colg.ForegroundIndex := tag and $0f;
		colg.BackgroundIndex := tag shr 4;
	end
	else begin
		colg.ForegroundIndex := 8;
		colg.BackgroundIndex := $f;
	end;
end;

end.
