unit mbs_fkt_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Grids, StdCtrls, ExtCtrls;

const
	showt: array [1..14, 1..14] of byte =
	( (0, 0, 0, 0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1),
	  (0, 0, 0, 0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1),
	  (0, 0, 0, 0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1),
	  (0, 0, 0, 0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1),
	  (0, 0, 0, 0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1),
	  (0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0),
	  (0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0),
	  (0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0),
	  (0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0),
	  (0, 0, 0, 8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0),
	  (8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0),
	  (8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0),
	  (8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0),
	  (8, 7, 6, 5, 4, 3, 2, 1, 0, 0, 0, 0, 0, 0));

type
	Tmbs_fkt_f =
	class(TForm)
		Label1: TLabel;
		Label2: TLabel;
		Label3: TLabel;
		Label4: TLabel;
		Label5: TLabel;
		Label6: TLabel;
		Label15: TLabel;
		Label16: TLabel;
		Label17: TLabel;
		Label18: TLabel;
		Label19: TLabel;
		Label20: TLabel;
		Label21: TLabel;
		Label22: TLabel;
		Label23: TLabel;
		Label24: TLabel;
		Label25: TLabel;
		Label26: TLabel;
		Label27: TLabel;
		Label28: TLabel;
		Label29: TLabel;
		Label30: TLabel;
		Label31: TLabel;
		Label33: TLabel;
		Label34: TLabel;
		Label35: TLabel;
		Label36: TLabel;
		Label37: TLabel;
		Label38: TLabel;
		Label39: TLabel;
		Label40: TLabel;
		Label41: TLabel;
		Label42: TLabel;
		Panel1: TPanel;
		Panel2: TPanel;
		OK: TButton;
		Button2: TButton;
		procedure FormCreate(Sender: TObject);
		procedure FormActivate(Sender: TObject);
		procedure cbtClick(Sender: TObject);
	private		{ Private-Deklarationen }
		procedure Showfunk;
	public 		{ Public-Deklarationen }
		funktab: array [1..14] of byte;
	end;

var
	mbs_fkt_f: Tmbs_fkt_f;
	cbt: array [1..14, 1..14] of tcheckbox;
	sws: boolean;

implementation

{$R *.DFM}

procedure Tmbs_fkt_f.Showfunk;
var
	i,
	r: byte;
begin
	sws := true;
	for r := 1 to 14
	do begin
		for i := 0 to 7
		do begin
			case r of
			1..5:
				begin
					if ((funktab[r] shr i) and 1) > 0
					then cbt[14 - i, r].Checked := true
					else cbt[14 - i, r].Checked := false;
				end;
			6..10:
				begin
					if ((funktab[r] shr i) and 1) > 0
					then cbt[11 - i, r].Checked := true
					else cbt[11 - i, r].Checked := false;
				end;
			11..14:
				begin
					if ((funktab[r] shr i) and 1) > 0
					then cbt[8 - i, r].Checked := true
					else cbt[8 - i, r].Checked := false;
				end;
			end;
		end;
	end;
	sws := false;
end;

procedure Tmbs_fkt_f.FormCreate(Sender: TObject);
var
	x,
	y: integer;
begin
	for x := 1 to 14
	do begin
		for y := 1 to 14
		do begin
			if showt[y, x] > 0
			then begin
				cbt[x, y] := tcheckbox.Create(self);
				cbt[x, y].parent := self;
				cbt[x, y].Width := 16;
				cbt[x, y].height := 16;
				cbt[x, y].Left := x * 14 - 14;
				cbt[x, y].Top := y * 14 + 18;
				cbt[x, y].OnClick := cbtclick;
				cbt[x, y].Tag := y shl 8 + showt[y, x] - 1;
			end;
		end;
	end;
end;

procedure Tmbs_fkt_f.FormActivate(Sender: TObject);
begin
	showfunk;
end;

procedure Tmbs_fkt_f.cbtClick(Sender: TObject);
begin
	if sws
	then exit;
	with sender as tcheckbox
	do begin
		funktab[tag shr 8] := funktab[tag shr 8] xor (1 shl (tag and 7));
	end;
end;

end.
