unit mbs_hsi;

interface

uses	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Menus, StdCtrls, ExtCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, mbs_epd;

type
	TfHsi =
	class(TForm)
		par: TGroupBox;
		rot: Tmbs_led;
		pm: TPopupMenu;
		pmrot: TMenuItem;
		pmgrn: TMenuItem;
		N1: TMenuItem;
		pmbel: TMenuItem;
		pmfre: TMenuItem;
		N2: TMenuItem;
		pma: TMenuItem;
		pmg40: TMenuItem;
		pmg60: TMenuItem;
		beg: TRadioGroup;
    swi: TCheckBox;
    vsi: Tmbs_lab;
    vms: Tmbs_lab;
    lhst: TLabel;
    Label1: TLabel;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
		procedure pmrotClick(Sender: TObject);
		procedure pmgrnClick(Sender: TObject);
		procedure pmbelClick(Sender: TObject);
		procedure pmfreClick(Sender: TObject);
		procedure pmg40Click(Sender: TObject);
		procedure pmg60Click(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure ChngStat;
		procedure draw(fld: tmbs_fld);
	end;

var
	fHsi: 		TfHsi;

implementation

uses mbs_bea_u;

{$R *.DFM}

procedure TfHsi.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfHsi.GetPar;
var
	v:			Tmbs_vrb;
begin
	with mbs_bea_f
	do begin
		par.Tag := 1;
		mw.w.PTyp := pthsi;
		rot.Adr := mw.w.Ad[0];
		iniset(rot.adr.dc, rot.adr.dv, true);

		swi.Checked := false;
		mw.w.Ad[1] := adr_leer;
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		beg.ItemIndex := mw.w.Stan - 2;
		if mw.w.Stan = 2
		then swi.Enabled := true
		else swi.Enabled := false;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := (mw.w.Stan > 2);
		st3.Visible := (mw.w.Stan > 3);
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;
		vsi.pos := point(0, 0);
		vms.pos := point(0, 0);
		mw.w.FstVerb;
		while mw.w.GetVerb(v)
		do begin
			if v.fix = vsi.tag
			then begin
				if ftvsi = mw.ftab[v.x, v.y].FTyp
				then begin
					vsi.Pos := point(v.x, v.y);
				end
				else mw.w.DelVerb(v);
				continue;
			end;
			if v.fix = vms.tag
			then begin
				if ftvsi = mw.ftab[v.x, v.y].FTyp
				then begin
					vms.Pos := point(v.x, v.y);
				end
				else mw.w.DelVerb(v);
				continue;
			end;
		end;
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		par.Tag := 0;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfHsi.SetPar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Stan := beg.ItemIndex + 2;
		mw.w.ad[0] := rot.Adr;
		mw.dtab[mw.w.Ad[0].dc].f[mw.w.Ad[0].dv] := mw.w;
		mw.w.DelVerb(true);
		mw.w.SetMess(0, sta0, 0);
		mw.w.SetMess(0, sta1, 1);
		mw.w.SetMess(0, sta2, 2);
		mw.w.SetMess(0, sta3, 3);

		if vsi.X > 0
		then begin
			if ftvsi = mw.ftab[vsi.X, vsi.Y].FTyp
			then begin
				av_fixsta(vsi, sta0, vsi.tag, sst0);
				av_fixsta(vsi, sta1, vsi.tag, sst1);
				av_fixsta(vsi, sta2, vsi.tag, sst2);
				av_fixsta(vsi, sta3, vsi.tag, sst3);
			end
			else vsi.Clear;
		end;
		if vms.X > 0
		then begin
			if ftvsi = mw.ftab[vms.X, vms.Y].FTyp
			then begin
				av_fixsta(vms, sta0, vms.tag, sst4);
				av_fixsta(vms, sta1, vms.tag, sst5);
				av_fixsta(vms, sta2, vms.tag, sst5);
				av_fixsta(vms, sta3, vms.tag, sst5);
			end
			else vms.Clear;
		end;
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then begin
			if swi.Checked
			then showdtab(ptout, 0)
			else showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		end;
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfHsi.draw(fld: tmbs_fld);
const
	ron: TRect = (	left: 2; 			Top: 2;
						Right: gr2 - 1; 	bottom: gr2 - 1);
	run: TRect = (	left: 2; 			Top: gr2 - 1;
						Right: gr2 - 1; 	bottom: gr - 4);
	roo: TRect = (	left: gr2 + 2; 	Top: 2;
						Right: gr - 1; 	bottom: gr2 - 1);
	ruo: TRect = (	left: 4; 			Top: 2;
						Right: gr2 + 1; 	bottom: gr2 - 1);
	ros: TRect = (	left: gr2 + 3; 	Top: gr2 + 1;
						Right: gr; 			bottom: gr - 1);
	rus: TRect = (	left: gr2 + 3; 	Top: 4;
						Right: gr; 			bottom: gr2 + 1);
	row: TRect = (	left: 1; 			Top: gr2 + 3;
						Right: gr2 - 1; 	bottom: gr);
	ruw: TRect = (	left: gr2 - 1 ; 	Top: gr2 + 3;
						Right: gr - 4; 	bottom: gr);
var
	ro,
	ru:		TRect;
	co,
	cu:		TColor;
begin
	with mw.bm.Canvas
	do begin
		if con and fld.isol > 0
		then begin
			ro := ron;
			ru := run;
		end;
		if coo and fld.isol > 0
		then begin
			ro := roo;
			ru := ruo;
		end;
		if cos and fld.isol > 0
		then begin
			ro := ros;
			ru := rus;
		end;
		if cow and fld.isol > 0
		then begin
			ro := roW;
			ru := ruW;
		end;
		pen.Width := 2;
		pen.Color := clblack;
		case fld.stat of
		sta0:	begin	co := pen.Color;	cu := clred;		end;
		sta1:	begin	co := cllime;		cu := pen.Color;	end;
		sta2: begin co := cllime;  	cu := cllime;		end;
		sta3: begin	co := cllime;		cu := clyellow;	end;
		end;
		brush.Color := co;
		rectangle(ro);
		brush.Color := cu;
		rectangle(ru);
		if (fld.Isol > 0)
		then begin
			Pen.Color := clwhite;
			fld.drawconn(fld.Isol, 3, 2);
		end;
	end;
end;

// statusnderung
procedure TfHsi.SetStat(fld: tmbs_fld; stat: tsta);
begin
	case stat of
	belp:
		begin
			inc(fld.Z.Blgt);
			fld.Paint(0);
			exit;
		end;
	belm:
		begin
			if fld.Blgt > 0
			then dec(fld.Z.Blgt)
			else exit;
			fld.Paint(0);
			if (fld.Blgt = 0)
			and (fld.Zugw > 0)
			then fld.Stat := sta1;
			exit;
		end;
	end;
	fld.setstatcom(stat);
	case fld.stat of
	sta7:
		begin
			fld.Z.Blgt := 0;
			fld.stat := sta0;
		end;
	end;
	fld.Paint(0);
end;

// statusnderung durch Click
procedure TfHsi.ChngStat;
var
	p:			TPoint;
begin
	pmrot.Enabled := mw.run;
	pmgrn.Enabled := mw.run;
	pmg40.Enabled := mw.run and (mw.w.stan > 2);
	pmg60.Enabled := mw.run and (mw.w.stan > 3);
	if mw.w.stan > 2
	then pmg60.Visible := true;
	if mw.w.stan > 3
	then pmg40.Visible := true;
	pmbel.Enabled := mw.test;
	pmfre.Enabled := mw.test;
	if mw.w.X < mw.trenn
	then begin
		p.x := mw.w.X * gr;
		p.y := mw.w.Y * gr;
		p := mw.i1.ClientToScreen(p);
	end
	else begin
		p.x := (mw.w.X - mw.trenn + 1) * gr;
		p.y := mw.w.Y * gr;
		p := mw.i2.ClientToScreen(p);
	end;
	pm.Popup(p.x, p.y);
end;

// statustabelle versorgen
procedure TfHsi.SetStab(fld: tmbs_fld);
begin
end;

procedure TfHsi.pmrotClick(Sender: TObject);
begin
	mw.w.Stat := sta0;		// rot
end;

procedure TfHsi.pmgrnClick(Sender: TObject);
begin
	mw.w.Stat := sta1;		// grn
end;

procedure TfHsi.pmg40Click(Sender: TObject);
begin
	mw.w.Stat := sta3;		// grn 40
end;

procedure TfHsi.pmg60Click(Sender: TObject);
begin
	mw.w.Stat := sta2;		// grn 60
end;

procedure TfHsi.pmbelClick(Sender: TObject);
begin
	mw.w.Stat := belp;
end;

procedure TfHsi.pmfreClick(Sender: TObject);
begin
	mw.w.Stat := belm;
end;

end.
 