unit mbs_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Menus, StdCtrls, ExtCtrls,
	CPort, ComCtrls, registry,
	mbs_fld, ImgList, ScktComp, AppEvnts, mbs_prt, inifiles;

const
	staone = $10;
	staofe = $00;
	devpa1 = $40;
	devpa2 = $50;
	devpa3 = $60;
	devpa4 = $70;

type
	Tmbs_f =
	class(TForm)
		mm: TMainMenu;
		im: TImage;
		od: TOpenDialog;
		sd: TSaveDialog;
		neu1: TMenuItem;
		load1: TMenuItem;
		save1: TMenuItem;
		saveas1: TMenuItem;
		N1: TMenuItem;
		Drucken1: TMenuItem;
		Anlage1: TMenuItem;
		ansehen1: TMenuItem;
		N2: TMenuItem;
		beenden1: TMenuItem;
		N3: TMenuItem;
		MPorts1: TMenuItem;
		PortA1: TMenuItem;
		PortB1: TMenuItem;
		PortC1: TMenuItem;
		PortD1: TMenuItem;
		System1: TMenuItem;
		Reset1: TMenuItem;
		Start1: TMenuItem;
		SendDecn1: TMenuItem;
		Schleifentest1: TMenuItem;
		Hilfe1: TMenuItem;
		monitor1: TMenuItem;
		about1: TMenuItem;
		N5: TMenuItem;
		Mode1: TMenuItem;
		fahren1: TMenuItem;
		bearbeiten1: TMenuItem;
		verbinden1: TMenuItem;
		Wegeverlegen1: TMenuItem;
		Anlagendern1: TMenuItem;
		Uhr1: TMenuItem;
		Ext1: TMenuItem;
		N6: TMenuItem;
		N4: TMenuItem;
		SendParam1: TMenuItem;
    	genEAGLE1: TMenuItem;
		procedure about1Click(Sender: TObject);
		procedure beenden1Click(Sender: TObject);
		procedure FormActivate(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure imMouseDown(Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
		procedure FormClose(Sender: TObject;
			var Action: TCloseAction);
		procedure load1Click(Sender: TObject);
		procedure save1Click(Sender: TObject);
		procedure imMouseMove(Sender: TObject;
			Shift: TShiftState;
			X, Y: Integer);
		procedure PortClick(Sender: TObject);
		procedure System1Click(Sender: TObject);
		procedure modeClick(Sender: TObject);
		procedure neu1Click(Sender: TObject);
		procedure saveas1Click(Sender: TObject);
		procedure Anlage1Click(Sender: TObject);
		procedure imMouseUp(Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
		procedure monitor1Click(Sender: TObject);
		procedure Ext1Click(Sender: TObject);
		procedure Uhr1Click(Sender: TObject);
		procedure Reset1Click(Sender: TObject);
		procedure SendDecn1Click(Sender: TObject);
		procedure Schleifentest1Click(Sender: TObject);
		procedure SendParam1Click(Sender: TObject);
		procedure RxMsg(
			Sender: TObject;
			msg: tmsg);
//    	procedure genEAGLE1Click(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		pt: array [0..4] of Tmbs_prt;
	end;

var
	mbs_f: 		Tmbs_f;
	mw:			tmbswork;
	aposx,
	aposy:		byte;
	scres,
	scsta,
	scdec,
	sctst: array [1..4] of boolean;
	anlage,
	anldec:	string;

implementation

uses mbs_ver_u, mbs_bea_u, ape_u, mbs_mon_u,
		mbs_ext_u, mbs_uhr_u;

{$R *.DFM}

procedure Tmbs_f.about1Click(Sender: TObject);
begin
	ape_f.ShowModal;
end;

procedure Tmbs_f.beenden1Click(Sender: TObject);
begin
	close;
end;

procedure Tmbs_f.FormActivate(Sender: TObject);
var
	i:			integer;
begin
	if ape_f.Tag > 0
	then exit;
	for i := 0 to 4
	do begin
		pt[i].OnMon := mbs_mon_f.Add;
//		pt[i].Monitor := mbs_mon_f.mon;
	end;
	chdir(extractfilepath(paramstr(0)));
	ape_f.Ports(false, porta1, portclick);
	ape_f.Ports(false, portb1, portclick);
	ape_f.Ports(false, portc1, portclick);
	ape_f.Ports(true, portd1, portclick);

	ape_f.rform;
 //	ape_f.form := nil; //self;
	mw.test := ape_f.RdB('Testbetrieb', false);
	mw.pri := ape_f.rdI('Printer', 0);
	mw.zmor := ape_f.RdI('Morgen', 5 * 60);
	mw.ztag := ape_f.RdI('Tag', 6 * 60);
	mw.zabe := ape_f.RdI('Abend', 18 * 60);
	mw.znch := ape_f.RdI('Nacht', 22 * 60);
	mbs_uhr_f.kti.Tag := ape_f.RdI('Beginn', 350);
	mbs_uhr_f.uhr.Caption := format('%2d:%2.2d',
				[mbs_uhr_f.kti.tag div 60,
				 mbs_uhr_f.kti.tag mod 60]);
	mw.min := ape_f.RdI('Minute', 10);
	mw.kmin := ape_f.RdI('Takt', 500);
	mbs_uhr_u.mtim := mw.min * 1000 div mw.kmin;

	fahren1.checked := true;
	mw.mode := 0;
	anlage := ape_f.rds('\Anlage', '');
	anldec := anlage + 'A-Decoder\ass\';
	if fileexists(od.filename)
	then begin
		mbs_uhr_f.anlage_l(od.filename);
		sd.FileName := od.FileName;
		sd.Tag := 1;
	end
	else begin
		od.InitialDir := anlage;
		if od.Execute
		then begin
			mbs_uhr_f.anlage_l(od.filename);
			sd.FileName := od.FileName;
			sd.Tag := 1;
		end;
		if extractfilepath(od.FileName) <> anlage
		then ape_f.wrs('\Anlage', extractfilepath(od.FileName));
	end;
	mw.mmon := monitor1;
	mw.muhr := uhr1;
	mw.mext := ext1;
	senddecn1.Click;

	if mw.ftabx > mw.trenn
	then begin
		mbs_ext_f.show;
		mbs_f.Ext1.Checked := true;
	end
	else begin
		mbs_ext_f.Hide;
		mbs_f.Ext1.Checked := false;
	end;
	mbs_uhr_f.Show;
	mbs_f.Uhr1.Checked := true;
	ape_f.tag := 1;
end;

procedure Tmbs_f.FormCreate(Sender: TObject);
var
	i:  		integer;
begin
	inherited;

	mw.trenn := 255;
	mw.i1 := im;
	mw.mo1 := mode1;
	application.tag := longint(addr(mw));
	application.name := 'pi_MBS';
	mw.typlst := tstringlist.Create;
	for i := 0 to high(sftab)
	do begin
		mw.typlst.Add(sftab[i]);
	end;
	for i := 0 to 4
	do begin
		pt[i] := tmbs_prt.Create(self);
		pt[i].Porttyp := ptdec;
		pt[i].PortKurz := char(ord('@') + i);
		if i< 5
		then pt[i].CustomBaudRate := 19200
		else pt[i].CustomBaudRate := 20833;
	end;
	autosize := true;
end;

procedure Tmbs_f.imMouseDown(
					Sender: TObject;
					Button: TMouseButton;
					Shift: TShiftState;
					X, Y: Integer);
begin
	mw.ftab[x div gr + 1, y div gr + 1].mousedown(
						timage(sender), button);
	mbs_uhr_f.putinf(mw.ftab[x div gr + 1, y div gr + 1]);
end;

procedure Tmbs_f.FormClose(
					Sender: TObject;
					var Action: TCloseAction);
var
	i: integer;
begin
	fahren1.Click;
	save1click(self);
	for i := 1 to 4
	do begin
		if pt[i].Port > ''
		then begin
			pt[i].Port := '';
		end;
	end;
	ape_f.SForm;
	ape_f.wrB('Testbetrieb', mw.test);
	ape_f.wrI('Reihen', mw.ftaby);
	ape_f.wrI('Spalten', mw.ftabx);
	ape_f.wrI('Trennung', mw.trenn);
	ape_f.wrI('Printer', mw.pri);
	ape_f.WrI('Morgen', mw.zmor);
	ape_f.WrI('Tag', mw.ztag);
	ape_f.WrI('Abend', mw.zabe);
	ape_f.WrI('Nacht', mw.znch);
	ape_f.WrI('Minute', mw.min);
	ape_f.WrI('Beginn', mbs_uhr_f.kti.Tag);
end;

procedure Tmbs_f.load1Click(Sender: TObject);
begin
	if od.Execute
	then begin
		if extractfileext(od.FileName) > '.mba'
		then showmessage(od.FileName + ' wird nicht automatisch gespeichert');
		mbs_uhr_f.anlage_l(od.FileName);
		sd.InitialDir := od.InitialDir;
		sd.FileName := od.FileName;
		sd.tag := 1;
	end;
end;

procedure Tmbs_f.save1Click(Sender: TObject);
begin
	case sd.Tag of
	1: mbs_uhr_f.anlage_s(sd.FileName);
	2: saveas1click(self);
	end;
end;

procedure Tmbs_f.imMouseMove(Sender: TObject;
				Shift: TShiftState;
				X, Y: Integer);
begin
	if (x div gr + 1 = aposx)
	and (y div gr + 1 = aposy)
	then exit;
	aposx := x div gr + 1;
	aposy := y div gr + 1;
	mbs_uhr_f.putinf(mw.ftab[aposx, aposy]);
end;

procedure Tmbs_f.modeClick(Sender: TObject);
begin
	mbs_uhr_f.Modechange(tmenuitem(sender).tag);
end;

procedure Tmbs_f.neu1Click(Sender: TObject);
begin
	mbs_uhr_f.anlage_n;
	application.MainForm.Caption := 'untitled';
	save1.tag := 2;
end;

procedure Tmbs_f.saveas1Click(Sender: TObject);
begin
	if sd.Execute
	then begin
		mbs_uhr_f.anlage_s(sd.FileName);
		od.FileName := sd.FileName;
		sd.Tag := 1;
	end;
end;

procedure Tmbs_f.Anlage1Click(Sender: TObject);
begin
	mbs_uhr_f.druck;
end;

procedure Tmbs_f.imMouseUp(
					Sender: TObject;
					Button: TMouseButton;
					Shift: TShiftState;
					X, Y: Integer);
begin
	mw.ftab[x div gr + 1, y div gr + 1].mouseup;
end;

procedure tmbs_f.PortClick(Sender: TObject);
var
	i:			integer;
	mi:		tmenuitem;
begin
	mi := tmenuitem(Sender);
	i := mi.Parent.MenuIndex + 1;
	pt[i].Close;
	pt[i].OnMsg := nil;
	pt[i].Port := '';
	mi.Parent.Checked := false;
	mi.Parent.Items[0].Checked := true;
	mi.Checked := true;
	if mi.MenuIndex > 0
	then begin
		pt[i].Port := mi.Caption;
		if pt[i].Open
		then begin
//			pt[i].Monitor := mbs_mon_f.mon;
			pt[i].OnMsg := rxmsg;
			mi.Checked := true;
			mi.Parent.Checked := true;
		end;
	end;
end;

procedure Tmbs_f.Ext1Click(Sender: TObject);
begin
	if ape_f.Tag = 0
	then exit;
	ext1.Checked := ext1.Checked xor true;
	if ext1.Checked
	then begin
		if mw.ftabx > mw.trenn
		then begin
			mbs_ext_f.Show;
		end
		else begin
			ext1.Checked := false;
		end;
	end
	else mbs_ext_f.Hide;
end;

procedure Tmbs_f.monitor1Click(Sender: TObject);
begin
	if ape_f.Tag = 0
	then exit;
	monitor1.Checked := monitor1.Checked xor true;
	mbs_ext_f.monitor1.Checked := monitor1.Checked;
	if monitor1.Checked
	then mbs_mon_f.show
	else mbs_mon_f.hide;
end;

procedure Tmbs_f.Uhr1Click(Sender: TObject);
begin
	if ape_f.Tag = 0
	then exit;
	uhr1.Checked := uhr1.Checked xor true;
	if uhr1.Checked
	then mbs_uhr_f.show
	else mbs_uhr_f.hide;
end;

procedure Tmbs_f.System1Click(Sender: TObject);
var
	i:			integer;
begin
	if mbs_mon_f.systim.Enabled
	then exit;
	sendparam1click(self);
	for i := 0 to mports1.Count - 1
	do begin
		if mports1.Items[i].Checked
		then begin
			pt[i + 1].SendCom(0, 2, 0);
			scsta[i + 1] := true;
		end;
	end;
	mw.run := true;
	mbs_mon_f.systim.Enabled := true;
end;

procedure Tmbs_f.Reset1Click(Sender: TObject);
var
	i:			integer;
begin
	if mbs_mon_f.systim.Enabled
	then exit;
	for i := 0 to mports1.Count - 1
	do begin
		if mports1.Items[i].Checked
		then begin
			mw.run := false;
			pt[i + 1].SendCom(0, 1, 0);
			scres[i + 1] := true;
		end;
	end;
	mbs_mon_f.systim.Enabled := true;
end;

procedure Tmbs_f.SendDecn1Click(Sender: TObject);
var
	i:			integer;
begin
	if mbs_mon_f.systim.Enabled
	then exit;
	for i := 1 to 127
	do begin
		mw.dtab[i].c := 0;
		mw.dtab[i].a := false;
	end;
	for i := 0 to mports1.Count - 1
	do begin
		if mports1.Items[i].Checked
		then begin
			pt[i + 1].SendCom(0, 8, 0);
			scdec[i + 1] := true;
		end;
	end;
	mbs_mon_f.systim.Enabled := true;
end;

procedure Tmbs_f.Schleifentest1Click(Sender: TObject);
var
	i:			integer;
begin
	if mbs_mon_f.systim.Enabled
	then exit;
	for i := 0 to mports1.Count - 1
	do begin
		if mports1.Items[i].Checked
		then begin
			pt[i + 1].SendCom(0, 15, 0);
			sctst[i + 1] := true;
		end;
	end;
	mbs_mon_f.systim.Enabled := true;
end;

procedure Tmbs_f.SendParam1Click(Sender: TObject);
var
	i,
	x,
	y:			integer;
begin
	for i := 0 to mports1.Count - 1
	do begin
		mbs_mon_f.systim.Tag := mbs_mon_f.systim.Tag shl 8;
	end;
	for x := low(mw.ftab) to mw.ftabx
	do begin
		for y := low(mw.ftab[1]) to mw.ftaby
		do begin
//**			if mw.ftab[x, y].Ad[0].po > 0
			if mw.ftab[x, y].Ad[0].dv > 0
			then begin
				case mw.ftab[x, y].PTyp of
				ptsrv:
					begin
						mw.ftab[x, y].putpar;
						mw.ftab[x, y].putcom;
					end;
				ptout:
					begin
						mw.ftab[x, y].putpar;
						mw.ftab[x, y].putcom;
					end;
				end;
				mw.ftab[x, y].Stat := sta0;
			end;
		end;
	end;
end;

procedure Tmbs_f.RxMsg(
	Sender: TObject;
	msg: tmsg);
var
	f:			tmbs_fld;
begin
	with mbs_mon_f
	do begin
		// verarb
		if msg.dc > 0 					// decoder
		then begin
			if msg.dv < 14 			// device meldet
			then begin
				if mw.dtab[msg.dc].a	// dec aktiv
				then begin
					if (mw.dtab[msg.dc].f[msg.dv] <> nil)
											// feld zugewiesen
					and mw.run
					then begin
						f := mw.dtab[msg.dc].f[msg.dv];
						if f.PTyp = ptinp
						then f.Stat := tsta(msg.dt and 1)
						else f.nextstat;
					end;
					add(self, format('>%s %3d %2d %s',
							[iprt[msg.pt], msg.dc,
							 msg.dv, stxt[msg.dt]]));
				end;
			end
			else begin           	// decoder meldet sich
				mw.dtab[msg.dc].a := true;		// dec aktiv
				mw.dtab[msg.dc].c := msg.pt;	// dec port
				// devicenamen aus dec-###.ini


				if mw.dtab[msg.dc].s = ''
				then mw.dtab[msg.dc].s := inttostr(msg.dc);
				add(self, format('>%s %3d %s',
						[iprt[msg.pt], msg.dc,
						 dtxt[msg.dt]]));
				scdec[msg.pt] := false;
			end;
		end
		else begin						// syscmd
			case msg.dv of
			1:		// reset
				begin
					scres[msg.pt] := false;
				end;
			2:
				begin
					scsta[msg.pt] := false;
				end;
			8:
				begin
					scdec[msg.pt] := false;
				end;
			15:
				begin
					sctst[msg.pt] := false;
				end;
			else
				begin
				end;
			end;
			add(self, format('>%s sys %s',
					[iprt[msg.pt], atxt[msg.dv]]));
		end;
	end;
end;

{
procedure Tmbs_f.genEAGLE1Click(Sender: TObject);
var
	dc,
	dv: integer;
	n1,
	n2,
	s: string;
	fini: tinifile;
	finidec,
	finidev,
	finityp: string;
	finiw: byte;
const
	fk = '%d.%d';
	fp = ';%s:%d';

	function finisrc(dec: word; dev: byte): boolean;
	begin
		finityp := '';
		result := true;
		finidec := format('Decoder%3.3d', [dec]);
		if not fini.SectionExists(finidec)
		then begin
			result := false;
			exit;
		end;
		finidev := format('dev%2.2d', [dev]);
		finidev := fini.ReadString(finidec, finidev, '');
		if finidev = ''
		then begin
			result := false;
			exit;
		end;
		finityp := fini.ReadString(finidev, 'typ', '');;
	end;

begin

	fini := tinifile.Create(changefileext(od.FileName, '.ini'));
	for dc := low(mw.dtab) to high(mw.dtab)
	do begin
		w := mw.dtab[dc];
		for dv := 1 to 13
		do begin
			if not finisrc(dc, dv)
			then continue;
			if not assigned(w.f[dv])
			then continue;
			case w.f[dv].pTyp of
			ptamp:
				begin
					fini.WriteInteger(finidev, 'ass', 0);
//					fini.WriteInteger(finidev, 'tim', w.p[dv, 1] and $7f);
					fini.WriteInteger(finidev, 'tim',
							w.f[dv].GetDPar(0, par1));
				end;
			pthsi:
				begin
				end;
			ptsrv:
				begin
					fini.WriteInteger(finidev, 'ass', 0);
					fini.WriteBool(finidev, 'inv',
//							w.f[dv].Ad[0].ms[sta0] and $01);
							(w.f[dv].Ad[0].ms[sta0] and $01) > 0);
					fini.WriteBool(finidev, 'swf',
//							w.p[dv, 0] and $02);
							(w.f[dv].GetDPar(0, par0) and $02) > 0);
					fini.WriteBool(finidev, 'phi',
//							w.p[dv, 0] and $04);
							(w.f[dv].GetDPar(0, par0) and $04) > 0);
					fini.WriteInteger(finidev, 'dif',
//							w.p[dv, 1] and $7f);
							w.f[dv].GetDPar(0, par1));
					fini.WriteInteger(finidev, 'krz',
//							w.p[dv, 2] and $7f);
							w.f[dv].GetDPar(0, par2));
					fini.WriteInteger(finidev, 'lng',
//							w.p[dv, 3] and $7f);
							w.f[dv].GetDPar(0, par3));
				end;
			ptout:
				begin
					fini.WriteInteger(finidev, 'ass', 0);
					fini.WriteInteger(finidev, 'ach', w.p[dv, 0] and $08);
					fini.WriteInteger(finidev, 'non', w.p[dv, 0] and $04);
					fini.WriteInteger(finidev, 'nof', w.p[dv, 0] and $02);
					fini.WriteInteger(finidev, 'ont', w.p[dv, 1] and $7f);
					fini.WriteInteger(finidev, 'oft', w.p[dv, 2] and $7f);
					fini.WriteInteger(finidev, 'ndv', w.p[dv, 3] and $7f);
				end;
			ptinp:
				begin
				end;
			ptvsi:
				begin
				end;
			end;
		end;
	end;
	fini.Free;
end;
}

end.
