unit mbs_ver_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
	mbs_fld, ComCtrls;

type
	Tmbs_ver_f =
	class(TForm)
		rg1: TRadioGroup;
		avloe: TButton;
		Label1: TLabel;
		lbsta: TLabel;
		tv: TTreeView;
		procedure FormCreate(Sender: TObject);
		procedure FormHide(Sender: TObject);
		procedure FormClose(
							Sender: TObject;
							var Action: TCloseAction);
		procedure FormDestroy(Sender: TObject);
		procedure FormActivate(Sender: TObject);
		procedure avloeClick(Sender: TObject);
		procedure vloeClick(Sender: TObject);
		procedure tvClick(Sender: TObject);
		procedure tvChange(
							Sender: TObject;
							Node: TTreeNode);
		procedure tvChanging(
							Sender: TObject; Node: TTreeNode;
							var AllowChange: Boolean);
    procedure rg1Click(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure showtv;
		procedure SetFeld(nf: Tmbs_fld);
		procedure verMousedown(f: Tmbs_fld;
								b: tmousebutton);
	end;

var
	mbs_ver_f:	Tmbs_ver_f;

implementation

uses mbs_u, ape_u, mbs_uhr_u;

{$R *.DFM}

var
	mw:			ptmbswork;

procedure Tmbs_ver_f.FormCreate(Sender: TObject);
begin
	inherited;
	mw := ptmbswork(Application.tag);
end;

procedure Tmbs_ver_f.SetFeld(nf: Tmbs_fld);
begin
	if assigned(mw)
	and assigned(mw.w)
	then begin
//		showtv;
		mw.w.Paint(0);
	end;
	mw.w := nf;
//	lb.Clear;
//	mw.w.ShwVerb(lb);
	lbsta.tag := integer(mw.w.Stat);
	lbsta.Caption := inttostr(lbsta.tag);
	mbs_ver_f.caption := format('%s(%d %d):%d',
					[sftab[integer(mw.w.ftyp)],mw.w.x, mw.w.y, mw.w.zugn]);
	mw.w.Paint(1);
	showtv;
end;

procedure Tmbs_ver_f.FormHide(Sender: TObject);
begin
	showtv;
	mw.w.Paint(0);
end;

procedure Tmbs_ver_f.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Hide;
	mbs_uhr_f.Modechange(0);
end;

procedure Tmbs_ver_f.FormDestroy(Sender: TObject);
begin
	hide;
	inherited;
end;

procedure Tmbs_ver_f.FormActivate(Sender: TObject);
begin
	if tag = 0
	then begin
		tag := 1;
	end;
end;

procedure Tmbs_ver_f.avloeClick(Sender: TObject);
begin
	showtv;
	mw.w.DelVerb(false);
	mw.w.DelVerb(true);
//	mw.w.ShwVerb(lb);
end;

procedure Tmbs_ver_f.vloeClick(Sender: TObject);
//var
//	vv:		Tmbs_vrb;
begin
{	if lb.ItemIndex > -1
	then begin
//		mw.w.getverb(vv, byte(lb.Items.Objects[lb.ItemIndex]));
		mw.w.DelVerb(vv);
	end;
}end;

procedure Tmbs_ver_f.tvClick(Sender: TObject);
begin
	if mw.w.FTyp = ftNon
	then exit;
{	if tv.Selected = false
	then begin
		mw.v := nil;
	end
	else begin
		if assigned(mw.v)
		then mw.v.paint(0);
//		i := byte(lb.Items.Objects[lb.ItemIndex]);
//		mw.w.getverb(v, i);
		mw.v := mw.ftab[v.x, v.y];

//		vermv.Checked := (s and $10) = 0;
		mw.w.Stat := tsta(v.sst);
		lbsta.tag := integer(mw.w.Stat);
		lbsta.Caption := inttostr(lbsta.tag);
		mw.v.paint(2);
		mw.w.paint(1);
	end;
}end;

procedure Tmbs_ver_f.verMousedown(f: Tmbs_fld;
					b: tmousebutton);
var
	vv:		Tmbs_vrb;
begin
	vv.fix := 0;
	vv.zug := 0;
	vv.rpz := 0;
	vv.dyn := false;
	if b = mbleft
	then begin
		if assigned(mw.w)
		then begin
			mw.w.FstVerb;
			while mw.w.GetVerb(vv)
			do mw.ftab[vv.x, vv.y].Paint(0);
		end;
		if mw.w = f
		then begin
			mw.w.NextStat;
			showtv;
			mw.w.Paint(1);
			lbsta.tag := integer(mw.w.Stat);
			lbsta.Caption := inttostr(lbsta.tag);
		end
		else begin
			mbs_ver_f.SetFeld(f);
			mw.v := nil;
		end;
	end;
	if b = mbmiddle
	then begin
		mw.v := f;
		vv.x := mw.v.x;
		vv.y := mw.v.y;
		vv.wst := mw.w.Stat;
		vv.sst := tsst(mw.v.Stat);
		mw.w.DelVerb(vv);
//		mw.w.ShwVerb(lb);
		showtv;
		mw.v.paint(0);
		mw.v := nil;
	end;
	if b = mbright
	then begin
		if mw.v = f
		then mw.v.NextStat
		else mw.v := f;
		if mw.v <> mw.w
		then begin
			vv.x := mw.v.x;
			vv.y := mw.v.y;
			vv.wst := mw.w.Stat;
			case rg1.ItemIndex of
			0:	vv.sst := tsst(mw.v.Stat);
			1: if mw.w.Stat = sta0
				then vv.sst := tsst(sta4)
				else vv.sst := tsst(sta5);
			2:	vv.sst := sblp;
			3:	vv.sst := sblm;
			4:	vv.sst := tsst(mw.v.Stat);
			end;
			mw.w.AddVerb(vv);
	//		mw.w.ShwVerb(lb);
			showtv;
			mw.v.paint(2);
		end;
	end;
	mw.w.paint(1);
	mbs_ver_f.Show;
	mbs_ver_f.BringToFront;
//	mbs_uhr_f.putinf(mw.w);
end;

procedure Tmbs_ver_f.showtv;
var
	i:			byte;
	vv:		Tmbs_vrb;
	p:			array [0..7] of ttreenode;
	d,
	e:			ttreenode;
	s:			string;
begin
	if assigned(tv.selected)
	then tv.Selected.Selected := false;
	tv.Items.Clear;
	if not assigned(mw)
	then exit;
	tv.Items.BeginUpdate;
	for i := 0 to 7
	do begin
		p[i] := tv.Items.Add(nil, 'Status ' + inttostr(i));
		p[i].Data := pointer(i);
		p[i].ImageIndex := -1;
		p[i].StateIndex := -1;
		p[i].SelectedIndex := -1;
	end;
	e := nil;
	mw.w.FstVerb;
	while mw.w.GetVerbStr(vv, s, i)
	do begin
		// verbindung
		if vv.fix = 0
		then begin
			p[byte(vv.wst)].ImageIndex := -1;
			p[byte(vv.wst)].StateIndex := -1;
			d := tv.Items.AddChild(p[byte(vv.wst)], s);
			d.Data := pointer(i);
			d.ImageIndex := -1;
			if assigned(mw.v)
			and (vv.x = mw.v.X)
			and (vv.y = mw.v.Y)
			and (vv.wst = mw.w.Stat)
			then begin
				e := d;
			end;
		end;
	end;
	if assigned(e)
	then e.Selected := true;
	p[byte(mw.w.Stat)].Expand(true);
//	caption := inttostr(byte(mw.w.Stat));
	tv.Items.EndUpdate;
end;

procedure Tmbs_ver_f.tvChange(
			Sender: TObject;
			Node: TTreeNode);
var
	v:			Tmbs_vrb;
begin
	if not assigned(node)
	then exit;
//	if not node.Selected
//	then exit;
	if node.Level = 0
	then begin
		lbsta.Tag := byte(node.Data);
		lbsta.Caption := inttostr(lbsta.tag);
		mw.w.Stat := tsta(node.Data);
		mw.w.paint(1);
		tv.FullCollapse;
		node.Expand(true);
		// alle verb / stat anzeigen
	end;
	if node.Level = 1
	then begin
		mw.w.Stat := tsta(node.Parent.Data);
		mw.w.getverb(v, byte(node.Data));
		mw.v := mw.ftab[v.x, v.y];
		// alle verb nicht anzeigen
		mw.v.Stat := tsta(v.sst);
		mw.v.paint(2);
		mw.w.paint(1);
	end;
end;

procedure Tmbs_ver_f.tvChanging(
			Sender: TObject;
			Node: TTreeNode;
			var AllowChange: Boolean);
var
	v:		tmbs_vrb;
begin
	// alle verb nicht anzeigen
	mw.w.FstVerb;
	while mw.w.GetVerb(v)
	do mw.v.paint(0);
	mw.w.paint(1);
end;

procedure Tmbs_ver_f.rg1Click(Sender: TObject);
var
	vv:		Tmbs_vrb;
begin
	if not assigned(tv.Selected)
	or (tv.Selected.Level = 0)
	then exit;
	mw.w.GetVerb(vv, byte(tv.selected.data));
	case rg1.ItemIndex of
	0:	vv.sst := tsst(mw.v.Stat);
	1:	vv.sst := sblp;
	2:	vv.sst := sblm;
//	3:	vv.sst := stim;
	end;
	mw.w.AddVerb(vv);
	showtv;
	mw.v.paint(2);
end;

end.

