unit mbs_vsi;

interface

uses	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, Menus, StdCtrls, ExtCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, mbs_epd;

type
	TfVsi =
	class(TForm)
		N1: TMenuItem;
		pma: TMenuItem;
		pm: TPopupMenu;
		pmrot: TMenuItem;
		pmg40: TMenuItem;
		pmg60: TMenuItem;
		pmgrn: TMenuItem;
		N2: TMenuItem;
		pmbel: TMenuItem;
		pmfre: TMenuItem;
		par: TGroupBox;
		Label13: TLabel;
		vsi: Tmbs_led;
		vsm: Tmbs_led;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure ChngStat;
		procedure draw(fld: tmbs_fld);
	end;

var
	fVsi: 		TfVsi;

implementation

uses mbs_bea_u;

{$R *.DFM}

procedure TfVsi.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfVsi.GetPar;
begin
	with mbs_bea_f
	do begin
		par.Tag := 1;
		mw.w.PTyp := ptvsi;
		vsi.Adr := mw.w.Ad[0];
		vsm.Adr := mw.w.Ad[1];
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := true;
		st3.Visible := true;
		st4.Visible := true;
		st5.Visible := true;
		st6.Visible := true;
		st7.Visible := true;
		par.Tag := 0;
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfVsi.setpar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Stan := 8;
		mw.w.Ad[0] := vsi.Adr;
		mw.w.Ad[1] := vsm.Adr;
		mw.dtab[mw.w.Ad[0].dc].f[mw.w.Ad[0].dv] := mw.w;
		mw.dtab[mw.w.Ad[1].dc].f[mw.w.Ad[1].dv] := mw.w;
		mw.w.DelVerb(true);
		mw.w.SetMess(0, sta0, 0);
		mw.w.SetMess(0, sta1, 1);
		mw.w.SetMess(0, sta2, 2);
		mw.w.SetMess(0, sta3, 3);
		mw.w.SetMess(1, sta4, 1);
		mw.w.SetMess(1, sta5, 0);
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfVsi.draw(fld: tmbs_fld);
const
	ron: TRect = (	left: 2; 			Top: 2;
						Right: gr2 - 1; 	bottom: gr2 - 1);
	run: TRect = (	left: 2; 			Top: gr2 - 1;
						Right: gr2 - 1; 	bottom: gr - 4);
	roo: TRect = (	left: gr2 + 2; 	Top: 2;
						Right: gr - 1; 	bottom: gr2 - 1);
	ruo: TRect = (	left: 4; 			Top: 2;
						Right: gr2 + 1; 	bottom: gr2 - 1);
	ros: TRect = (	left: gr2 + 3; 	Top: gr2 + 1;
						Right: gr; 			bottom: gr - 1);
	rus: TRect = (	left: gr2 + 3; 	Top: 4;
						Right: gr; 			bottom: gr2 + 1);
	row: TRect = (	left: 1; 			Top: gr2 + 3;
						Right: gr2 - 1; 	bottom: gr);
	ruw: TRect = (	left: gr2 - 1 ; 	Top: gr2 + 3;
						Right: gr - 4; 	bottom: gr);
var
	ro,
	ru:		TRect;
	co,
	cu:		TColor;
begin
	with mw.bm.Canvas
	do begin
		if con and fld.isol > 0
		then begin
			ro := ron;
			ru := run;
		end;
		if coo and fld.isol > 0
		then begin
			ro := roo;
			ru := ruo;
		end;
		if cos and fld.isol > 0
		then begin
			ro := ros;
			ru := rus;
		end;
		if cow and fld.isol > 0
		then begin
			ro := roW;
			ru := ruW;
		end;
		pen.Width := 2;
		pen.Color := clgray;
		case fld.stat of
		sta0:	begin	co := clyellow;	cu := clyellow;	end;
		sta1:	begin	co := cllime;		cu := cllime;		end;
		sta2: begin	co := clyellow;	cu := cllime;  	end;
		sta3: begin co := cllime;  	cu := clyellow		end;
		end;  
		brush.Color := co;
		rectangle(ro);
		brush.Color := cu;
		rectangle(ru);
	end;
end;

// statusnderung
procedure TfVsi.SetStat(fld: tmbs_fld; stat: tsta);
var
	zsta:		tsta;
begin
	case stat of
	belp:
		begin
			inc(fld.Z.Blgt);
			fld.Paint(0);
			exit;
		end;
	belm:
		begin
			if fld.Blgt > 0
			then dec(fld.Z.Blgt)
			else exit;
			fld.Paint(0);
			if (fld.Blgt = 0)
			and (fld.Zugw > 0)
			then fld.Stat := sta1;
			exit;
		end;
	end;
	zsta := fld.Stat;
	if (zsta = sta4)
	and (stat < sta4)
	then begin
		fld.SetIPar(par3, byte(stat));
	end
	else begin
		case stat of
		sta4:
			begin
				fld.SetIPar(par3, byte(zsta));
				fld.setstatcom(stat);
			end;
		sta5:
			begin
				fld.setstatcom(tsta(fld.GetIpar(par3)));
			end;
		else
			begin
				fld.setstatcom(stat);
			end;
		end;
		fld.Paint(0);
	end;
end;

// statusnderung durch Click
procedure TfVsi.ChngStat;
begin
end;

// statustabelle versorgen
procedure TfVsi.SetStab(fld: tmbs_fld);
begin
	fld.stan := 4;
end;

end.

