unit mbs_weg_u;

interface

uses
  	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls, Buttons,
	mbs_fld;

type
	Tmbs_weg_f =
	class(TForm)
		Label22: TLabel;
		rb0: 			TRadioButton;
		rb1: 			TRadioButton;
		rb2: 			TRadioButton;
		rb3: 			TRadioButton;
		rb4: 			TRadioButton;
		nc: 			TBitBtn;
		noc: 			TBitBtn;
		soc: 			TBitBtn;
		oc: 			TBitBtn;
		wc: 			TBitBtn;
		nwc: 			TBitBtn;
		sc: 			TBitBtn;
		swc: 			TBitBtn;
		fc: 			TBitBtn;
		wegstr: 		TCheckBox;
    rb5: TRadioButton;
		procedure 	FormCreate(Sender: TObject);
		procedure 	rbClick(Sender: TObject);
		procedure 	btClick(Sender: TObject);
		procedure FormKeyPress(Sender: TObject;
						var Key: Char);
		procedure wegstrClick(Sender: TObject);
		procedure FormActivate(Sender: TObject);
		procedure FormClose(Sender: TObject;
						var Action: TCloseAction);
	private		{ Private-Deklarationen }
		procedure Posw(dir: integer);
		procedure Posv(dir: integer);
	public		{ Public-Deklarationen }
		procedure wegMousedown(f: Tmbs_fld;
						b: tmousebutton);
	end;

var
	mbs_weg_f: 	Tmbs_weg_f;
	mw:			ptmbswork;

implementation

uses ape_u, mbs_uhr_u;

{$R *.DFM}

{$i settyp.inc}
procedure Tmbs_weg_f.Posw(dir: integer);
var
	wx,
	wy:		integer;
begin
	if (mw.w.Conn = 0)
	and ((mw.w.FTyp = ftstr) or (mw.w.FTyp = ftstr))
	then mw.w.FTyp := ftNon;
	mw.w.paint(0);
	wx := mw.w.x;
	wy := mw.w.y;
	case dir of
	con:
		if wy > 1 then dec(wy);
	cono:
		begin
			if wx < mw.ftabx then inc(wx);
			if wy > 1 then dec(wy);
		end;
	coo:
		if wx < mw.ftabx then inc(wx);
	coso:
		begin
			if wx < mw.ftabx then inc(wx);
			if wy < mw.ftaby then inc(wy);
		end;
	cos:
		if wy < mw.ftaby then inc(wy);
	cosw:
		begin
			if wx > 1 then dec(wx);
			if wy < mw.ftaby then inc(wy);
		end;
	cow:
		if wx > 1 then dec(wx);
	conw:
		begin
			if wx > 1 then dec(wx);
			if wy > 1 then dec(wy);
		end;
	end;
	mw.w := mw.ftab[wx, wy];
	if mw.w.FTyp = ftnon
	then begin
		if wegstr.Checked
		then mw.w.FTyp := ftgls
		else mw.w.FTyp := ftstr;
	end;
end;

procedure Tmbs_weg_f.Posv(dir: integer);
var
	vx,
	vy:		integer;
begin
	if (mw.v.Conn = 0)
	and ((mw.v.FTyp = ftstr) or (mw.v.FTyp = ftstr))
	then mw.v.FTyp := ftNon;
	mw.v.paint(0);
	vx := mw.v.x;
	vy := mw.v.y;
	case dir of
	con:
		if vy > 1 then dec(vy);
	cono:
		begin
			if vx < mw.ftabx then inc(vx);
			if vy > 1 then dec(vy);
		end;
	coo:
		if vx < mw.ftabx then inc(vx);
	coso:
		begin
			if vx < mw.ftabx then inc(vx);
			if vy < mw.ftaby then inc(vy);
		end;
	cos:
		if vy < mw.ftaby then inc(vy);
	cosw:
		begin
			if vx > 1 then dec(vx);
			if vy < mw.ftaby then inc(vy);
		end;
	cow:
		if vx > 1 then dec(vx);
	conw:
		begin
			if vx > 1 then dec(vx);
			if vy > 1 then dec(vy);
		end;
	end;
	mw.v := mw.ftab[vx, vy];
	if mw.v.FTyp = ftnon
	then begin
		if wegstr.Checked
		then mw.v.FTyp := ftgls
		else mw.v.FTyp := ftstr;
	end;
end;

procedure Tmbs_weg_f.rbClick(Sender: TObject);
begin
	with Sender as TRadiobutton
	do begin
		wegstr.Tag := Tag;
	end;
end;

procedure addconn(o, a: byte);
var
	i,
	b,
	n:			byte;
begin
	if mw.w.Conn and o = 0
	then begin
		mw.w.Conn := mw.w.Conn or o;
		mw.w.Isol := mw.w.Isol and a;
	end
	else mw.w.Conn := mw.w.Conn and a;
	b := mw.w.conn;
	n := 0;
	for i := 0 to 7
	do begin
		if (b and 1) > 0
		then inc(n);
		b := b shr 1;
	end;
	case n of
	0: mw.w.FTyp := ftnon;
	1, 2:
		begin
			if mw.w.FTyp in [fttrn]
			then mw.w.FTyp := ftgls;
			if mw.w.FTyp = ftabz
			then mw.w.FTyp := ftstr;
		end;
	3:
		begin
			if mw.w.FTyp in [ftgls]
			then mw.w.FTyp := fttrn;
			if mw.w.FTyp = ftstr
			then mw.w.FTyp := ftabz;
		end;
	end;
end;

procedure Tmbs_weg_f.btClick(Sender: TObject);
var
	a,
	o:			byte;
	pw,
	pv: 		tpoint;
	i,
	j:			integer;
	x:			tmbs_fld;
begin
	if not assigned(mw)
	then exit;
	if not assigned(mw)
	then exit;
	with sender as TButton
	do begin
		o := Tag;
		a := 255 - o;
		if (mw.w.FTyp = ftnon)
		or (mw.w.FTyp = ftgls)
		or (mw.w.FTyp = ftstr)
		then begin
			if wegstr.Checked
			then mw.w.FTyp := ftgls
			else mw.w.FTyp := ftstr;
		end;
		case wegstr.tag of
		0: addconn(o, a);
		1:	begin
				addconn(o,a);
				settyp(mw.w, wegstr.checked);
				if mw.w.isol > 0
				then begin
					mw.w.ftyp := fthsi;
					mw.w.Stan := 2;
				end;
				posw(tag);
				o := Tag shl 4 or Tag shr 4;
				a := 255 - o;
				addconn(o,a);
				settyp(mw.w, wegstr.checked);
			end;
		2:	begin
				mw.w.Isol := o;
				mw.w.Conn := (o shr 4) or (o shl 4);
			end;
		3: Posw(Tag);
		4: begin
				a := (mw.w.Isol shl 4) or (mw.w.Isol shr 4);
				if o = a
				then mw.w.Isol := mw.w.isol or o
				else mw.w.Isol := o;
			end;
		5: begin
				// mw.w = von		mw.v = nach
				if assigned(mw.w)
				and assigned(mw.v)
				then begin
					pw.x := mw.w.X;
					pw.y := mw.w.Y;
					pv.x := mw.v.x;
					pv.y := mw.v.Y;
					x := tmbs_fld.Create(self);
					x.Copy(mw.w);
					mw.w.copy(mw.v);
					mw.v.Copy(x);
					x.Free;
					x := mw.w;
					for i := 1 to mw.ftabx
					do begin
						for j := 1 to mw.ftaby
						do begin
							if (mw.ftab[i, j].FTyp = ftnon)
							then continue;
							mw.ftab[i, j].CngVerb(pw, pv);
						end;
					end;
					posw(tag);
					posv(tag);
					mw.w.Paint(1);
					mw.v.Paint(2);
				end;
			end;
		end;
		if o = 0
		then begin
			mw.w.Conn := 0;
			mw.w.Isol := 0;
		end;
	end;
	if mw.w.FTyp = ftNon
	then begin
		mw.w.Conn := 0;
		mw.w.Isol := 0;
	end;
//	application.ProcessMessages;
	mw.w.paint(1);
end;

procedure Tmbs_weg_f.FormKeyPress(
					Sender: TObject;
					var Key: Char);
begin
	case key of
	'1', 'j':			swc.Click;
	'2', 'k':			sc.Click;
	'3', 'l':			soc.Click;
	'4', 'u':			wc.Click;
	'5', 'i', ' ':    fc.Click;
	'6', 'o':   		oc.Click;
	'7': 					nwc.Click;
	'8': 					nc.Click;
	'9': 					noc.Click;
	'/':		rb0.Checked := true;
	'*':		rb1.Checked := true;
	'-':		rb2.Checked := true;
	'+':		rb3.Checked := true;
	'.':		rb4.Checked := true;
	end;
	key := #0;
end;

procedure Tmbs_weg_f.wegstrClick(Sender: TObject);
begin
	if wegstr.checked
	then wegstr.Caption := 'Gleis'
	else wegstr.Caption := 'Strasse';
end;      

procedure Tmbs_weg_f.FormCreate(Sender: TObject);
begin
	inherited;
	mw := ptmbswork(application.tag);
end;

procedure Tmbs_weg_f.wegMousedown(
		f: Tmbs_fld;
		b: tmousebutton);
begin
	if b = mbleft
	then begin
		if assigned(mw.w)
		then mw.w.Paint(0);
		mw.w := f;
		mw.w.paint(1);
		mbs_weg_f.Show;
//		mbs_uhr_f.putinf(mw.w);
	end;
	if b = mbright
	then begin
		if assigned(mw.v)
		then mw.v.Paint(0);
		mw.v := f;
		mw.v.paint(2);
		mbs_weg_f.Show;
//		mbs_uhr_f.putinf(mw.v);
	end;
end;

procedure Tmbs_weg_f.FormActivate(Sender: TObject);
begin
	if tag = 0
	then begin
		tag := 1;
	end;
end;

procedure Tmbs_weg_f.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	mbs_uhr_f.Modechange(0);
end;

end.
