unit mbs_amp;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, Menus, StdCtrls,
	mbs_fld, mbs_lab, mbs_led, mbs_epi, mbs_epd, ExtCtrls;

type
	TfAmp =
	class(TForm)
		par: TGroupBox;
		rot: Tmbs_led;
		lpa0:	TLabel;
		pa0: Tmbs_epi;
		lpa1:	TLabel;
		pa1: Tmbs_epi;
		lhst:	TLabel;
		hst: Tmbs_lab;
		lprl:	TLabel;
		prl: Tmbs_lab;
		lngr:	TLabel;
		ngr: Tmbs_lab;
		pm: TPopupMenu;
		pmrot: TMenuItem;
		pmgrn: TMenuItem;
		pmgbl: TMenuItem;
		N1: TMenuItem;
		pma: TMenuItem;
		pmmd0: TMenuItem;
		pmmd1: TMenuItem;
		N2: TMenuItem;
		pmbel: TMenuItem;
		pmfre: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
		procedure pmrotClick(Sender: TObject);
		procedure pmgrnClick(Sender: TObject);
		procedure pmgblClick(Sender: TObject);
		procedure pmmd0Click(Sender: TObject);
		procedure pmmd1Click(Sender: TObject);
		procedure pmbelClick(Sender: TObject);
		procedure pmfreClick(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure RecMess(fld: tmbs_fld; mess: boolean);
		procedure ChngStat;
		procedure draw(f: tmbs_fld);
	end;

var
	fAmp: 		TfAmp;

implementation

uses mbs_bea_u, mbs_uhr_u;

{$R *.DFM}

procedure TfAmp.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfAmp.GetPar;
var
	v:			Tmbs_vrb;
begin
	with mbs_bea_f
	do begin
		par.Tag := 1;
		mw.w.Stan := 4;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := true;
		st3.Visible := true;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;
		rot.Adr := mw.w.Ad[0];
		pa0.Value := mw.w.getipar(par0);
		pa1.Value := mw.w.getipar(par1);
		hst.pos := point(0,0);
		prl.pos := point(0,0);
		ngr.pos := point(0,0);
		mw.w.FstVerb;
		while mw.w.GetVerb(v)
		do begin
			if v.fix = ngr.tag
			then ngr.pos := point(v.x, v.y);
			if v.fix = prl.tag
			then prl.pos := point(v.x, v.y);
			if v.fix = hst.tag
			then hst.Pos := point(v.x, v.y);
		end;
		showdtab(ptnon, 0);
		par.Visible := true;
		par.Tag := 0;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfAmp.setpar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Ad[0] := rot.Adr;
		mw.w.Ad[1] := adr_leer;
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		mw.dtab[mw.w.Ad[0].dc].f[mw.w.Ad[0].dv] := mw.w;
		mw.w.DelVerb(true);
// ampel						dev 	hst	ktimer	ktim o adr
//	0 = rot							
// 1 = rot gelb			=1							par3->self+
//		stat+ von decoder oder von ktimer
// 2 = grn             		=1		par0->self+
// 3 = grn blk/gelb		=0		=0		par1->ngr=1
// 														par3->self+
//		stat+ von decoder oder von ktimer
//
// 6 = gelb blinken		=2		=1	 	ngr=6
// 7 = rot (stop)       =0    =0		ngr=7
		// device
		mw.w.SetMess(0, sta1, 1);
		mw.w.SetMess(0, sta3, 0);
		mw.w.SetMess(0, sta6, 2);
		mw.w.SetMess(0, sta7, 0);
		mw.w.SetIpar(par0, pa0.value);
		mw.w.SetIpar(par1, pa1.value);
		mw.w.SetIPar(par3, 0);
		if rot.Adr.dc = 0
		then begin
			mw.w.SetIpar(par3, 4);
			av_timparsta(mw.w, sta1, par3, sst2);
			av_timparsta(mw.w, sta3, par3, sst3);
		end;
		av_timparnxt(mw.w, sta2, par0); 		// par0->self+
		av_fixnxt(mw.w, sta4, 1);	 			// 4->self0
		// nchste ampel
		if ngr.pos.x > 0
		then begin
			if ftamp = mw.ftab[ngr.X, ngr.Y].FTyp
			then begin
				av_fixsta(ngr, sta6, ngr.tag, sst6);
				av_fixsta(ngr, sta7, ngr.tag, sst7);
				av_timparsta(ngr, sta3, par1, sst1);
			end
			else ngr.Clear;
		end;
		// haltestelle
		if hst.pos.x > 0
		then begin
			if ftstp = mw.ftab[hst.X, hst.Y].FTyp
			then begin
				av_fixsta(hst, sta0, hst.tag, sst0);
				av_fixsta(hst, sta2, hst.tag, sst1);
				av_fixsta(hst, sta3, hst.tag, sst0);
				av_fixsta(hst, sta6, hst.tag, sst1);
				av_fixsta(hst, sta7, hst.tag, sst0);
			end
			else hst.Clear;
		end;
		// parallele ampel
		if prl.pos.x > 0
		then begin
			if ftamp = mw.ftab[prl.X, prl.Y].FTyp
			then begin
				av_fixsta(prl, sta1, prl.tag, sst1);
				av_fixsta(prl, sta6, prl.tag, sst6);
				av_fixsta(ngr, sta7, prl.tag, sst7);
				mw.ftab[prl.x, prl.y].SetIpar(par0, pa0.value);
				mw.ftab[prl.X, prl.Y].SetIpar(par1, pa1.value);
			end
			else prl.Clear;
		end;
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.Ptyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfAmp.draw(f: tmbs_fld);
const
	d = gr div 3 - 1;
	r: TRect = (left: d + 1;		Top: d + 1;
					Right: gr - d; 	bottom: gr - d);
var
	s:		tsta;
begin
	if mw.mode > 0
	then s := f.VSta
	else s := f.Stat;
	with mw.bm.Canvas
	do begin
		pen.Width := 1;
		pen.Color := clblack;
		brush.Color := clblack;
		rectangle(r);
		case s of
		sta0: 	brush.Color := clred;
		sta2: 	brush.Color := cllime;
//		sta3: 	brush.Color := clgreen;
		else	brush.color := clyellow;
		end;
		ellipse(r);
	end;
end;

// empangene meldungen
procedure TfAmp.RecMess(fld: tmbs_fld; mess: boolean);
begin
	if (fld.Stat = sta1)
	and mess
	then fld.Stat := sta2;
	if (fld.Stat = sta3)
	and not mess
	then fld.Stat := sta0;
end;

// statusnderung
procedure TfAmp.SetStat(fld: tmbs_fld; stat: tsta);
begin
	case stat of
	sta1:
		begin
			if fld.Blgt > 0
			then begin
				fld.zugw := 1;
				exit;
			end
			else fld.zugw := 0;
		end;
	sta6: mbs_uhr_f.delktimer(fld);
	sta7: mbs_uhr_f.delktimer(fld);
	belp:
		begin
			inc(fld.Z.Blgt);
			fld.Paint(0);
			exit;
		end;
	belm:
		begin
			if fld.Blgt > 0
			then dec(fld.Z.Blgt)
			else exit;
			fld.Paint(0);
			if (fld.Blgt = 0)
			and (fld.Zugw > 0)
			then fld.Stat := sta1;
			exit;
		end;
	end;
	fld.setstatcom(stat);
	case fld.stat of
	sta6: fld.Z.Blgt := 0;
	sta7:
		begin
			fld.Z.Blgt := 0;
		end;
	end;
	fld.Paint(0);
end;

// statusnderung durch Click
procedure TfAmp.ChngStat;
var
	p:			TPoint;
begin
	pmrot.Enabled := mw.run;
	pmgrn.Enabled := mw.run;
	pmgbl.Enabled := mw.run;
	pmbel.Enabled := mw.test;
	pmfre.Enabled := mw.test;
	pmmd0.Enabled := mw.test;
	pmmd1.Enabled := mw.test;
	p.x := mw.w.X * gr;
	p.y := mw.w.Y * gr;
	if mw.w.X < mw.trenn
	then p := mw.i1.ClientToScreen(p)
	else p := mw.i2.ClientToScreen(p);
	pm.Popup(p.x, p.y);
end;

// statustabelle versorgen
procedure TfAmp.SetStab(fld: tmbs_fld);
begin
	fld.PTyp := ptamp;
	fld.z.Stab[sta0] := fld.Conn;
	fld.z.Stab[sta1] := fld.Conn;
	fld.z.Stab[sta2] := fld.Conn;
	fld.z.Stab[sta3] := fld.Conn;
	fld.z.Stab[sta4] := fld.Conn;
	fld.z.Stab[sta5] := fld.Conn;
	fld.z.Stab[sta6] := fld.Conn;
	fld.z.Stab[sta7] := fld.Conn;
end;

procedure TfAmp.pmrotClick(Sender: TObject);
begin
	mw.w.Stat := sta7;		// rot
end;

procedure TfAmp.pmgrnClick(Sender: TObject);
begin
	mw.w.Stat := sta1;		// grn
end;

procedure TfAmp.pmgblClick(Sender: TObject);
begin
	mw.w.Stat := sta6;		// gelb blinken
end;

procedure TfAmp.pmmd0Click(Sender: TObject);
begin
	recmess(mw.w, false);  	// grn = 0
end;

procedure TfAmp.pmmd1Click(Sender: TObject);
begin
	recmess(mw.w, true);  	// gelb nach grn
end;

procedure TfAmp.pmbelClick(Sender: TObject);
begin
	mw.w.Stat := belp;
end;

procedure TfAmp.pmfreClick(Sender: TObject);
begin
	mw.w.Stat := belm;
end;

end.
