unit mbs_anl_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs,
	mbs_fld, StdCtrls, mbs_epi;

type
	Tmbs_anl_f =
	class(TForm)
		Label1: TLabel;
		Label2: TLabel;
		re: TButton;
		rl: TButton;
		ra: TButton;
		se: TButton;
		sl: TButton;
		sa: TButton;
		Label3: TLabel;
		Label4: TLabel;
		Label5: TLabel;
		Button1: TButton;
		tstb: TCheckBox;
		edbr: Tmbs_epi;
		edhi: Tmbs_epi;
		edtr: Tmbs_epi;
		procedure FormCreate(Sender: TObject);
		procedure saClick(Sender: TObject);
		procedure slClick(Sender: TObject);
		procedure seClick(Sender: TObject);
		procedure raClick(Sender: TObject);
		procedure rlClick(Sender: TObject);
		procedure reClick(Sender: TObject);
		procedure FormActivate(Sender: TObject);
		procedure FormClose(Sender: TObject;
						var Action: TCloseAction);
		procedure Button1Click(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure anlMousedown(f: Tmbs_fld;
						b: tmousebutton);
	end;

var
	mbs_anl_f: 	Tmbs_anl_f;
	mw:			ptmbswork;
	fld:			tmbs_fld;
	vp,
	np:			tpoint;

implementation

uses ape_u, mbs_uhr_u;

{$R *.DFM}

procedure Tmbs_anl_f.anlMousedown(f: Tmbs_fld;
				b: tmousebutton);
begin
	if b = mbleft
	then begin
		mw.w.Paint(0);
	end;
	mw.w := f;
	mw.w.paint(1);
	mbs_anl_f.Show;
//	mbs_uhr_f.putinf(mw.w);
end;

procedure Tmbs_anl_f.FormCreate(Sender: TObject);
begin
	mw := ptmbswork(application.tag);
	fld := tmbs_fld.Create(self);
end;

procedure rm(b: byte);
var
	i:			integer;
begin
	for i := 1 to mw.ftabx
	do begin
		mw.ftab[i, mw.w.y].paint(b);
	end;
end;

procedure sm(b: byte);
var
	i:			integer;
begin
 	for i := 1 to mw.ftaby
	do begin
		mw.ftab[mw.w.x, i].paint(b);
	end;
end;

procedure cngverb(ber: trect;
				difx, dify: integer);
var
	i,
	j:			integer;
	f:			Tmbs_fld;
begin
	for i := 1 to mw.ftabx
	do begin
		for j := 1 to mw.ftaby
		do begin
			f := mw.ftab[i, j];
			if f.FTyp = ftnon
			then continue;
			f.CngVerb(ber, difx, dify);
		end;
	end;
end;

procedure Tmbs_anl_f.saClick(Sender: TObject);
var
	i,
	j:			integer;
	r:			trect;
begin
	sm(1);
	if messagedlg('Spalte ausfgen?',
						mtConfirmation,
						[mbYes, mbNo],
						0) = mrYes
	then begin
		r.Left := mw.w.x + 1;
		r.Right := mw.ftabx;
		r.top := 1;
		r.Bottom := mw.ftaby;
		if mw.ftabx > mw.w.x + 1
		then begin
			for i := mw.w.x + 1 to mw.ftabx
			do begin
				for j := 1 to mw.ftaby
				do begin
					mw.ftab[i - 1, j].Copy(mw.ftab[i, j]);
					mw.ftab[i - 1, j].paint(0);
				end;
			end;
			cngverb(r, -1, 0);
		end;
	end
	else begin
		sm	(0);
	end;
	mw.w.paint(1);
end;

procedure Tmbs_anl_f.slClick(Sender: TObject);
var
	j:			integer;
	r:			trect;
begin
	sm(1);
	if messagedlg('Spalte lschen?',
						mtConfirmation,
						[mbYes, mbNo],
						0) = mrYes
	then begin
		r.Left := mw.w.x;
		r.Right := mw.w.x;
		r.top := 1;
		r.Bottom := mw.ftaby;
		for j := 1 to mw.ftaby
		do begin
			mw.ftab[mw.w.x, j].Conn := 0;
			mw.ftab[mw.w.x, j].FTyp := ftnon;
			mw.ftab[mw.w.x, j].Paint(0);
		end;
		cngverb(r, 0, 0);
	end
	else begin
		sm(0);
	end;
	mw.w.paint(1);
end;

procedure Tmbs_anl_f.seClick(Sender: TObject);
var
	i,
	j:			integer;
	r:			trect;
begin
	if mw.ftabx > mw.w.x + 1
	then begin
		r.Left := mw.w.x + 1;
		r.Right := mw.ftabx;
		r.top := 1;
		r.Bottom := mw.ftaby;
		for i := mw.ftabx downto mw.w.x + 1
		do begin
			for j := 1 to mw.ftaby
			do begin
				mw.ftab[i, j].Copy(mw.ftab[i - 1, j]);
				mw.ftab[i, j].paint(0);
{ TODO :
Verbindung oben und unten }
			end;
		end;
		cngverb(r, +1, 0);
	end;
//	mbsf.Apaint;
	mw.w.Paint(1);
end;

procedure Tmbs_anl_f.raClick(Sender: TObject);
var
	i,
	j:			integer;
	r:			trect;
begin
	rm(1);
	if messagedlg('Reihe ausfgen?',
						mtConfirmation,
						[mbYes, mbNo],
						0) = mrYes
	then begin
		r.Left := 1;
		r.Right := mw.ftaby;
		r.top := mw.w.y + 1;
		r.Bottom := mw.ftaby;;
		if mw.ftaby > mw.w.y + 1
		then begin
			for j := mw.w.y + 1 to mw.ftaby
			do begin
				for i := 1 to mw.ftabx
				do begin
					mw.ftab[i, j - 1].Copy(mw.ftab[i, j]);
					mw.ftab[i, j - 1].paint(0);
{ TODO :
Verbindung oben und unten }
				end;
			end;
			cngverb(r, 0, -1);
		end;
	end
	else begin
		rm(0);
	end;
	mw.w.Paint(1);
end;

procedure Tmbs_anl_f.rlClick(Sender: TObject);
var
	i:			integer;
	r:			trect;
begin
	rm(1);
	if messagedlg('Reihe lschen?',
						mtConfirmation,
						[mbYes, mbNo],
						0) = mrYes
	then begin
		r.Left := 1;
		r.Right := mw.ftaby;
		r.top := mw.w.y;
		r.Bottom := mw.w.y;
		for i := 1 to mw.ftabx
		do begin
			mw.ftab[i, mw.w.y].Conn := 0;
			mw.ftab[i, mw.w.y].Paint(0);
{ TODO :
Verbindung oben und unten }
		end;
		cngverb(r, 0, 0);
	end
	else begin
		rm(0);
	end;
	mw.w.Paint(1);
end;

procedure Tmbs_anl_f.reClick(Sender: TObject);
var
	i,
	j:			integer;
	r:			trect;
begin
	if mw.ftaby > mw.w.y + 1
	then begin
		r.Left := 1;
		r.Right := mw.ftaby;
		r.top := mw.w.y + 1;
		r.Bottom := mw.ftaby;
		for j := mw.ftaby downto mw.w.y + 1
		do begin
			for i := 1 to mw.ftabx
			do begin
				mw.ftab[i, j].Copy(mw.ftab[i, j - 1]);
				mw.ftab[i, j].paint(0);
			end;
		end;
		cngverb(r, 0, +1);
	end;
//	mbsf.Apaint;
	mw.w.Paint(1);
end;

procedure Tmbs_anl_f.FormActivate(Sender: TObject);
begin
	edbr.Value := mw.ftabx;
	edhi.Value := mw.ftaby;
	edtr.Value := mw.trenn;
	tstb.Checked := mw.test;
end;

procedure Tmbs_anl_f.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	mbs_uhr_f.Modechange(0);
end;

procedure Tmbs_anl_f.Button1Click(Sender: TObject);
begin
	mw.ftabx :=	edbr.Value;
	mw.ftaby :=	edhi.Value;
	mw.trenn :=	edtr.Value;
	mw.test := tstb.Checked;
end;

end.
