unit mbs_bea_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, Buttons, ExtCtrls,
	ComCtrls, StdCtrls, Menus, inifiles, math, ImgList,
	mbs_fld, mbs_lab;

type
	Tmbs_bea_f =
	class(TForm)
		tv:			TTreeView;
		mm:			TMainMenu;
		N1:			TMenuItem;
		einfA:		TMenuItem;
		bealoe: 		TMenuItem;
		N2: 			TMenuItem;
		zurck1: 		TMenuItem;
		mloe: 		TMenuItem;
		mdec: 		TMenuItem;
		fd: 		TLabel;
		beaod: 	TOpenDialog;
		cbtyp:	TComboBox;
		tvpm: 	TPopupMenu;
		il1: 		TImageList;
		lb: TListBox;
		btdec: TButton;
		btpar: TButton;
		dec: TGroupBox;
		empf: TLabel;
		allVerb: TMenuItem;
		Dev: TRadioGroup;
		st1: TButton;
		st2: TButton;
		st3: TButton;
		st4: TButton;
		st0: TButton;
		st5: TButton;
		st6: TButton;
		st7: TButton;
		asnd: TMenuItem;
    	ldec: TLabel;
		procedure FormCreate(Sender: TObject);
		procedure FormActivate(Sender: TObject);
		procedure tvEditing(Sender: TObject;
							Node: TTreeNode;
							var AllowEdit: Boolean);
		procedure tvMouseMove(Sender: TObject;
							Shift: TShiftState;
							X, Y: Integer);
		procedure tvChange(Sender: TObject;
							Node: TTreeNode);
		procedure bealoeClick(Sender: TObject);
		procedure cbtypChange(Sender: TObject);
		procedure mloeClick(Sender: TObject);
		procedure FormClose(
							Sender: TObject;
							var Action: TCloseAction);
		procedure btparClick(Sender: TObject);
		procedure btdecClick(Sender: TObject);
		procedure stClick(Sender: TObject);
		procedure allVerbClick(Sender: TObject);
    	procedure DevClick(Sender: TObject);
		procedure tvClick(Sender: TObject);
		procedure tvCollapsed(Sender: TObject; Node: TTreeNode);
	private		{ Private-Deklarationen	}
	public		{ Public-Deklarationen }
		function tvfind(adr: tmbs_adr): boolean;
		procedure showdtab(t: tptyp; ind: byte);
		function iniset(dc: word; dv: byte; err: boolean): boolean;
		procedure beaMousedown(
							f:	Tmbs_fld;
							b: tmousebutton);
		procedure SetFeld(
							nf: Tmbs_fld);
		procedure addverb(
							fix: byte;
							obj: tmbs_lab;
							wst: tsta;
							rpz: byte;
							sst: tsst);     			overload;
		procedure addverb(
							fix: byte;
							obj: tmbs_fld;
							wst: tsta;
							rpz: byte;
							sst: tsst);     			overload;
		procedure av_timnxt(fld: tmbs_fld;
							sta: tsta;
							tkt: byte);					overload;
		procedure av_timnxt(lab: tmbs_lab;
							sta: tsta;
							tkt: byte);					overload;
		procedure av_timparnxt(fld: tmbs_fld;
							sta: tsta;
							par: tpar);					overload;
		procedure av_timparnxt(lab: tmbs_lab;
							sta: tsta;
							par: tpar);					overload;
		procedure av_timsta(fld: tmbs_fld;
							sta: tsta;
							tkt: byte;
							sst: tsst);					overload;
		procedure av_timsta(lab: tmbs_lab;
							sta: tsta;
							tkt: byte;
							sst: tsst);					overload;
		procedure av_timparsta(fld: tmbs_fld;
							sta: tsta;
							par: tpar;
							sst: tsst);					overload;
		procedure av_timparsta(lab: tmbs_lab;
							sta: tsta;
							par: tpar;
							sst: tsst);					overload;
		procedure av_fixnxt(fld: tmbs_fld;
							sta: tsta;
							fix: byte);					overload;
		procedure av_fixnxt(lab: tmbs_lab;
							sta: tsta;
							fix: byte);					overload;
		procedure av_fixsta(fld: tmbs_fld;
							sta: tsta;
							fix: byte;
							sst: tsst);					overload;
		procedure av_fixsta(lab: tmbs_lab;
							sta: tsta;
							fix: byte;
							sst: tsst);					overload;

	end;

var
	mbs_bea_f:	Tmbs_bea_f;
	mw:			ptmbswork;
	zdec,
	zdev:			string;
	mn:			ttreenode;
	wegh,
	wegw:			integer;
	ini: tinifile;

implementation

uses mbs_ver_u, ape_u, mbs_col_u, mbs_u,
	mbs_amp, mbs_stp, mbs_lck, mbs_aus, mbs_non,
	mbs_cnt, mbs_hsi, mbs_vsi, mbs_trn, mbs_fst,
	mbs_uhr_u;

{$R *.DFM}

const
	ei3 = $B0;
	ei2 = $A0;
	ei1 = $90;
	aus = $80;

procedure nil2dec(t: longint);
var
	i:			word;
begin
	if t > 0
	then begin
		i := (t and $e000) shr 6 - 128
					 + (t shr 5) and $7f;
		mw.dtab[i].s := '';
		mw.dtab[i].a := false;
	end;
end;

function dat2str(p: pointer): string;
var
	d:			longint;
begin
	d := longint(p);
	if d = 0
	then result := '@ 000 00'
	else result := format('%s %3.3d %2.2d',
			[char((d  shr 24) and $07 + 64),
			(d shr 8) and $7f,
			d and 15]);
end;

function Tmbs_bea_f.iniset(dc: word; dv: byte; err: boolean): boolean;
begin
	result := true;
	mw.sdec := format('Decoder%3.3d', [dc]);
	mw.sdev := format('dev%2.2d', [dv]);
	mw.sdev := mw.dini.ReadString(mw.sdec, mw.sdev, '');
	mw.styp := '';
	if mw.sdev = ''
	then begin
		mw.sdev := 'dev00';
//		if err
//		then showmessage('nicht in ini'
//					+ #13
//					+ format('%3.3d %2.2d', [dc, dv]));
	end
	else begin
		mw.styp := mw.dini.ReadString(mw.sdev, 'typ', '');
		result := mw.dini.ReadBool(mw.sdec, 'a51', true);
	end;
end;
// 127 add verb ktimer nextstat
procedure Tmbs_bea_f.av_timnxt(fld: tmbs_fld;
	sta: tsta; tkt: byte);
var
	v:			Tmbs_vrb;
begin
	if fld.X > 0
	then begin
		v.wst := sta;
		v.x := fld.X;
		v.y := fld.Y;
		v.rpz := tkt;
		v.fix := 127;
		v.zug := 0;
		v.sst := sstl;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

procedure Tmbs_bea_f.av_timnxt(lab: tmbs_lab;
	sta: tsta;
	tkt: byte);
var
	v:			Tmbs_vrb;
begin
	if lab.X > 0
	then begin
		v.wst := sta;
		v.x := lab.X;
		v.y := lab.y;
		v.rpz := tkt;
		v.fix := 127;
		v.zug := 0;
		v.sst := sstl;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

// 126 add verb ktimer:par nextstat
procedure Tmbs_bea_f.av_timparnxt(fld: tmbs_fld;
	sta: tsta;
	par: tpar);
var
	v:			Tmbs_vrb;
begin
	if fld.X > 0
	then begin
		v.wst := sta;
		v.x := fld.X;
		v.y := fld.Y;
		v.rpz := byte(par);
		v.fix := 126;
		v.zug := 0;
		v.sst := sstl;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

procedure Tmbs_bea_f.av_timparnxt(lab: tmbs_lab;
	sta: tsta;
	par: tpar);
var
	v:			Tmbs_vrb;
begin
	if lab.X > 0
	then begin
		v.wst := sta;
		v.x := lab.X;
		v.y := lab.y;
		v.rpz := byte(par);
		v.fix := 126;
		v.zug := 0;
		v.sst := sstl;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

// 125 add verb ktimer:par setstat
procedure Tmbs_bea_f.av_timparsta(fld: tmbs_fld;
	sta: tsta;
	par: tpar;
	sst: tsst);
var
	v:			Tmbs_vrb;
begin
	if fld.X > 0
	then begin
		v.wst := sta;
		v.x := fld.X;
		v.y := fld.Y;
		v.rpz := byte(par);
		v.fix := 125;
		v.zug := 0;
		v.sst := sst;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

procedure Tmbs_bea_f.av_timparsta(lab: tmbs_lab;
	sta: tsta;
	par: tpar;
	sst: tsst);
var
	v:			Tmbs_vrb;
begin
	if lab.X > 0
	then begin
		v.wst := sta;
		v.x := lab.X;
		v.y := lab.y;
		v.rpz := byte(par);
		v.fix := 125;
		v.zug := 0;
		v.sst := sst;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

// 124 add verb ktimer setstat
procedure Tmbs_bea_f.av_timsta(fld: tmbs_fld;
	sta: tsta;
	tkt: byte;
	sst: tsst);
var
	v:			Tmbs_vrb;
begin
	if fld.X > 0
	then begin
		v.wst := sta;
		v.x := fld.X;
		v.y := fld.Y;
		v.rpz := tkt;
		v.fix := 124;
		v.zug := 0;
		v.sst := sst;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

procedure Tmbs_bea_f.av_timsta(lab: tmbs_lab;
	sta: tsta;
	tkt: byte;
	sst: tsst);
var
	v:			Tmbs_vrb;
begin
	if lab.X > 0
	then begin
		v.wst := sta;
		v.x := lab.X;
		v.y := lab.y;
		v.rpz := tkt;
		v.fix := 124;
		v.zug := 0;
		v.sst := sst;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

// fix add verb fix stat
procedure Tmbs_bea_f.av_fixsta(fld: tmbs_fld;
	sta: tsta;
	fix: byte;
	sst: tsst);
var
	v:			Tmbs_vrb;
begin
	if fld.X > 0
	then begin
		v.wst := sta;
		v.x := fld.X;
		v.y := fld.Y;
		v.rpz := 0;
		v.fix := fix;
		v.zug := 0;
		v.sst := sst;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

procedure Tmbs_bea_f.av_fixsta(lab: tmbs_lab;
	sta: tsta;
	fix: byte;
	sst: tsst);
var
	v:			Tmbs_vrb;
begin
	if lab.X > 0
	then begin
		v.wst := sta;
		v.x := lab.X;
		v.y := lab.y;
		v.rpz := 0;
		v.fix := fix;
		v.zug := 0;
		v.sst := sst;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

// fix add verb fix next
procedure Tmbs_bea_f.av_fixnxt(fld: tmbs_fld;
	sta: tsta;
	fix: byte);
var
	v:			Tmbs_vrb;
begin
	if fld.X > 0
	then begin
		v.wst := sta;
		v.x := fld.X;
		v.y := fld.Y;
		v.rpz := 0;
		v.fix := fix;
		v.zug := 0;
		v.sst := sstl;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

procedure Tmbs_bea_f.av_fixnxt(lab: tmbs_lab;
	sta: tsta;
	fix: byte);
var
	v:			Tmbs_vrb;
begin
	if lab.X > 0
	then begin
		v.wst := sta;
		v.x := lab.X;
		v.y := lab.y;
		v.rpz := 0;
		v.fix := fix;
		v.zug := 0;
		v.sst := sstl;
		v.dyn := false;
		mw.w.AddVerb(v);
	end;
end;

procedure Tmbs_bea_f.addverb(
				fix: byte;
				obj: tmbs_lab;
				wst: tsta;
				rpz: byte;
				sst: tsst);
var
	v:			Tmbs_vrb;
begin
	with obj as tmbs_lab
	do begin
		if X > 0
		then begin
			v.zug := 0;
			v.fix := fix;
			v.wst := wst;
			v.sst := sst;
			v.x := x;
			v.y := y;
			mw.w.AddVerb(v);
		end;
	end;
end;

procedure Tmbs_bea_f.addverb(
				fix: byte;
				obj: tmbs_fld;
				wst: tsta;
				rpz: byte;
				sst: tsst);
var
	v:			Tmbs_vrb;
begin
	with obj as tmbs_fld
	do begin
		if X > 0
		then begin
			v.zug := 0;
			v.fix := fix;
			v.wst := wst;
			v.sst := sst;
			v.rpz := rpz;
			v.x := X;
			v.y := Y;
			mw.w.AddVerb(v);
		end;
	end;
end;

function Tmbs_bea_f.tvfind(adr: tmbs_adr): boolean;
var
	i,
	t:			integer;
	dc,
	dv:		longint;
begin
	result := false;
	dc := adr.dc shl 8;
	dv := adr.dc shl 8 + adr.dv;
	with mbs_bea_f.tv
	do begin
		for i := 0 to items.count - 1
		do begin
			if longint(items[i].Data) and $ffffff = dc
			then begin
				items[i].Expand(true);
				t := i;
			end;
			if longint(items[i].Data) and $ffffff = dv
			then begin
				tv.FullCollapse;
				Selected := items[i];
				topitem := items[t];
				result := true;
				exit;
			end;
		end;
	end;
end;

procedure Tmbs_bea_f.FormCreate(Sender: TObject);
begin
	inherited;

	mw := ptmbswork(application.tag);
	cbtyp.Items.AddStrings(mw.typlst);
	cbtyp.ItemIndex := 0;
end;

procedure tmbs_bea_f.showdtab(t: tptyp; ind: byte);
var
	i,
	j,
	k:			integer;
	pr:		array [0..4] of ttreenode;
	p,
	d,
	v,
	e:			ttreenode;
	swe,
	swa:		boolean;
begin
//	if assigned(mw.w)
//	then t := mw.w.PTyp
//	else t := ptnon;
//	tv.Items.BeginUpdate;
	tv.Items.Clear;
	e := nil;
	pr[0] := tv.Items.Add(nil, 'noPort');
	pr[0].Data := pointer($0000000);
	pr[0].ImageIndex := 0;
	pr[0].SelectedIndex := 0;
	pr[1] := tv.Items.Add(nil, 'Port A');
	pr[1].Data := pointer($1000000);
	pr[1].ImageIndex := 3;
	pr[1].SelectedIndex := 3;
	pr[2] := tv.Items.Add(nil, 'Port B');
	pr[2].Data := pointer($2000000);
	pr[2].ImageIndex := 6;
	pr[2].SelectedIndex := 6;
	pr[3] := tv.Items.Add(nil, 'Port C');
	pr[3].Data := pointer($3000000);
	pr[3].ImageIndex := 9;
	pr[3].SelectedIndex := 9;
	pr[4] := tv.Items.Add(nil, 'Port D');
	pr[4].Data := pointer($4000000);
	pr[4].ImageIndex := 12;
	pr[4].SelectedIndex := 12;
	for i := low(mw.dtab) to high(mw.dtab)
	do begin
		if (ind > 0)
		and (i <> ind)
		then continue;
		k := mw.dtab[i].c * 3;
		p := pr[mw.dtab[i].c];
		if (mw.dtab[i].s > '')
		or (mw.dtab[i].a = true)
		then begin
			// decoder
			d := tv.Items.AddChild(p, mw.dtab[i].s);
			d.Data := pointer(longint(p.Data)
						+ (i shl 8));
			swa := true;
			swe := false;
			for j := low(mw.dtab[i].n) to high(mw.dtab[i].n)
			do begin
				// device
				if mw.dtab[i].n[j] > ''
				then begin
//					if (mw.dtab[i].t[j] = t)
//					or (t = ptnon)
//					then begin
						v := tv.Items.AddChild(d, mw.dtab[i].n[j]);
						v.Data := pointer(longint(d.Data) + j);
						if mw.dtab[i].f[j] <> nil
						then begin
							v.ImageIndex := 2 + k;
							v.SelectedIndex := 2 + k;
							swe := true;
						end
						else begin
							if not assigned(e)
							then e := d;
							v.ImageIndex := k;
							v.SelectedIndex := k;
							swa := false;
						end;
//					end;
				end;
			end;
			if swa
			then begin
				d.ImageIndex := 2 + k;
				d.SelectedIndex := 2 + k;
			end
			else begin
				if swe
				then begin
					d.ImageIndex := 1 + k;
					d.SelectedIndex := 1 + k;
				end
				else begin
					d.ImageIndex := k;
					d.SelectedIndex := k;
				end;
			end;
			if d.ImageIndex = 2 + k
			then d.Collapse(true)
			else begin
				d.Expand(false);
				p.Expand(false);
			end;
		end;
	end;
	tv.Items.EndUpdate;
	if not assigned(mw.w)
	or (mw.w.Ad[dev.itemindex].dc = 0)
	or not tvfind(mw.w.Ad[dev.itemindex])
	then begin
		tv.Selected := e;
		tv.TopItem := e;
	end;
	if lb.Visible
	then mw.w.Anzeige(lb, 0);
end;

procedure Tmbs_bea_f.FormActivate(Sender:	TObject);
begin
	if tag = 0
	then begin
		tag := 1;
	end
	else begin
//		btpar.Click;
	end;
end;

procedure Tmbs_bea_f.tvEditing(Sender: TObject;
					Node: TTreeNode;
					var AllowEdit: Boolean);
begin
	if node.Level = 0
	then allowedit := false;
end;

procedure Tmbs_bea_f.tvMouseMove(Sender: TObject;
					Shift: TShiftState;
					X, Y: Integer);
begin
	if mn = tv.GetNodeAt(x, y)
	then exit;
	mn := tv.GetNodeAt(x, y);
	if assigned(mn)
	then begin
		mdec.Caption := dat2str(mn.Data);
	end;
end;

procedure Tmbs_bea_f.tvChange(Sender: TObject; Node: TTreeNode);
begin
	mw.tv := tv.Selected;
end;

procedure Tmbs_bea_f.beaMousedown(f: Tmbs_fld;
					b: tmousebutton);
begin
	if b = mbleft
	then begin
		if mw.w	= f
		then begin
			mw.w.nextstat;
			mbs_ver_f.showtv;
//			mbs_uhr_f.putinf(mw.w);
		end
		else begin
			if assigned(mw.w)
			then begin
//				cbtypchange(self);
				mw.w.paint(0);
			end;
		end;
		mbs_bea_f.SetFeld(f);
		mw.w.paint(1);
		mbs_bea_f.Show;
	end;
	if b = mbright
	then begin
		if assigned(mw.v)
		then mw.v.paint(0);
		mw.v := f;
		mw.v.nextstat;
		mw.v.Paint(2);
		mbs_bea_f.Show;
	end;
end;

procedure Tmbs_bea_f.SetFeld(nf: Tmbs_fld);
begin
	if assigned(mw)
	and assigned(mw.w)
	then begin
		mw.w.Paint(0);
	end;
	mw.w :=	nf;
	cbtyp.ItemIndex := Ord(mw.w.FTyp);
	cbtypchange(self);
	application.ProcessMessages;
	caption := format('%s(%d %d):%d',
					[sftab[integer(mw.w.ftyp)],mw.w.x, mw.w.y, mw.w.zugn]);
	Show;
end;

procedure Tmbs_bea_f.bealoeClick(Sender: TObject);
begin
	if tv.Selected.Level <>	1
	then exit;
end;

procedure Tmbs_bea_f.cbtypChange(Sender: TObject);
var
	i:			byte;
begin
	mw.w.FTyp := tftyp(cbtyp.itemindex);
	mw.w.Paint(1);
	famp.par.Visible := false;
	flck.par.Visible := false;
	fstp.par.Visible := false;
	fcnt.par.Visible := false;
	fhsi.par.Visible := false;
	fvsi.par.Visible := false;
	ftrn.par.Visible := false;
	faus.par.Visible := false;
	ffst.par.Visible := false;
	i := dev.itemindex;
	dev.items.BeginUpdate;
	dev.Visible := false;
	dev.Items.Clear;
	case mw.w.ftyp of
	ft3wg:
		begin
			dev.Items.Add('L');
			dev.Items.Add('R');
			dev.Visible := true;
		end;
	ftekw:
		begin
			dev.Items.Add('1');
			dev.Items.Add('2');
			dev.Visible := true;
		end;
	ftaus, ftdkw:
		begin
			dev.Items.Add('1');
			dev.Items.Add('2');
			dev.Items.Add('3');
			dev.Items.Add('4');
			dev.Visible := true;
		end;
	else
		begin
			dev.Items.Add('1');
		end;
	end;
	dev.ItemIndex := 0;
	devclick(self);
	dev.items.EndUpdate;
end;

procedure Tmbs_bea_f.mloeClick(Sender: TObject);
begin
	if tv.Selected.Level <>	1
	then exit;
	nil2dec(longint(tv.Selected.data));
	showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
end;

procedure Tmbs_bea_f.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	mbs_uhr_f.Modechange(0);
end;

procedure Tmbs_bea_f.btparClick(Sender: TObject);
begin
	tv.Visible := false;
	mw.w.Anzeige(lb, 0);
	lb.Visible := true;
end;

procedure Tmbs_bea_f.btdecClick(Sender: TObject);
begin
	lb.Visible := false;
	showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
	tv.Visible := true;
end;

procedure Tmbs_bea_f.stClick(Sender: TObject);
begin
	with sender as tbutton
	do begin
		empf.Visible := false;
		mw.w.putpar;
		mw.w.Stat := tsta(tbutton(sender).tag);
		mw.w.putcom;
		mw.w.Anzeige(lb, 0);
	end;
end;

procedure Tmbs_bea_f.allVerbClick(Sender: TObject);
begin
	mw.w.DelVerb(true);
	mw.w.DelVerb(false);
	tv.Visible := false;
	mw.w.Anzeige(lb, 0);
	lb.Visible := true;
end;

procedure Tmbs_bea_f.DevClick(Sender: TObject);
begin
	case mw.w.FTyp of
	ftamp: famp.GetPar;
	ftfst: ffst.GetPar;
	ftaus: faus.GetPar;
	ftlck: flck.GetPar;
	ftekw,
	ft3wg,
	ftdkw,
	fttrn,
	ftabz: ftrn.Getpar;
	ftgkt,
	ftskt: fCnt.GetPar;
	ftstp: fstp.GetPar;
	fthsi: fhsi.Getpar;
	ftvsi: fvsi.Getpar;
	else
		fnon.Getpar;
	end;
end;

procedure Tmbs_bea_f.tvClick(Sender: TObject);
var
	i: integer;
	d:	longint;
begin
	if not Assigned(tv.Selected)
	then exit;
	if tv.Selected.Count = 0
	then begin
		for i := 0 to tv.Selected.Parent.Count - 1
		do begin
			d := longint(tv.Selected.Parent.Item[i].Data);
			if d <> 0
			then begin
				if assigned(mw.dtab[(d shr 8) and $7f].f[d and 15])
				then mw.dtab[(d shr 8) and $7f].f[d and 15].paint(0);
			end;
		end;
		d := longint(tv.Selected.Data);
		if d <> 0
		then begin
			if assigned(mw.dtab[(d shr 8) and $7f].f[d and 15])
			then mw.dtab[(d shr 8) and $7f].f[d and 15].paint(1);
		end;
	end
	else begin
		if not tv.Selected.Expanded
		then exit;
		for i := 0 to tv.Selected.Count - 1
		do begin
			d := longint(tv.Selected.Item[i].Data);
			if d <> 0
			then begin
				if assigned(mw.dtab[(d shr 8) and $7f].f[d and 15])
				then mw.dtab[(d shr 8) and $7f].f[d and 15].paint(2);
			end;
		end;
	end;
end;

procedure Tmbs_bea_f.tvCollapsed(Sender: TObject; Node: TTreeNode);
var
	i: integer;
	d:	longint;
begin
	if node.Count = 0
	then exit;
	if node.level < 1
	then exit;
	for i := 0 to node.Count - 1
	do begin
		d := longint(node.Item[i].Data);
		if d <> 0
		then begin
			if assigned(mw.dtab[(d shr 8) and $7f].f[d and 15])
			then mw.dtab[(d shr 8) and $7f].f[d and 15].paint(0);
		end;
	end;
end;

end.
