unit mbs_dcc_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, StdCtrls, ComCtrls,
	ScktComp, menus, Spin, Grids, inifiles, CPort,
	ImgList, Buttons, ExtCtrls,
	FileCtrl,
	mbs_lok_u, mbs_prt;

const
	anzloks = 32;
	bosad = 0;

type
	Tmbs_dcc_f =
	class(TForm)
		mon: 			TListBox;
		gbp: 			TGroupBox;
		mm: 			TMainMenu;
		cvs: 			TStringGrid;
		Label1: 		TLabel;
		pmcvs: 		TPopupMenu;
		pmrea: 		TMenuItem;
		pmwri: 		TMenuItem;
		pmver: 		TMenuItem;
		bearb: 		TMenuItem;
		odec: 		TOpenDialog;
		N3: 			TMenuItem;
		spg: 			TMenuItem;
		Ports1: 		TMenuItem;
		oi1: 			TMenuItem;
		oe1: 			TMenuItem;
		bel1: 		TMenuItem;
		loks: 		TComboBox;
		Hilfe1: 		TMenuItem;
		showmon: 	TMenuItem;
		gbc: 			TGroupBox;
		alleles: 	TButton;
		alleprf: 	TButton;
		alleschr: 	TButton;
		gbl: 			TGroupBox;
		loksava: 	TButton;
		loksave: 	TButton;
		lokumb: 		TButton;
		lokdel: 		TButton;
		sdec: 		TSaveDialog;
		stop: 		TButton;
		showbos: 	TMenuItem;
		N1: 			TMenuItem;
		ber1: 		TMenuItem;
		lokres: 		TButton;
		lokrad: 		TLabel;
		N2: 			TMenuItem;
		ovor: 		TMenuItem;
		il: 			TImageList;
		Gleisweg: 	TMenuItem;
		GleisDCC: 	TMenuItem;
		spdtab: TButton;
		lsek: TLabel;
		Label4: TLabel;
		lms: TLabel;
		Label5: TLabel;
		lkmh: TLabel;
		Label7: TLabel;
		brpls: TButton;
		Label3: TLabel;
		bruml: TLabel;
		fkttab: TButton;
		decum: TMenuItem;
		Belautoon1: TMenuItem;
	 	Belautooff1: TMenuItem;
		N4: TMenuItem;
		prt: Tmbs_prt;
		belegtA: TLabel;
		lokpos: TLabel;
		Lokssuchen1: TMenuItem;
    	Button1: TButton;
		cvf: TButton;
		cvfp: TButton;
		cvfm: TButton;
		belegtB: TLabel;
		Label2: TLabel;
		Label6: TLabel;
    N192001: TMenuItem;
    N208331: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure FormActivate(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure monDblClick(Sender: TObject);
		procedure about1Click(Sender: TObject);
		procedure showmonClick(Sender: TObject);
		procedure pmreaClick(Sender: TObject);
		procedure cvsMouseDown(Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
		procedure pmwriClick(Sender: TObject);
		procedure pmverClick(Sender: TObject);
		procedure loksChange(Sender: TObject);
		procedure allelesClick(Sender: TObject);
		procedure save1Click(Sender: TObject);
		procedure alleprfClick(Sender: TObject);
		procedure bearbClick(Sender: TObject);
		procedure alleschrClick(Sender: TObject);
		procedure spdschrClick(Sender: TObject);
		procedure fktschrClick(Sender: TObject);
		procedure LoksuchClick(Sender: TObject);
		procedure FormHide(Sender: TObject);
		procedure beenden1Click(Sender: TObject);
		procedure LokneuClick(Sender: TObject);
		procedure LokdelClick(Sender: TObject);
		procedure lokresClick(Sender: TObject);
		procedure loksavaClick(Sender: TObject);
		procedure LokumbClick(Sender: TObject);
		procedure Ports1Click(Sender: TObject);
		procedure FormClose(Sender: TObject;
			var Action: TCloseAction);
		procedure stopClick(Sender: TObject);
		procedure pmcvsPopup(Sender: TObject);
		procedure cvsDrawCell(Sender: TObject;
			ACol, ARow: Integer;
			Rect: TRect;
			State: TGridDrawState);
		procedure stfClick(Sender: TObject);
		procedure oi1Click(Sender: TObject);
		procedure bel1Click(Sender: TObject);
		procedure oe1Click(Sender: TObject);
		procedure loksaveClick(Sender: TObject);
		procedure showbosClick(Sender: TObject);
		procedure ber1Click(Sender: TObject);
		procedure lokradClick(Sender: TObject);
		procedure ovorClick(Sender: TObject);
		procedure GleisDCCClick(Sender: TObject);
		procedure GleiswegClick(Sender: TObject);
		procedure FormKeyDown(Sender: TObject;
			var Key: Word;
			Shift: TShiftState);
		procedure FormKeyUp(Sender: TObject;
			var Key: Word;
			Shift: TShiftState);
		procedure spdtabClick(Sender: TObject);
		procedure brplsClick(Sender: TObject);
		procedure fkttabClick(Sender: TObject);
		procedure decumClick(Sender: TObject);
		procedure prtMon(Sender: TObject;
			str: String);
		procedure prtAck(Sender: TObject; Art, Val: Byte);
		procedure Belautoon1Click(Sender: TObject);
		procedure Belautooff1Click(Sender: TObject);
		procedure cvfClick(Sender: TObject);
		procedure cvfpClick(Sender: TObject);
		procedure cvfmClick(Sender: TObject);
    procedure N192001Click(Sender: TObject);
    procedure N208331Click(Sender: TObject);
	private		{ Private-Deklarationen }
		rda,						// read all
		rde,						// read ende
		rd8,						// read cv8 und decoderwahl
		vfa,						// verfy all
		vfe,                 // verify ende
		wra,                 // write all
		wre,                 // write ende
		res,						// reset
		cvn,
		cvv,
		cvx,
		cvy:			integer;
		pin:			tinifile;
		tim:			tdatetime;
		lpo:			byte;
		lkn:			string;
		cvt:			boolean;
		procedure 	setenab(
							cvn: word; txt: string);
		procedure 	umrech(
							ein: string);
		procedure 	loksreadini();
		procedure 	writestring(
							sec, des, ber, def,
							bem, bit: string);
		procedure 	writedesc(
							sec, inp: string);
		function		savelok(
						fra: boolean): boolean;
		procedure	eincvs(
							cvn: word;
							cvv: byte);
	public		{ Public-Deklarationen }
		anlage:		string;
	end;

var
	mbs_dcc_f: 		Tmbs_dcc_f;
	lok: Tmbs_lok_f;

implementation

uses ape_u, mbs_cvb_u, mbs_spt_u,
  ShlObj, ActiveX, ComObj, mbs_fkt_u;

{$R *.DFM}

function iso: boolean;
var
	p: tpoint;
begin
	with mbs_dcc_f
	do begin
		result := true;
		if not oi1.Checked
		then begin
			p := mbs_dcc_f.clienttoscreen(point(0, 0));
			inc(p.x, 15);
			inc(p.y, 60);

			if messagedlgpos('Spannung einschalten?',
						mtConfirmation,
						[mbYes, mbNo],
						0,
						p.x, p.y) = mryes
			then begin
				oi1Click(mbs_dcc_f);
				sleep(200);
				application.ProcessMessages;
			end
			else result := false;
		end;
	end;
end;

procedure tmbs_dcc_f.setenab(
			cvn: word;
			txt: string);
begin
	if vfa + rda + wra > 0
	then begin
		Caption := format('!!! %s all: %d', [txt, cvn]);
		gbp.Enabled := false;
		il.GetIcon(0, Icon);
		gbl.Enabled := false;
		gbc.Enabled := false;
		lok.enabled := false;
		color := clred;
		exit;
	end;
	il.GetIcon(1, Icon);
	if cvn > 0
	then begin
		Caption := format('%s: %d', [txt, cvn]);
	end
	else begin
		Caption := txt;
	end;
	if loks.ItemIndex = -1
	then begin
		gbp.Enabled := false;
		gbl.Enabled := false;
		gbc.Enabled := false;
		lok.Enabled := false;
		color := clgray;
		exit;
	end;
	gbp.Enabled := true;
	gbl.Enabled := true;
	gbc.Enabled := true;
	lok.Enabled := true;
	color := clbtnface;
end;

function tmbs_dcc_f.savelok(
			fra: boolean): boolean;
var
	i:			integer;
	ts:		tstringlist;
	f:			string;
	def:		boolean;
begin
	result := true;
	if not assigned(pin)
	then exit;
	if cvs.Tag = 0
	then exit;
	def := false;
	if fra
	then begin
		f := changefileext(extractfilename(pin.filename), '');
		i := mrno;
		if res > 0
		then i := messagedlg('Lok ' + f + #13
							+ ' mit Default sichern ?',
							mtConfirmation,
							mbYesNoCancel,
							0);
		case i of
		mrno:
			i := messagedlg('Lok ' + f + #13
							+ ' sichern ?',
							mtConfirmation,
							mbYesNoCancel,
							0);
		mryes:
			def := true;
		mrcancel:
			begin
				result := false;
				exit;
			end;
		end;
		case i of
		mrno:
			begin
				cvs.Tag := 0;
				result := true;
				exit;
			end;
		mrcancel:
			begin
				result := false;
				exit;
			end;
		end;
	end;
	cvs.Tag := 0;
	result := true;
	ts := tstringlist.Create;
	pin.ReadSections(ts);
	pin.WriteInteger('lok', 'stufen', lok.Stufen);
	pin.WriteInteger('lok', 'reseta', lokres.tag shr 8);
	pin.WriteInteger('lok', 'resetw', lokres.tag and $ff);
	if cvs.RowCount > 1
	then begin
		for i := 0 to cvs.RowCount - 1
		do begin
			pin.WriteString('CV' + cvs.Cells[0, i],
								'Wert',
								cvs.Cells[1, i]);
			pin.WriteBool('CV' + cvs.Cells[0, i],
								'ReadOnly',
								(cvs.Cells[3, i] = 'R'));
			if def
			then pin.WriteString('CV' + cvs.Cells[0, i],
								'Default',
								cvs.Cells[1, i]);
		end;
	end;
	pin.UpdateFile;
end;

procedure Tmbs_dcc_f.FormCreate(
	Sender: TObject);
begin
	cvs.ColWidths[3] := 10;
	lok := tmbs_lok_f.Create(self);
	lok.Top := lokpos.top;
	lok.Left := lokpos.left;
	lok.Parent := self;
	lok.Port := prt;
	lok.Adr := 0;
	setenab(0, 'start');
	prt.Monitor := mon;
	prt.Porttyp := ptlok;
	prt.PortKurz := 'A';
	prt.OnAck := prtAck;
end;

procedure Tmbs_dcc_f.FormActivate(
			Sender: TObject);
begin
	if Tag = 0
	then begin
		application.ProcessMessages;
		ape_f.Ports(false, Ports1, ports1click);
		anlage := ape_f.RdS('\Anlage', '');
		if anlage = ''
		then begin
			odec.FileName := 'Anlagenverzeichnis';
			while not odec.Execute
			do begin
				odec.FileName := 'Anlagenverzeichnis';
			end;
			anlage := extractfilepath(odec.FileName);
			ape_f.WrS('\Anlage', anlage);
		end;
		lok.Anlage(anlage);
		loksuchClick(self);
		ape_f.RForm;
		oe1click(self);
		tag := 1;
	end;
end;

procedure Tmbs_dcc_f.FormDestroy(Sender: TObject);
begin
//	lokmi.Free;
	if not savelok(false)
	then exit;
	lok.Free;
end;

procedure Tmbs_dcc_f.monDblClick(
			Sender: TObject);
begin
	mon.Clear;
end;

procedure Tmbs_dcc_f.about1Click(
			Sender: TObject);
begin
	ape_f.showmodal;
end;

procedure Tmbs_dcc_f.showmonClick(
			Sender: TObject);
begin
	showmon.Checked := showmon.Checked xor true;
	mon.Visible := showmon.Checked;
end;

procedure Tmbs_dcc_f.cvsMouseDown(
			Sender: TObject;
			Button: TMouseButton;
			Shift: TShiftState;
			X, Y: Integer);
begin
	cvs.MouseToCell(x, y, cvx, cvy);
	if (cvx < 0)
	or (cvy < 0)
	then exit;
	cvs.Col := 1;
	cvs.Row := cvy;
	cvn := strtoint(cvs.cells[0, cvy]);
	if cvs.cells[1, cvy] <> '?'
	then cvv := strtoint(cvs.cells[1, cvy])
	else cvv := 0;
end;

procedure Tmbs_dcc_f.pmreaClick(
			Sender: TObject);
begin
	if not iso
	then exit;
	gbp.Enabled := false;
	prt.Read(cvn, cvv);
	setenab(cvn, 'Read');
end;

procedure Tmbs_dcc_f.pmwriClick(
			Sender: TObject);
begin
	if not iso
	then exit;
	gbp.Enabled := false;
	prt.Writ(cvn, cvv);
	setenab(cvn, 'Write');
end;

procedure Tmbs_dcc_f.pmverClick(
			Sender: TObject);
begin
	if not iso
	then exit;
	gbp.Enabled := false;
	prt.Veri(cvn, cvv);
	setenab(cvn, 'Verify');
end;

function cvcomp(
	l: TStringlist;
	i1, i2: integer): integer;
var
	z1,
	z2: word;
begin
	result := 0;
	if i1 = i2
	then exit;
	z1 := strtoint(copy(l[i1], 3, 3));
	z2 := strtoint(copy(l[i2], 3, 3));
	if z1 < z2
	then result := -1
	else result := 1;
end;

procedure Tmbs_dcc_f.loksreadini();
var
	i,
	n:			integer;
	ts:		tstringlist;
	s:			string[255];
begin
	if loks.ItemIndex = -1
	then exit;
//	if not savelok(true, false)
//	then exit;
	ts := tstringlist.Create;
	try
		cvs.Tag := 0;
		if fileexists(anlage	+ loks.Items[loks.itemindex]
									+ '.lok')
		then pin := tinifile.Create(anlage
									+ loks.Items[loks.itemindex]
									+ '.lok')
		else exit;
		pin.ReadSections(ts);
		ts.Delete(0);
		ts.CustomSort(cvcomp);
		cvs.RowCount := 0;
		for i := 0 to ts.Count - 1
		do begin
			s := pin.ReadString(ts[i], 'wert', '?');
			n := pos(';', s);
			if n > 0
			then delete(s, n, 255);
			cvs.cells[0, cvs.rowcount - 1] := copy(ts[i], 3, 4);
			cvs.cells[1, cvs.rowcount - 1] := s;
			if s <> '?'
			then cvs.cells[2, cvs.rowcount - 1] :=
							format('$%2.2x', [strtoint(s)])
			else cvs.cells[2, cvs.rowcount - 1] := s;
			if pin.ReadBool(ts[i], 'readonly', false)
			then cvs.Cells[3, cvs.RowCount - 1] := 'R'
			else cvs.Cells[3, cvs.RowCount - 1] := '';
			cvs.RowCount := cvs.RowCount + 1;
		end;
	finally
		cvs.RowCount := cvs.RowCount - 1;
		ts.Free;
	end;
end;

procedure Tmbs_dcc_f.allelesClick(
			Sender: TObject);
begin
	if not iso
	then exit;
	cvy := 0;
	cvs.Row := 0;
	rda := 1;
	rde := cvs.RowCount;
	cvn := 1;
	if cvs.cells[1, 0] = '?'
	then cvv := pin.ReadInteger('CV' + inttostr(cvn), 'Default', 0)
	else cvv := strtoint(cvs.cells[1, 0]);
	setenab(cvn, 'Read');
	pmrea.Click;
end;

procedure Tmbs_dcc_f.alleprfClick(
			Sender: TObject);
begin
	if not iso
	then exit;
	cvy := 0;
	cvs.Row := 0;
	vfa := 1;
	vfe := cvs.RowCount;
	cvn := 1;
	if cvs.cells[1, 0] = '?'
	then cvv := 3
	else cvv := strtoint(cvs.cells[1, 0]);
	setenab(cvn, 'Verify');
	pmver.Click;
end;

procedure Tmbs_dcc_f.alleschrClick(
			Sender: TObject);
begin
	if not iso
	then exit;
	cvy := 0;
	cvs.Row := 0;
	wra := 1;
	wre := cvs.RowCount;
	cvn := 1;
	if cvs.cells[1, 0] = '?'
	then cvv := 3
	else cvv := strtoint(cvs.cells[1, 0]);
	setenab(cvn, 'Write');
	pmwri.Click;
end;

procedure Tmbs_dcc_f.save1Click(
			Sender: TObject);
begin
	if loks.ItemIndex = -1
	then exit;
	cvs.Tag := 1;
	savelok(false);
end;

procedure Tmbs_dcc_f.bearbClick(
			Sender: TObject);
var
	c: 		string[8];
	e:       tmodalresult;
begin
	if not iso
	then exit;
	with mbs_cvb_f
	do begin
		cvnum := cvn;
		cvwrt := cvv;
		c := 'CV' + inttostr(cvn);
		bez := pin.ReadString(c, 'Bezeichnung', '?');
		ber := pin.ReadString(c, 'Bereich', '?');
		def := pin.ReadString(c, 'Default', '0');
		if cvn = 7
		then bem := pin.ReadString('lok', 'decoder', '?')
		else bem := pin.ReadString(c, 'Bemerkung', '?');
		bit[0] := pin.ReadString(c, 'Bit0', '');
		bit[1] := pin.ReadString(c, 'Bit1', '');
		bit[2] := pin.ReadString(c, 'Bit2', '');
		bit[3] := pin.ReadString(c, 'Bit3', '');
		bit[4] := pin.ReadString(c, 'Bit4', '');
		bit[5] := pin.ReadString(c, 'Bit5', '');
		bit[6] := pin.ReadString(c, 'Bit6', '');
		bit[7] := pin.ReadString(c, 'Bit7', '');
		rdo := pin.ReadBool(c, 'ReadOnly', false);
		spt := pin.ReadInteger('lok', 'tabspeed', 1);
		e := Showmodal;
		if	(e = mrok)
		and not rdo
		then begin
			cvv := cvwrt;
			if (cvs.cells[1, cvy] = '?')
			or (strtoint(cvs.cells[1, cvy]) <> cvv)
			then cvs.Tag := 1;
			cvs.Cells[1, cvy] := inttostr(cvv);
			cvs.cells[2, cvy] := format('$%2.2x', [cvv]);
			pmwri.Click
			//SendMess(7, cvv and $ff, cvn);
		end;
		if	(e = mryes)
		and not rdo
		then begin
			cvs.Cells[3, cvy] := 'R';
			pin.WriteBool(c, 'ReadOnly', true);
			cvs.Tag := 1;
			cvs.Invalidate;
		end;
		if	(e = mryes)
		and rdo
		then begin
			cvs.Cells[3, cvy] := '';
			pin.WriteBool(c, 'ReadOnly', false);
			cvs.Tag := 1;
			cvs.Invalidate;
		end;
	end;
end;

procedure Tmbs_dcc_f.LoksuchClick(
			Sender: TObject);
var
	e:			integer;
	sr:		tsearchrec;
	i:			integer;
begin
	loks.Clear;
	e :=  findfirst(anlage + '*.lok', faanyfile, sr);
	i := 0;
	while (e = 0)
	and (i <= anzloks)
	do begin
		loks.Items.Add(changefileext(sr.name, ''));
		e := findnext(sr);
		inc(i);
	end;
	loks.Sorted := true;
//	if loks.Items.Count > 0
//	then begin
//		loks.ItemIndex := 0;
//		lokschange(self);
//	end;
	setenab(0, '');
end;

procedure Tmbs_dcc_f.FormHide(
			Sender: TObject);
begin
	savelok(true);
end;

procedure Tmbs_dcc_f.beenden1Click(Sender: TObject);
begin
	hide;
end;

procedure Tmbs_dcc_f.WriteString(
			sec, des, ber, def, bem, bit: string);
var
	n,
	z:			integer;
	s:			string;
begin
	pin.WriteString(sec, 'Wert', '?');
	pin.WriteString(sec, 'Bezeichnung', des);
	if ber > ''
	then pin.WriteString(sec, 'Bereich', ber);
	if def > ''
	then begin
		pin.WriteString(sec, 'Default', def);
		pin.WriteString(sec, 'Wert', def);
	end;
	if bem > ''
	then pin.WriteString(sec, 'Bemerkung', bem);
	if bit = ''
	then exit;
	n := Pos('|', bit);
	z := 0;
	while n > 0
	do begin
		delete(bit, n, 1);
		s := copy(bit, n, 255);
		n := Pos('|', s);
		if n > 0
		then delete(s, n, 255);
		if s = ''
		then begin
			inc(z);
			continue;
		end;
		if (s[1] > '1')
		or (s[1] = '#')
		or (s[1] = '4')
		then begin
			pin.WriteString(sec,
							'Bit' + inttostr(z),
							copy(s, 3, 255));
			inc(z);
		end;
		if (s[1] > '2')
		or (s[1] = '#')
		then begin
			pin.WriteString(sec,
							'Bit' + inttostr(z),
							copy(s, 3, 255));
			inc(z);
		end;
		if (s[1] > '3')
		or (s[1] = '#')
		then begin
			pin.WriteString(sec,
							'Bit' + inttostr(z),
							copy(s, 3, 255));
			inc(z);
		end;
		pin.WriteString(sec,
							'Bit' + inttostr(z),
							copy(s, 3, 255));
		inc(z);
		n := Pos('|', bit);
	end;
end;

procedure Tmbs_dcc_f.WriteDesc(
			sec, inp: string);
var
	b:			integer;
	des,
	ber,
	def,
	bem,
	bit: 		string;
begin
	inp := trim(inp);
	delete(inp, 1, 1);
	b := pos('"', inp);
	des := copy(inp, 1, b - 1);
	delete(inp, 1, b + 1);

	inp := trimleft(inp);
	delete(inp, 1, 1);
	b := pos('"', inp);
	ber := copy(inp, 1, b - 1);
	delete(inp, 1, b + 1);

	inp := trimleft(inp);
	b := pos(',', inp);
	def := copy(inp, 1, b - 1);
	delete(inp, 1, b + 1);

	inp := trimleft(inp);
	b := pos(',', inp);
	delete(inp, 1, b + 1);

	bem := '';
	bit := '';
	inp := trimleft(inp);
	if length(inp) > 2
	then begin
		delete(inp, 1, 1);
		b := pos('"', inp);
		if b > 1
		then bem := copy(inp, 1, b - 1);
		delete(inp, 1, b + 1);

		inp := trimleft(inp);
		if length(inp) > 2
		then begin
			delete(inp, 1, 1);
			b := pos('"', inp);
			if b < 2
			then bit := ''
			else bit := '|' + copy(inp, 1, b - 1);
		end;
	end;
	writestring(sec, des, ber, def, bem, bit);
end;

procedure Tmbs_dcc_f.umrech(
			ein: string);
var
	ts:		tstringlist;
	i,
	j,
	n:			integer;
	s:			string;
	st:		array [0..27] of byte;
begin
	ts := tstringlist.Create;
	try
		ts.loadfromfile(ein);
		for i := ts.Count - 1 downto 0
		do begin
			n := length(ts[i]);
			if (n > 0)
			and (ts[i][n] = '-')
			then begin
				ts[i] := copy(ts[i], 1, n - 1)
							+ copy(trim(ts[i + 1]), 1, 255);
				ts.Delete(i + 1);
			end;
		end;
		s := ts[0];
		delete(s, 1, 1);
		delete(s, length(s), 1);
		s := extractfilepath(ein);
		s := extractfilename(copy(s, 1, length(s) - 1));
		s := anlage
			+ 'Decoder\_'
			+ ts.Values['Manufacturer']
			+ ' '
			+ s;
		if not DirectoryExists(s)
		then begin
			ForceDirectories(s);
		end;
		s := s
			+ '\'
			+ copy(ts[0], 2, length(ts[0]) - 2)
			+ '.lok';
		if assigned(pin)
		then pin.free;
		pin := tinifile.Create(s);
		pin.WriteString('lok', 'decoder', copy(ts[0], 2, length(ts[0]) - 2));
		if ts.values['InternalSteps'] > ''
		then j := strtoint(ts.values['InternalSteps'])
		else j := 64;
		s := ts.Values['SpeedTabValues'] + ',';
		if s > ''
		then begin
			for i := 0 to 27
			do begin
				st[i] := j;
				n := pos(',', s) - 1;
				if n > 0
				then begin
					st[i] := strtoint(copy(s, 1, n));
					delete(s, 1, n + 1);
				end;
			end;
		end;
		s := ts.Values['SpeedSteps'];
		if s > ''
		then begin
			pin.WriteString('lok', 'maxstufen', s);
			pin.WriteString('lok', 'stufen', s);
		end
		else begin
			pin.WriteString('lok', 'maxstufen', '28');
			pin.WriteString('lok', 'stufen', '28');
		end;
		pin.WriteInteger('lok', 'maxspeed', j);

		lokradclick(self);
		WriteString('CV1', 'Basisadresse',
						'1-127', '3', '', '');
		for i := 2 to 255
		do begin
			case i of
			7:
				begin
					WriteString('CV7', 'Versionsnummer',
									'0-255', '', '', '');
					pin.WriteString('CV7', 'ReadOnly', '1');
				end;
			8:
				begin
					s := ts.Values['Manufacturer'];
					WriteString('CV8', 'Hersteller',
									s + '-' + s, s, '', '');
					pin.WriteString('CV8', 'ReadOnly', '1');
				end;
			17:
				begin
					s := ts.Values['ExtAddress'];
					if s = 'Y'
					then begin
						WriteString('CV17', 'Erweiterte Adresse MSB',
										'196-231', '0', '', '');
					end;
				end;
			18:
				begin
					if s = 'Y'
					then begin
						WriteString('CV18', 'Erweiterte Adresse LSB',
										'0-255', '0', '', '');
					end;
				end;
			19:
				begin
					s := ts.Values['ConsAddress'];
					if s = 'Y'
					then begin
						WriteString('CV19', 'Verbundadresse',
							'1-127', '0', '', '');
					end;
				end;
			29:
				begin
					WriteString('CV29', 'Konfigurationsbits',
							'0-127', '0', '',
							'|1,Fahrtrichtung,vorwrts,rckwrts' +
							'|1,Fahrstufen,14,28 ' +
							'|1,Power,nur digital,analog' +
							'|1,bidirectional,aus,ein' +
							'|1,Speedtable,aus,ein' +
							'|1,Adresse,kurz,lang' +
							'|1' +
							'|1,Accessory Decoder');
				end;
			67..94:
				begin
					if i = 67
					then s := ts.Values['SpeedTable'];
					if s = 'Y'
					then begin
						WriteString('CV' + inttostr(i),
								';freie Geschw. Tab',
								'0-255',
								inttostr(st[i - 67]),
								'Stufe ' + inttostr(i - 66),
								'');
					end;
				end;
			else
				begin
					s := ts.Values['CV_' + inttostr(i)];
					if (s > '')
					or ovor.Checked
					then begin
						writedesc('CV' + inttostr(i), s);
					end;
				end;
			end;
		end;
		pin.UpdateFile;
		cvs.Tag := 0;
	finally
		ts.Free;
	end;
end;

procedure Tmbs_dcc_f.LokneuClick(
			Sender: TObject);
var
	s:			string;
	n:			integer;
begin
	if inputquery('Lokname neue Lok',
						'Bitte Lokname eingeben',
						s)
	then begin
		n := loks.Items.IndexOf(s);
		if n > -1
		then begin
			loks.ItemIndex := n;
			showmessage('Lok vorhanden');
			exit;
		end;
      cvs.RowCount := 2;
      cvs.Cells[0, 0] := '8';
      cvs.Cells[1, 0] := '?';
		// cv8 lesen
		lkn := s;
		rd8 := 1;
		cvn := 8;
		cvv := 0;
		pmreaClick(self);
	end;
end;

procedure Tmbs_dcc_f.LokdelClick(
			Sender: TObject);
begin
	if loks.ItemIndex > -1
	then begin
		if messagedlg('Soll die Lok'
					+ #13
					+ loks.Items[loks.itemindex]
					+ #13
					+ 'gelscht werden?',
					mtConfirmation,
					mbOKCancel,
					0) = mrok
		then begin
			deletefile(anlage
							+ loks.Items[loks.itemindex]
							+ '.lok');
			loks.Items.Delete(loks.itemindex);
			cvs.Tag := 0;
			loksuchclick(self);
		end;
	end;
end;

procedure Tmbs_dcc_f.lokresClick(
			Sender: TObject);
begin
	if not iso
	then exit;
	// reset senden
	if messagedlg('Reset der Lok '
				+ #13
				+ loks.Items[loks.itemindex]
				+ ' ?',
				mtConfirmation,
				[mbYes, mbNo],
				0) = mryes
	then begin
		res := 1;
		gbp.Enabled := false;
		// ['w', 0, lokreset.tag and $FF, 0, ]));
		prt.Writ(lokres.tag shr 8, lokres.Tag and $FF);
		cvs.Tag := 1;
	end;
end;

procedure Tmbs_dcc_f.loksavaClick(
			Sender: TObject);
var
	s:			string;
begin
	sdec.InitialDir := anlage;
	sdec.FileName := pin.FileName;
	if sdec.Execute
	then begin
		s := pin.FileName;
		pin.Free;
		if copyfile(pchar(s), pchar(sdec.FileName), false)
		then begin
			pin := tinifile.Create(sdec.filename);
			cvs.Tag := 1;
			savelok(false);
			loks.Items.Add(extractfilename(
								changefileext(sdec.filename, '')));
		end
		else pin := tinifile.Create(s);
	end;
end;

procedure Tmbs_dcc_f.LokumbClick(
			Sender: TObject);
var
	s:			string;
begin
	sdec.InitialDir := anlage;
	sdec.FileName := pin.FileName;
	if sdec.Execute
	then begin
		s := pin.FileName;
		pin.Free;
		if renamefile(s, sdec.filename)
		then begin
			loks.Items[loks.ItemIndex] :=
					extractfilename(changefileext(sdec.filename, ''));
			pin := tinifile.Create(sdec.filename);
		end
		else pin := tinifile.Create(s);
	end;
end;

procedure Tmbs_dcc_f.Ports1Click(
			Sender: TObject);
begin
	with sender as tmenuitem
	do begin
		checked := true;
		if name = 'Ports1'
		then exit;
		prt.Close;
		if caption = 'kein Port'
		then prt.Port := ''
		else begin
			prt.Port := Caption;
		end;
		prt.Open;
		prt.OnMon := prtmon;
	end;
end;

procedure Tmbs_dcc_f.FormClose(
			Sender: TObject;
			var Action: TCloseAction);
begin
	if not savelok(true)
	then begin
		action := canone;
		exit;
	end;
	oe1click(self);
	ape_f.SForm;
end;

procedure Tmbs_dcc_f.eincvs(
			cvn: word;
			cvv: byte);
var
	i:			integer;
begin
	i := cvs.cols[0].IndexOf(inttostr(cvn));
	if (cvs.Cells[1, i] = '?')
	or (strtoint(cvs.Cells[1, i]) <> cvv)
	then cvs.Tag := 1;
	if cvn = 1
	then begin
		lok.Adr := cvv;
	end;
	cvs.Cells[1, i] := inttostr(cvv);
	cvs.Cells[2, i] := format('$%2.2x', [cvv]);
end;

procedure Tmbs_dcc_f.prtAck(Sender: TObject; Art, Val: Byte);
var
	i,
	j,
	st,
	mi,
	se,
	ms: word;
	z: double;
	tsr: tsearchrec;
begin
	//dctst
	case Art of
	mreno:	// read not ok
		begin
			if MessageDlg('Read(' + inttostr(cvn) + ')Fehler.'
					+ #13 + 'wiederholen?',
					mtConfirmation,
					[mbYes, mbNo],
					0) = mryes
			then begin
				dec(rda);
				pmrea.Click;
			end
			else begin
				prtmon(self, 'Read Fehler');
				setenab(cvn, 'Read Fehler');
				if rd8 > 0
				then begin
					rd8 := 0;
					if findfirst(anlage
										+ 'Decoder\'
										+ inttostr(val)
										+ ' *',
								fadirectory,
								tsr) = 0
					then begin
						odec.InitialDir := anlage
										+ 'Decoder\'
										+ tsr.Name;
					end
					else begin
						odec.InitialDir := anlage
										+ 'Decoder';
					end;
					odec.FileName := '*.lok';
					findclose(tsr);
					if odec.Execute
					then begin
						loks.Items.Add(lkn);
						copyfile(pchar(odec.FileName),
								pchar(anlage
								+ lkn
								+ '.lok'),
								true);
						loks.ItemIndex := -1;
						loks.ItemIndex := loks.Items.IndexOf(lkn);
						loksreadini;
						if messagedlg('Alle CVs lesen?',
										mtConfirmation,
										mbokcancel,
										0) = mrok
						then begin
							res := 2;
							alleles.click;
							exit;
						end
						else begin
							rda := 0;
							res := 0;
							setenab(0, '');
						end;
					end;
				end;
			end;
		end;
	mreok:   // read ok, byte folgt
		begin
			prtmon(self, 'Read OK');
			eincvs(cvn, val);
			setenab(cvn, 'Read OK');
			if (rda > 0)
			and (rda < rde)
			then begin
				cvn := strtoint(cvs.cells[0, rda]);
				if cvs.cells[1, rda] = '?'
				then cvv := pin.ReadInteger('CV' + inttostr(cvn), 'Default', 0)
				else cvv := strtoint(cvs.cells[1, rda]);
				inc(rda);
				pmrea.Click;
			end;
			if rda >= rde
			then begin
				rda := 0;
				setenab(0, 'Read all OK');
				savelok(true);
				res := 0;
			end;
			if rd8 > 0
			then begin
				rd8 := 0;
				if findfirst(anlage
									+ 'Decoder\_'
									+ inttostr(val)
									+ ' *',
							fadirectory,
							tsr) = 0
				then begin
					odec.InitialDir := anlage
									+ 'Decoder\'
									+ tsr.Name;
				end
				else begin
					odec.InitialDir := anlage
									+ 'Decoder';
				end;
				odec.FileName := '*.lok';
				findclose(tsr);
				if odec.Execute
				then begin
					loks.Items.Add(lkn);
					copyfile(pchar(odec.FileName),
							pchar(anlage
							+ lkn
							+ '.lok'),
							true);
					loks.ItemIndex := -1;
					loks.ItemIndex := loks.Items.IndexOf(lkn);

					loksreadini;
					if messagedlg('Alle CVs lesen?',
									mtConfirmation,
									mbokcancel,
									0) = mrok
					then begin
						res := 2;
						alleles.click;
						exit;
					end
					else begin
						res := 0;
						setenab(0, '');
					end;
				end;
			end;
		end;
	mwrno:   // write not ok
		begin
			if MessageDlg('Write(' + inttostr(cvn) + ')Fehler.'
					+ #13 + 'wiederholen?',
					mtConfirmation,
					[mbYes, mbNo],
					0) = mryes
			then begin
				dec(wra);
				pmwri.Click;
			end
			else begin
				prtmon(self, 'Write Fehler');
				setenab(cvn, 'Write Fehler');
				wra := 0;
				if res = 1
				then begin
					if messagedlg('Alle CVs lesen ?',
								mtConfirmation,
								[mbYes, mbNo],
								0) = mryes
					then begin
						res := 2;
						alleles.Click;
					end
					else begin
						res := 0;
						setenab(0, '');
					end;
				end;
				cvf.Tag := cvf.Tag + 1;
				cvf.Caption := 'CV' + inttostr(cvf.tag);
				cvt := false;
			end;
		end;
	mwrok:   // write ok
		begin
			prtmon(self, 'Write OK');
			setenab(cvn, 'Write OK');
			if cvn = 1
			then begin
				eincvs(1, cvv);
			end;
			if res = 1
			then begin
				if messagedlg('Alle CVs lesen ?',
							mtConfirmation,
							[mbYes, mbNo],
							0) = mryes
				then begin
					res := 2;
					alleles.Click;
					exit;
				end
				else begin
					res := 0;
					setenab(0, '');
				end;
			end;
			while (wra > 0)
			and (wra < wre)
			do begin
				cvn := strtoint(cvs.cells[0, wra]);
				if (cvs.cells[1, wra] <> '?')
				and (cvs.cells[3, wra] <> 'R')
				then begin
					cvv := strtoint(cvs.cells[1, wra]);
					inc(wra);
					pmwri.Click;
					break;
				end
				else begin
					inc(wra);
					continue;
				end;
			end;
			if (wra >= wre)
			then begin
				wra := 0;
				setenab(0, 'Write OK');
			end;
			if cvt
			then begin
				for i := cvs.RowCount - 1 downto 0
				do begin
					if strtoint(cvs.Cells[0, i]) = cvn
					then begin
						cvf.Tag := cvf.Tag + 1;
						cvf.Caption := 'CV' + inttostr(cvf.tag);
						cvt := false;
						exit;
					end;
				end;
				for i := cvs.RowCount - 1 downto 0
				do begin
					if strtoint(cvs.Cells[0, i]) > cvn
					then begin;
						cvs.cells[0, i + 1] := cvs.cells[0, i];
						cvs.cells[1, i + 1] := cvs.cells[1, i];
						cvs.cells[2, i + 1] := cvs.cells[3, i];
						cvs.cells[3, i + 1] := cvs.cells[3, i];
					end
					else begin
						cvs.cells[0, i + 1] := inttostr(cvn);
						cvs.cells[1, i + 1] := inttostr(cvv);
						cvs.cells[2, i + 1] := '$00';
						cvs.Cells[3, i + 1] := '';
						cvs.tag := 1;
						cvs.rowcount := cvs.rowcount + 1;
						break;
					end;
				end;
				cvf.Tag := cvf.Tag + 1;
				cvf.Caption := 'CV' + inttostr(cvf.tag);
				cvt := false;
			end;
		end;
	mveno:   // verify not ok
		begin
			if MessageDlg('Verify(' + inttostr(cvn) + ')Fehler.'
				+ #13 + 'wiederholen?',
					mtConfirmation,
					[mbYes, mbNo],
					0) = mryes
			then begin
				dec(vfa);
				pmver.Click;
			end
			else begin
				prtmon(self, 'Verify Fehler');
				vfa := 0;
				setenab(cvn, 'Verify Fehler');
			end;
		end;
	mveok:   // verify ok
		begin
			prtmon(self, 'Verify OK');
			setenab(cvn, 'Verify OK');
			while (vfa > 0)
			and (vfa < vfe)
			do begin
				cvn := strtoint(cvs.cells[0, vfa]);
				if cvs.cells[1, vfa] <> '?'
				then begin
					cvv := strtoint(cvs.cells[1, vfa]);
					inc(vfa);
					pmver.Click;
					break;
				end
				else begin
					inc(vfa);
					continue;
				end;
			end;
			if vfa >= vfe
			then begin
				vfa := 0;
				setenab(0, 'Verify OK');
			end;
		end;
	mboon:   // spannung ein
		begin
			oi1.Checked := true;
			spg.Caption := 'ON';
			prtmon(self, 'Spannung ON');
		end;
	mboff:   // spannung aus
		begin
			oe1.Checked := true;
			spg.Caption := 'OFF';
			prtmon(self, 'Spannung OFF');
		end;
	mbint:   // Schiene an decoder
		begin
			prtmon(self, 'Gleis Decoder');
		end;
	mbext:   // Schiene  an vorgnger
		begin
			prtmon(self, 'Gleis ext');
		end;
	meld1:
		begin
			if lpo = 2
			then begin
				lpo := 1;
				prtmon(self, 'Kontakt 1');
				tim := now();
				lsek.Caption := 'start';
				if bruml.Tag > 0
				then begin
					bruml.Tag := bruml.Tag - 1;
					bruml.Caption := inttostr(bruml.tag);
					if bruml.Tag = 0
					then lok.Speed := 3;
				end;
			end
			else begin
//				prtmon(self, 'Kontakt 1 doppelt');
			end;
		end;
	meld2:
		begin
			if lpo = 1
			then begin
				lpo := 2;
				prtmon(self, 'Kontakt 2');
				if bruml.tag = 0
				then begin
					bruml.tag := -1;
					bruml.Caption := '-';
					lok.Speed := 0;
				end
				else begin
					tim := now() - tim;
					decodetime(tim, st, mi, se, ms);
					if z = 0
					then begin
						lsek.Caption := '-';
						lms.Caption := '-';
						lkmh.Caption := '-';
					end
					else begin
						z := se + ms / 1000;
						lsek.Caption := format('%4.2f', [z]);
						z := 0.8 / z;
						lms.Caption := format('%4.2f', [z]);
						z := z * 3600 / 1000 * 87;
						lkmh.Caption := format('%3.0f', [z]);
					end;
				end;
			end
			else begin
//				prtmon(self, 'Kontakt 2 doppelt');
			end;
		end;
	meld3:
		begin
			prtmon(self, 'Kontakt 3');
		end;
	meld4:
		begin
			prtmon(self, 'Kontakt 4');
		end;
	mebel:   // auto bel ein
		begin
			prtmon(self, 'auto Bel ON');
		end;
	mabel:   // auto bel aus
		begin
			prtmon(self, 'auto Bel OFF');
		end;
	mfreA:   // frei
		begin
			prtmon(self, 'A: frei');
			belegtA.Color := clsilver;
			belegtA.Caption := 'frei';
			exit;
		end;
	mfreB:   // frei
		begin
			prtmon(self, 'B: frei');
			belegtB.Color := clsilver;
			belegtB.Caption := 'frei';
			exit;
		end;
	museA:   // belegt
		begin
			prtmon(self, 'A: belegt');
			belegtA.Color := clgreen;
			belegtA.Caption := 'belegt';
			exit;
		end;
	museB:   // belegt
		begin
			prtmon(self, 'B: belegt');
			belegtB.Color := clgreen;
			belegtB.Caption := 'belegt';
			exit;
		end;
	mshrA:   // kurzschluss
		begin
			spg.Caption := 'KS';
			spg.Checked := false;
			belegtA.Color := clred;
			belegtA.Caption := 'Kurzschluss';
			prtmon(self, 'A: Kurzschluss');
			exit;
		end;
	mshrB:   // kurzschluss
		begin
			spg.Caption := 'KS';
			spg.Checked := false;
			belegtB.Color := clred;
			belegtB.Caption := 'Kurzschluss';
			prtmon(self, 'B: Kurzschluss');
			exit;
		end;
	else
		prtmon(self, format('??? %2.2x', [byte(Art)]));
	end;
end;

procedure Tmbs_dcc_f.stopClick(
			Sender: TObject);
begin
	rda := 0;
	vfa := 0;
	wra := 0;
	setenab(0, '');
end;

procedure Tmbs_dcc_f.pmcvsPopup(
			Sender: TObject);
begin
	if pin.ReadBool('CV' + inttostr(cvn), 'ReadOnly', false)
	then begin
		bearb.Caption := 'ansehen';
		pmwri.Enabled := false;
	end
	else begin
		bearb.Caption := 'bearbeiten';
		pmwri.Enabled := true;
	end;
end;

procedure Tmbs_dcc_f.cvsDrawCell(
			Sender: TObject;
			ACol, ARow: Integer;
			Rect: TRect;
			State: TGridDrawState);
begin
	with sender as tstringgrid
	do begin
		if (acol > 0)
		and (cvs.cells[3, arow] = 'R')
		then begin
			canvas.Brush.Color := clsilver;
			canvas.Font.Color := clgray;
			canvas.FillRect(rect);
			canvas.TextRect(rect,
							rect.Left + 2,
							rect.Top + 2,
							cvs.Cells[acol, arow]);
		end;
	end;
end;

procedure Tmbs_dcc_f.stfClick(
			Sender: TObject);
begin
	with sender as tradiobutton
	do begin
		Checked := true;
		lok.Stufen := tag;
		cvs.Tag := 1;
	end;
end;

procedure Tmbs_dcc_f.loksChange(
			Sender: TObject);
var
	s:		string;
begin
	if not savelok(true)
	then begin
		loks.ItemIndex := loks.Tag;
		exit;
	end;
	loks.Tag := loks.ItemIndex;
	pin.Free;
	cvs.RowCount := 0;
	if loks.ItemIndex = -1
	then begin
		cvs.RowCount := 0;
		cvs.Cells[0, 0] := '';
		cvs.Cells[1, 0] := '';
		cvs.Cells[2, 0] := '';
		exit;
	end;
	spdtab.Enabled := false;
	if fileexists(anlage
				+ loks.Items[loks.itemindex]
				+ '.lok')
	then begin
		lok.Visible := true;
		lok.Bez := loks.Items[loks.itemindex];
		pin := tinifile.Create(anlage	+ lok.bez + '.lok');
		lok.Stufen := pin.ReadInteger('lok', 'stufen', 28);
		lok.ISteps := pin.ReadInteger('CV94', 'default', 0);
		s := '';
		if pin.ReadInteger('CV105', 'wert', 0) > 32
		then s := s + char(pin.ReadInteger('CV105', 'wert', 0));
		if pin.ReadInteger('CV106', 'wert', 0) > 32
		then s := s + char(pin.ReadInteger('CV106', 'wert', 0));
		s := s + #13 + #10
			+ pin.ReadString('lok', 'decoder', '') + #13 + #10
			+ 'max Stufen=' + inttostr(pin.ReadInteger('lok', 'maxstufen', 28));

		spdtab.Enabled := lok.ISteps > 0;
		lok.Index := 0;
	end;
	lokres.Tag := pin.ReadInteger('lok', 'reseta', 0) shl 8
				+ pin.ReadInteger('lok', 'resetw', 0);
	lokrad.Caption := inttostr(lokres.tag shr 8)
					+ '-'
					+ inttostr(lokres.tag and $ff);
	if lokres.Tag = 0
	then begin
		lokradclick(self);
	end;
	if loks.ItemIndex = -1
	then begin
		showmessage('Bitte Lok auswhlen');
		exit;
	end;
	if wra + vfa + rda > 0
	then begin
		showmessage('Bitte Schleife stoppen');
		exit;
	end;
	stop.Click;
	loksreadini;
//	lok.setlok;
	setenab(0, '');
//	lok.SetFocus;
end;

procedure Tmbs_dcc_f.bel1Click(
			Sender: TObject);
begin
	prt.Bel(0);				// belegt ?
end;

procedure Tmbs_dcc_f.oi1Click(
			Sender: TObject);
begin
	prt.Spg(0, true);		// spannung ein
	prt.intext(0, false);	// intern
end;

procedure Tmbs_dcc_f.oe1Click(
			Sender: TObject);
begin
	prt.Spg(0, false);		// spannung aus
	prt.intext(0, true);	// externe Schiene
end;

procedure Tmbs_dcc_f.loksaveClick(
			Sender: TObject);
begin
	savelok(false);
end;

procedure Tmbs_dcc_f.showbosClick(
			Sender: TObject);
begin
	showbos.Checked := showbos.Checked xor true;
	if showbos.Checked
	then prt.OnMon := prtmon
	else prt.OnMon := nil;
end;

procedure Tmbs_dcc_f.ber1Click(
			Sender: TObject);
begin
	ape_f.ShowModal;
end;

procedure Tmbs_dcc_f.lokradClick(
			Sender: TObject);
var
	s:			string;
	r:			integer;
begin
	try
		s := '1';
		if inputQuery(loks.Text, 'Resetadresse', s)
		then begin
			r := strtoint(s) shl 8;
			s := '0';
			if inputQuery(loks.Text, 'Resetwert', s)
			then begin
				r := r + strtoint(s) and $FF;
				if lokres.Tag <> r
				then begin
					lokres.tag := r;
					cvs.Tag := 1;
				end;
			end;
		end;
	except
		lokres.Tag := 0
	end;
	pin.WriteInteger('lok', 'reseta', lokres.tag shr 8);
	pin.WriteInteger('lok', 'resetw', lokres.tag and $ff);
	lokrad.Caption := inttostr(lokres.tag shr 8)
					+ '-'
					+ inttostr(lokres.tag and $ff);
end;

procedure Tmbs_dcc_f.ovorClick(
			Sender: TObject);
begin
	ovor.Checked := ovor.Checked xor true;
end;

procedure Tmbs_dcc_f.GleisDCCClick(
			Sender: TObject);
begin
	prt.intext(0, false);	// intern
end;

procedure Tmbs_dcc_f.GleiswegClick(
			Sender: TObject);
begin
	prt.intext(0, true);	// externe Schiene
end;

procedure Tmbs_dcc_f.Belautoon1Click(Sender: TObject);
begin
	prt.belauto(true);	// bel auto on
end;

procedure Tmbs_dcc_f.Belautooff1Click(Sender: TObject);
begin
	prt.belauto(false);	// bel auto off
end;

procedure Tmbs_dcc_f.FormKeyDown(
			Sender: TObject;
			var Key: Word;
			Shift: TShiftState);
begin
//	if iso
//	then key := lok.KeyD(key);
end;

procedure Tmbs_dcc_f.FormKeyUp(
			Sender: TObject;
			var Key: Word;
			Shift: TShiftState);
begin
//	key := lok.KeyU(key, shift);
end;

procedure Tmbs_dcc_f.spdtabClick(Sender: TObject);
var
	b,
	c,
	i,
	j:			integer;
	s:			string;
begin
	if not iso
	then exit;
	c := cvs.cols[0].indexof('29');
	cvv := strtoint(cvs.cells[1, c]);
	mbs_spt_f.cv29.Checked := (cvv and $10) > 0;
	c := cvs.cols[0].indexof('67');
	if c < 0
	then exit;
	cvs.TopRow := c;
	j := 0;
	for i := c to c + 27
	do begin
		mbs_spt_f.speedtab[j] := strtoint(cvs.cells[1, i]);
		inc(j);
	end;
	mbs_spt_f.steps := lok.ISteps;
	b := cvs.cols[0].indexof('2');
	mbs_spt_f.minspeed := strtoint(cvs.cells[1, b]);
	b := cvs.cols[0].indexof('5');
	mbs_spt_f.maxspeed := strtoint(cvs.cells[1, b]);
	b := cvs.cols[0].indexof('6');
	if b < 0
	then mbs_spt_f.midspeed :=
		(mbs_spt_f.maxspeed + mbs_spt_f.minspeed) div 2
	else mbs_spt_f.midspeed := strtoint(cvs.cells[1, b]);
	case mbs_spt_f.ShowModal of
	mrok:
		begin
			j := c;
			for i := 0 to 27
			do begin
				s := inttostr(mbs_spt_f.speedtab[i]);
				if s <> cvs.cells[1, j]
				then begin
					cvs.cells[1, j] := s;
					cvs.cells[2, j] := format('$%2.2x',
										[mbs_spt_f.speedtab[i]]);
					cvs.Tag := 1;
				end;
				inc(j);
			end;
			if mbs_spt_f.cv29.Checked <> (cvv and $ef = 0)
			then cvs.Tag := 1;
			if mbs_spt_f.cv29.Checked
			then cvv := cvv or $10
			else cvv := cvv and $EF;
			if oi1.Checked
			then spdschrclick(self);
			cvs.TopRow := c;
			cvs.Invalidate;
		end;
	mrretry:
		begin
			j := c;
			for i := 0 to 27
			do begin
				s := pin.ReadString('CV' + inttostr(i + 67),
												'Default', '?');
				if s <> cvs.cells[1, j]
				then begin
					cvs.cells[1, j] := s;
					if s <> '?'
					then cvs.cells[2, j] :=
									format('$%2.2x', [strtoint(s)])
					else cvs.cells[2, j] := s;
					cvs.Tag := 1;
				end;
				inc(j);
			end;
			cvs.Invalidate;
			spdtab.click;
		end;
	end;
end;

procedure Tmbs_dcc_f.spdschrClick(
			Sender: TObject);
begin
	cvy := cvs.cols[0].indexof('29');
	cvs.Row := cvy;
	cvs.Cells[1, cvy] := inttostr(cvv);
	cvs.cells[2, cvy] := format('$%2.2x', [cvv]);
	wra := cvs.cols[0].indexof('67');
	wre := cvs.cols[0].indexof('94') + 1;
	cvn := 29;
	setenab(cvn, 'Write');
	pmwri.Click;
end;

procedure Tmbs_dcc_f.fktschrClick(
			Sender: TObject);
begin
	wra := cvs.cols[0].indexof('33');
	wre := cvs.cols[0].indexof('46') + 1;
	cvn := 33;
	setenab(cvn, 'Write');
	pmwri.Click;
end;

{procedure CreateLink(
	Target,
	ShortCutName: string);
var
	IObj: IUnknown;
	Link: IShellLink;
	IPFile: IPersistFile;
	TargetW: WideString;
begin
	IObj := CreateComObject (CLSID_ShellLink);
	Link := IObj as IShellLink;
	IPFile := IObj as IPersistFile;

	with Link
	do begin
		SetPath (PChar (Target));
		SetArguments (PChar (''));
		SetShowCmd (SW_SHOWMINIMIZED);
		SetWorkingDirectory (PChar (''));
		SetIconLocation (PChar (''), 0);
	end;
	TargetW := ShortCutName;
	IPFile.Save (PWChar (TargetW), False);
End;
}

procedure Tmbs_dcc_f.brplsClick(Sender: TObject);
begin
	if bruml.tag < 5
	then bruml.Tag := bruml.Tag + 1;
	if bruml.Tag = 0
	then bruml.Tag := 1;
	bruml.Caption := inttostr(bruml.tag);
	lok.Dir := true;
	lok.Speed := 28;
	lpo := 2;
end;

procedure Tmbs_dcc_f.fkttabClick(Sender: TObject);
var
	c,
	i,
	j: integer;
begin
	if not iso
	then exit;
	c := cvs.cols[0].indexof('33');
	if c < 0
	then exit;
	cvs.TopRow := c;
	j := 1;
	for i := c to c + 13
	do begin
		mbs_fkt_f.funktab[j] := strtoint(cvs.cells[1, i]);
		inc(j);
	end;
 	case mbs_fkt_f.ShowModal of
	mrok:
		begin
			j := 1;
			for i := c to c + 13
			do begin
				cvs.cells[1, i] := inttostr(mbs_fkt_f.funktab[j]);
				cvs.cells[2, i] := format('$%2.2x',
										[mbs_fkt_f.funktab[j]]);
				inc(j);
			end;
			cvs.Tag := 1;
			if oi1.Checked
			then fktschrclick(self);
			cvs.Invalidate;
		end;
	end;
end;

procedure Tmbs_dcc_f.decumClick(Sender: TObject);
var
	i: integer;
begin
	odec.InitialDir := anlage + 'PDecoder';
	odec.filename := '*.DEC';
	if odec.Execute
	then begin
		for i := 0 to odec.Files.Count - 1
		do begin
			umrech(odec.Files[i]);
		end;
	end;
end;

procedure Tmbs_dcc_f.prtMon(
	Sender: TObject;
	str: String);
begin
	if (tag = 0)
	or not assigned(mon)
	or not mon.Visible
	then exit;
	mon.Items.Add(str);
	if mon.Height div mon.ItemHeight < mon.Items.Count
	then mon.TopIndex := mon.Items.Count
							- mon.Height div mon.ItemHeight
							+ 1;
end;

procedure Tmbs_dcc_f.cvfClick(Sender: TObject);
begin
	if not iso
	then exit;
	cvn := cvf.Tag;
	cvv := 0;
	cvt := true;
	gbp.Enabled := false;
	prt.Writ(cvn, cvv);
	setenab(cvn, 'Write');
end;

procedure Tmbs_dcc_f.cvfpClick(Sender: TObject);
begin
	cvf.Tag := cvf.Tag + 1;
	if cvs.tag > 1024
	then cvs.tag := 1;
	cvf.Caption := 'CV' + inttostr(cvf.tag);
end;

procedure Tmbs_dcc_f.cvfmClick(Sender: TObject);
begin
	cvf.Tag := cvf.Tag - 1;
	if cvs.tag < 1
	then cvs.tag := 1024;
	cvf.Caption := 'CV' + inttostr(cvf.tag);
end;

procedure Tmbs_dcc_f.N192001Click(Sender: TObject);
begin
	if prt.Conn
	then prt.Close;
	prt.CustomBaudRate := 19200;
	n192001.Checked := true;
	prt.Open;
end;

procedure Tmbs_dcc_f.N208331Click(Sender: TObject);
begin
	if prt.Conn
	then prt.Close;
	prt.CustomBaudRate := 20833;
	n208331.Checked := true;
	prt.Open;
end;

end.



