unit mbs_ext_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics,
	Controls, Forms, Dialogs, ExtCtrls, Menus,
	mbs_fld, ActnList;

type
	Tmbs_ext_f =
	class(TForm)
		im: TImage;
		pd: TPrintDialog;
    mm: TMainMenu;
    MBStest1: TMenuItem;
    save1: TMenuItem;
    N2: TMenuItem;
    beenden1: TMenuItem;
    System1: TMenuItem;
    Reset1: TMenuItem;
    Start1: TMenuItem;
    SendDecn1: TMenuItem;
    Schleifentest1: TMenuItem;
    Hilfe1: TMenuItem;
    monitor1: TMenuItem;
    N4: TMenuItem;
    about1: TMenuItem;
    N5: TMenuItem;
    Mode1: TMenuItem;
    fahren1: TMenuItem;
    bearbeiten1: TMenuItem;
    verbinden1: TMenuItem;
    Wegeverlegen1: TMenuItem;
    Anlagendern1: TMenuItem;
		procedure 	FormCreate(Sender: TObject);
		procedure 	imMouseMove(Sender: TObject;
							Shift: TShiftState;
							X, Y: Integer);
		procedure 	FormActivate(Sender: TObject);
		procedure 	imMouseDown(Sender: TObject;
							Button: TMouseButton;
							Shift: TShiftState;
							X, Y: Integer);
		procedure 	FormClose(Sender: TObject;
							var Action: TCloseAction);
    procedure modeclick(Sender: TObject);
    procedure imMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure about1Click(Sender: TObject);
    procedure beenden1Click(Sender: TObject);
    procedure save1Click(Sender: TObject);
    procedure fahren1Click(Sender: TObject);
    procedure bearbeiten1Click(Sender: TObject);
    procedure verbinden1Click(Sender: TObject);
    procedure Wegeverlegen1Click(Sender: TObject);
    procedure Anlagendern1Click(Sender: TObject);
    procedure monitor1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure Start1Click(Sender: TObject);
    procedure SendDecn1Click(Sender: TObject);
    procedure Schleifentest1Click(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
	end;

var
	mbs_ext_f: 		Tmbs_ext_f;
	mw:			ptmbswork;
	aposx,
	aposy:		byte;

implementation

uses ape_u, mbs_u, mbs_uhr_u;

{$R *.DFM}

procedure Tmbs_ext_f.FormCreate(sender: TObject);
begin
	inherited;

	mw := ptmbswork(application.Tag);
	mw.i2 := im;
	mw.mo2 := mode1;
end;

procedure Tmbs_ext_f.imMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
	if (x div gr + mw.trenn = aposx)
	and (y div gr + 1 = aposy)
	then exit;
	aposx := x div gr + mw.trenn;
	aposy := y div gr + 1;
	mbs_uhr_f.putinf(mw.ftab[aposx, aposy]);
end;

procedure Tmbs_ext_f.FormActivate(Sender: TObject);
begin
	if tag = 0
	then begin
		tag := 1;
	end;
end;

procedure Tmbs_ext_f.imMouseDown(Sender: TObject;
					Button: TMouseButton;
					Shift: TShiftState;
					X, Y: Integer);
begin
	mw.ftab[x div gr + mw.trenn, y div gr + 1].mousedown(
						timage(sender), button);
end;

procedure Tmbs_ext_f.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	hide;
	action := canone;
	mw.mext.Checked := false;
end;

procedure Tmbs_ext_f.modeclick(Sender: TObject);
begin
	mbs_uhr_f.Modechange(tmenuitem(sender).tag);
end;

procedure Tmbs_ext_f.imMouseUp(Sender: TObject; Button: TMouseButton;
  	Shift: TShiftState; X, Y: Integer);
begin
	mw.ftab[x div gr + mw.trenn, y div gr + 1].mouseup;
end;

procedure Tmbs_ext_f.about1Click(Sender: TObject);
begin
	ape_f.ShowModal;
end;

procedure Tmbs_ext_f.beenden1Click(Sender: TObject);
begin
	mbs_f.Close;
end;

procedure Tmbs_ext_f.save1Click(Sender: TObject);
begin
	mbs_f.save1Click(Sender);
end;

procedure Tmbs_ext_f.fahren1Click(Sender: TObject);
begin
	mbs_f.modeClick(sender);
end;

procedure Tmbs_ext_f.bearbeiten1Click(Sender: TObject);
begin
	mbs_f.modeClick(Sender);
end;

procedure Tmbs_ext_f.verbinden1Click(Sender: TObject);
begin
	mbs_f.modeClick(Sender);
end;

procedure Tmbs_ext_f.Wegeverlegen1Click(Sender: TObject);
begin
	mbs_f.modeClick(Sender);
end;

procedure Tmbs_ext_f.Anlagendern1Click(Sender: TObject);
begin
	mbs_f.modeClick(Sender);
end;

procedure Tmbs_ext_f.monitor1Click(Sender: TObject);
begin
	mbs_f.monitor1Click(Sender);
end;

procedure Tmbs_ext_f.Reset1Click(Sender: TObject);
begin
	mbs_f.Reset1Click(Sender);
end;

procedure Tmbs_ext_f.Start1Click(Sender: TObject);
begin
	mbs_f.System1Click(Sender);
end;

procedure Tmbs_ext_f.SendDecn1Click(Sender: TObject);
begin
	mbs_f.SendDecn1Click(Sender);
end;

procedure Tmbs_ext_f.Schleifentest1Click(Sender: TObject);
begin
	mbs_f.Schleifentest1Click(Sender);
end;

end.

