unit mbs_fst;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls,
  mbs_fld, mbs_lab, mbs_led, mbs_epi, ExtCtrls, mbs_epd;

type
	TfFst = class(TForm)
		par: TGroupBox;
		pin: Tmbs_led;
    	chc: TStaticText;
		procedure FormCreate(Sender: TObject);
		procedure SetPar(Sender: TObject);
		procedure chcClick(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure ChngStat;
		procedure draw(f: tmbs_fld);
	end;

var
	fFst: TfFst;

implementation

uses mbs_bea_u, mbs_col_u;

{$R *.DFM}

procedure TfFst.FormCreate(Sender: TObject);
begin
	inherited;
	par.Parent := mbs_bea_f;
end;

// alle parameter ins formular
procedure TfFst.GetPar;
begin
	with mbs_bea_f
	do begin
		par.tag := 1;
		mw.w.Stan := 2;
		if mw.w.Farb = 0
		then mw.w.Farb := $8f;
		st0.Visible := true;
		st1.Visible := true;
		st2.Visible := false;
		st3.Visible := false;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;
		pin.adr := mw.w.ad[dev.ItemIndex];
		par.Caption := sftab[integer(mw.w.ftyp)];
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		par.Visible := true;
		par.tag := 0;
		setpar(self);
	end;
end;

// alle parameter aus formular
procedure TfFst.SetPar(Sender: TObject);
begin
	with mbs_bea_f
	do begin
		if par.Tag > 0
		then exit;
		if not Assigned(mw)
		then exit;
		mw.w.Ad[0] := pin.Adr;
		mw.w.Ad[1] := adr_leer;
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		mw.dtab[mw.w.Ad[0].dc].f[mw.w.Ad[0].dv] := mw.w;
		mw.w.DelVerb(true);
		mw.w.SetMess(dev.ItemIndex, sta0, 0);
		mw.w.SetMess(dev.ItemIndex, sta1, 1);
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
		if tv.Visible
		then showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		mw.w.Paint(1);
	end;
end;

// Feldtyp zeichnen
procedure TfFst.draw(f: tmbs_fld);
const
	r: TRect = (left: gr div 4;	Top: gr div 4;
					Right: gr div 4 * 3 + 1;
					bottom: gr div 4 * 3 + 1);
begin
	with mw.bm.Canvas
	do begin
		pen.Width := 1;
		pen.Color := clblue;
		brush.color := clblue;
		if f.stat = sta0
		then framerect(r)
		else rectangle(r);
	end;
end;

// statusnderung
procedure TfFst.SetStat(fld: tmbs_fld; stat: tsta);
begin
	fld.setstatcom(stat);
end;

// statusnderung durch Click
procedure TfFst.ChngStat;
begin
	mw.w.NextStat;			// umschalten
end;

// statustabelle versorgen
procedure TfFst.SetStab(fld: tmbs_fld);
begin
	fld.PTyp := ptout;
	fld.stan := 2;
end;

procedure TfFst.chcClick(Sender: TObject);
begin
	with mbs_col_f
	do begin
		top := chc.clienttoscreen(point(0, 0)).y;
		left := chc.clienttoscreen(point(0, 0)).x;
		Tag := mw.w.Farb;
		showmodal;
		mw.w.Farb := Tag;
		setpar(self);
	end;
end;

end.
