unit mbs_non;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,
  mbs_fld;

type
	TfNon =
	class(TDataModule)
		procedure SetPar(Sender: TObject);
		procedure DataModuleCreate(Sender: TObject);
	private		{ Private-Deklarationen }
	public		{ Public-Deklarationen }
		procedure GetPar;
		procedure SetStat(fld: tmbs_fld; stat: tsta);
		procedure SetStab(fld: tmbs_fld);
		procedure ChngStat;
		procedure draw(fld: tmbs_fld);
	end;

var
	fNon: 		TfNon;
	mw:			ptmbswork;

implementation

uses mbs_bea_u;

{$R *.DFM}

procedure TfNon.DataModuleCreate(Sender: TObject);
begin
	inherited;
	mw := ptmbswork(application.Tag);
end;

// alle parameter ins formular
procedure TfNon.GetPar;
begin
	with mbs_bea_f
	do begin
		if mw.w.FTyp = ftfst
		then mw.w.Stan := 2
		else mw.w.Stan := 1;
		mw.w.PTyp := ptnon;
		mw.w.Ad[0] := adr_leer;
		mw.w.Ad[1] := adr_leer;
		mw.w.Ad[2] := adr_leer;
		mw.w.Ad[3] := adr_leer;
		st0.Visible := false;
		st1.Visible := false;
		st2.Visible := false;
		st3.Visible := false;
		st4.Visible := false;
		st5.Visible := false;
		st6.Visible := false;
		st7.Visible := false;
		showdtab(mw.w.PTyp, mw.w.Ad[0].dc);
		if lb.Visible
		then mw.w.Anzeige(lb, 0);
	end;
end;

// alle parameter aus formular
procedure TfNon.SetPar(Sender: TObject);
begin
	mw.w.Paint(1);
end;

// Feldtyp zeichnen
procedure TfNon.draw(fld: tmbs_fld);
const
	r: TRect = (left: gr div 4;	Top: gr div 4;
					Right: gr div 4 * 3 + 1;
					bottom: gr div 4 * 3 + 1);
	m: tpoint = (x: gr div 2; y: gr div 2);
var
	v:			tmbs_vrb;
begin
	with mw.bm.Canvas
	do begin
		case fld.FTyp of
		ftEnd, ftSte:
			begin
				fld.FstVerb;
				if not fld.GetVerb(v)
				then begin
					pen.Width := 3;
					pen.Color := clblack;
					if fld.FTyp = ftSte
					then pen.Color := clgray;
					case fld.conn of
					con, cos, con + cos:
						begin
							moveto(r.left, m.y);
							lineto(r.right, m.y);
						end;
					cono, cosw, cono + cosw:
						begin
							moveto(r.left, r.top);
							lineto(r.right, r.bottom);
						end;
					coo, cow, coo + cow:
						begin
							moveto(m.x, r.top);
							lineto(m.x, r.bottom);
						end;
					coso, conw, coso + conw:
						begin
							moveto(r.right, r.top);
							lineto(r.left, r.bottom);
						end;
					end;
				end
				else begin
					pen.Width := 1;
					pen.Color := clblack;
					brush.color := clblack;
					framerect(r);
				end;
			end;
		end;
	end;
end;

// empangene meldungen
// statusnderung
procedure TfNon.SetStat(fld: tmbs_fld; stat: tsta);
begin
	fld.setstatcom(stat);
end;

// statusnderung durch Click
procedure TfNon.ChngStat;
begin
	mw.w.NextStat;			// umschalten
end;

// statustabelle versorgen
procedure TfNon.SetStab(fld: tmbs_fld);
begin
	fld.PTyp := ptnon;
	fld.stan := 1;
	fld.z.Stab[sta1] := fld.Conn;
	if fld.ftyp = ftfst
	then begin
		fld.stan := 2;
		fld.z.Stab[sta0] := fld.Conn;
	end;
	fld.Ad[0] := adr_leer;
	fld.Ad[1] := adr_leer;
	fld.Ad[2] := adr_leer;
	fld.Ad[3] := adr_leer;
end;

end.
