unit pi_MBStest_u;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, ComCtrls, Menus, ExtCtrls,
	registry, inifiles,
	mbs_fld, mbs_prt, mbs_epd, ape_u, Grids, Spin;

const
	stazero = $00;
	staone = $10;
	statwo = $20;
	statre = $30;
	devpa1 = $40;
	devpa2 = $50;
	devpa3 = $60;
	devpa4 = $70;

	devpin: array [1..13] of string =
		( 'P1.7'
		, 'P1.6'
		, 'P1.5'
		, 'P1.4'
		, 'P1.3'
		, 'P1.2'
		, 'P1.1'
		, 'P1.0'
		, 'P3.7'
		, 'P3.5'
		, 'P3.4'
		, 'P3.3'
		, 'P3.2'
		);

type
	Tpi_MBStest_f =
	class(TForm)
		mon: TListBox;
		mm: TMainMenu;
		MBStest1: TMenuItem;
		beenden1: TMenuItem;
		MPorts: TMenuItem;
		System1: TMenuItem;
		Reset1: TMenuItem;
		Start1: TMenuItem;
		SendDecn1: TMenuItem;
		Schleifentest1: TMenuItem;
		Hilfe1: TMenuItem;
		monitor1: TMenuItem;
		about1: TMenuItem;
		N5: TMenuItem;
		pt: Tmbs_prt;
		inphex1: TMenuItem;
		N192001: TMenuItem;
		N208331: TMenuItem;
		sbt: TTimer;
		dev: TStringGrid;
	 	gbsrv: TGroupBox;
		sphi: TCheckBox;
		sswf: TCheckBox;
		decm: TLabel;
		decp: TLabel;
	 	sdifm: TLabel;
		sdifp: TLabel;
		slngm: TLabel;
		slngp: TLabel;
		slng: Tmbs_epd;
		skrzm: TLabel;
		skrzp: TLabel;
		skrz: Tmbs_epd;
		ldif: TLabel;
		lllng: TLabel;
		lkrz: TLabel;
		spar: Tmbs_epd;
		sdif: Tmbs_epd;
		dec: Tmbs_epd;
		sinv: TCheckBox;
		gbout: TGroupBox;
		ondvm: TLabel;
		ondvp: TLabel;
		ooftm: TLabel;
		ooftp: TLabel;
		oontm: TLabel;
		oontp: TLabel;
		ondvl: TLabel;
		ooftl: TLabel;
		oontl: TLabel;
		onof: TCheckBox;
		onon: TCheckBox;
		ooft: Tmbs_epd;
		oont: Tmbs_epd;
		opar: Tmbs_epd;
		ondv: Tmbs_epd;
		oach: TCheckBox;
		lname: TLabel;
		gbamp: TGroupBox;
		atimm: TLabel;
		atimp: TLabel;
		atiml: TLabel;
		atim: Tmbs_epd;
    ravh01: TMenuItem;
    tst1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    inibereinigen1: TMenuItem;
		procedure beenden1Click(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure FormClose(Sender: TObject;
						var Action: TCloseAction);
		procedure FormActivate(Sender: TObject);
		procedure Reset1Click(Sender: TObject);
		procedure Start1Click(Sender: TObject);
		procedure SendDecn1Click(Sender: TObject);
		procedure Schleifentest1Click(Sender: TObject);
		procedure MPortsClick(Sender: TObject);
		procedure ptMsg(Sender: TObject; msg: Tmsg);
		procedure monDblClick(Sender: TObject);
		procedure inphex1Click(Sender: TObject);
		procedure N192001Click(Sender: TObject);
		procedure N208331Click(Sender: TObject);
		procedure decChange(Sender: TObject);
		procedure about1Click(Sender: TObject);
		procedure sbtTimer(Sender: TObject);
		procedure monitor1Click(Sender: TObject);
		procedure ptMon(Sender: TObject; str: String);
		procedure editKeyPress(Sender: TObject; var Key: Char);
		procedure devMouseDown(Sender: TObject; Button: TMouseButton;
						Shift: TShiftState; X, Y: Integer);
		procedure devDrawCell(Sender: TObject; ACol, ARow: Integer;
						Rect: TRect; State: TGridDrawState);
		procedure devSelectCell(Sender: TObject; ACol, ARow: Integer;
						var CanSelect: Boolean);
		procedure devMouseWheelDown(Sender: TObject; Shift: TShiftState;
						MousePos: TPoint; var Handled: Boolean);
		procedure devMouseWheelUp(Sender: TObject; Shift: TShiftState;
						MousePos: TPoint; var Handled: Boolean);
		procedure decpClick(Sender: TObject);
		procedure decmClick(Sender: TObject);
		procedure sinvClick(Sender: TObject);
		procedure sparChange(Sender: TObject);
		procedure sdifmClick(Sender: TObject);
		procedure sdifpClick(Sender: TObject);
		procedure skrzmClick(Sender: TObject);
		procedure skrzpClick(Sender: TObject);
		procedure slngmClick(Sender: TObject);
		procedure slngpClick(Sender: TObject);
		procedure sdifChange(Sender: TObject);
		procedure skrzChange(Sender: TObject);
		procedure slngChange(Sender: TObject);
		procedure sswfClick(Sender: TObject);
		procedure sphiClick(Sender: TObject);
		procedure oparChange(Sender: TObject);
		procedure oachClick(Sender: TObject);
		procedure ononClick(Sender: TObject);
		procedure onofClick(Sender: TObject);
		procedure ondvChange(Sender: TObject);
		procedure oontChange(Sender: TObject);
		procedure ooftChange(Sender: TObject);
		procedure ondvClick(Sender: TObject);
		procedure ondvmClick(Sender: TObject);
		procedure oontpClick(Sender: TObject);
		procedure oontmClick(Sender: TObject);
		procedure ooftpClick(Sender: TObject);
		procedure ooftmClick(Sender: TObject);
		procedure atimChange(Sender: TObject);
		procedure atimpClick(Sender: TObject);
		procedure atimmClick(Sender: TObject);
    procedure ravh01Click(Sender: TObject);
    procedure tst1Click(Sender: TObject);
    procedure inibereinigen1Click(Sender: TObject);
	private	{ Private-Deklarationen }
		procedure admon(Sender: TObject;
						str: string);
		procedure setfini(
						key: string;
						wrt:boolean); 						overload;
		procedure setfini(
						key: string;
						wrt: integer); 	  				overload;
	public	{ Public-Deklarationen }
	end;

var
	pi_MBStest_f: Tpi_MBStest_f;
	mw: Tmbswork;
	aposx,
	aposy: byte;
//	anldec,
	anlage: string;
	fini:	tinifile;
	finidec,
	finidev,
	finityp: string;
	finiw: byte;
	sini:	string;
	lastcol: integer;

implementation

{$R *.DFM}

procedure finisrc(dec: word; dev: byte);
begin
	finidec := format('Decoder%3.3d', [dec]);
	finidev := format('dev%2.2d', [dev]);
	finidev := fini.ReadString(finidec, finidev, '');
	finityp := finidev;
	while pos('-', finityp) > 0
	do finityp := copy(finityp, pos('-', finityp) + 1, 32);
end;

procedure Tpi_MBStest_f.setfini(
	key: string;
	wrt:boolean);
begin
	fini.WriteBool(finidev, key, wrt);
	fini.WriteInteger(finidev, 'ass', 0);
	dev.Cells[6, dev.Tag] := '0';
end;

procedure Tpi_MBStest_f.setfini(
	key: string;
	wrt: integer);
begin
	fini.WriteInteger(finidev, key, wrt);
	fini.WriteInteger(finidev, 'ass', 0);
	dev.Cells[6, dev.Tag] := '0';
end;

procedure Tpi_MBStest_f.beenden1Click(Sender: TObject);
begin
	close;
end;

procedure Tpi_MBStest_f.MPortsClick(Sender: TObject);
var
	mi:		tmenuitem;
begin
	if tmenuitem(sender).name = 'MPorts'
	then exit;
	mi := tmenuitem(Sender);
	pt.Close;
	pt.Port := '';

	mi.Parent.Items[0].Checked := true;

	if mi.MenuIndex > 0
	then begin
		mi.Checked := true;
		pt.Port := mi.Caption;
		if pt.Open
		then begin
			mi.Checked := true;
		end;
	end;
end;

procedure Tpi_MBStest_f.FormCreate(Sender: TObject);
var
	i:	integer;
	myRect: TGridRect;
begin
	inherited;

	application.tag := longint(addr(mw));
	mw.trenn := 255;
	mw.typlst := tstringlist.Create;
	for i := 0 to high(sftab)
	do begin
		mw.typlst.Add(sftab[i]);
	end;
	dev.ColWidths[4] := 32;
	dev.ColWidths[5] := dev.Width - dev.DefaultColWidth * 4 - 36;
	for i := 0 to dev.RowCount - 1
	do begin
		dev.Cells[0, i] := '0';
		dev.Cells[4, i] := '-';
		if i < dev.RowCount - 3
		then begin
			dev.Cells[1, i] := '1';
			dev.Cells[2, i] := '2';
			dev.Cells[3, i] := '3';
		end;
	end;
	gbout.Left := gbsrv.Left;
	gbamp.Left := gbsrv.Left;
	gbout.Top := gbsrv.Top;
	gbamp.Top := gbsrv.Top;

	myRect.Left := 5;
	myRect.Top := 0;
	myRect.Right := 4;
	myRect.Bottom := 15;
	dev.Selection := myRect;

end;

procedure Tpi_MBStest_f.FormClose(Sender: TObject;
	var Action: TCloseAction);
begin
	fini.Free;
	ape_f.SForm;
end;

procedure Tpi_MBStest_f.FormActivate(Sender: TObject);
begin
	if not assigned(ape_f)
	then exit;
	chdir(extractfilepath(paramstr(0)));
	if ape_f.Tag > 0
	then exit;
	with ape_f
	do begin
		ape_f.Ports(false, mports, mportsclick);
		rform;
		anlage := rds('\Anlage', '');
		ravh01.Click;
		mw.mode := 0;
		tag := 1;
		monitor1.Checked := true;
	end;
	senddecn1.Click;
end;

procedure Tpi_MBStest_f.admon(Sender: TObject; str: string);
begin
	mon.Items.Add(str);
end;

procedure Tpi_MBStest_f.Reset1Click(Sender: TObject);
begin
	if pt.Conn
	then pt.SendCom(0, 1, 0);
end;

procedure Tpi_MBStest_f.Start1Click(Sender: TObject);
begin
	if pt.Conn
	then pt.SendCom(0, 2, 0);
end;

procedure Tpi_MBStest_f.SendDecn1Click(Sender: TObject);
begin
	if pt.Conn
	then pt.SendCom(0, 8, 0);
end;

procedure Tpi_MBStest_f.Schleifentest1Click(Sender: TObject);
begin
	if pt.Conn
	then pt.SendCom(0, 15, 0);
end;

procedure Tpi_MBStest_f.ptMsg(Sender: TObject;
	msg: Tmsg);
begin
	if msg.dv + msg.dt * 16 = $2f
	then begin
		dec.value := msg.dc;
	end;
end;

procedure Tpi_MBStest_f.monDblClick(Sender: TObject);
begin
	mon.Clear;
end;

procedure Tpi_MBStest_f.inphex1Click(Sender: TObject);
begin
	inphex1.Checked := inphex1.Checked xor true;
	pt.byt2mon := inphex1.Checked;
 //	pt.hex := inphex1.Checked;
end;

procedure Tpi_MBStest_f.N192001Click(Sender: TObject);
begin
	if pt.Conn
	then pt.Close;
	pt.CustomBaudRate := 19200;
	n192001.Checked := true;
	pt.Open;
end;

procedure Tpi_MBStest_f.N208331Click(Sender: TObject);
begin
	if pt.Conn
	then pt.Close;
	pt.CustomBaudRate := 20833;
	n208331.Checked := true;
	pt.Open;
end;

procedure Tpi_MBStest_f.decChange(Sender: TObject);
var
	i: integer;
	sr: tsearchrec;
begin
	caption := fini.FileName;
	try
		dev.tag := -1;
		lastcol := -1;
		finisrc(dec.value, 1);
		if finidec = ''
		then exit;
		lname.Caption := fini.ReadString(finidec, 'dec', '???');
		for i := 1 to 13
		do begin
			finisrc(dec.value, i);
			if (finityp = 'hsi')
			or (finityp = 'srv')
			or (finityp = 'vsi')
			or (finityp = 'vsd')
			or (finityp = 'out')
			or (finityp = 'inp')
			or (finityp = 'amp')
			then begin
				dev.Cells[0, i - 1] := '0';
				dev.Cells[1, i - 1] := '1';
				dev.Cells[2, i - 1] := '2';
				dev.Cells[3, i - 1] := '3';
				dev.cells[4, i - 1] := finityp;
				dev.cells[5, i - 1] := finidev;
			end
			else begin
				dev.Cells[0, i - 1] := '';
				dev.Cells[1, i - 1] := '';
				dev.Cells[2, i - 1] := '';
				dev.Cells[3, i - 1] := '';
				dev.cells[4, i - 1] := '-';
				dev.cells[5, i - 1] := '-';
			end;
		end;
	except
		for i := 1 to 13
		do begin
			dev.cells[4, i - 1] := inttostr(i);
			dev.cells[5, i - 1] := devpin[i];
		end;
	end;
	dev.cells[4, 13] := '?';
	dev.cells[4, 14] := '?';
	dev.cells[5, 13] := 'istat';
	dev.cells[5, 14] := 'bdd';
	findclose(sr);
end;

procedure Tpi_MBStest_f.about1Click(Sender: TObject);
begin
	ape_f.ShowModal;
end;

procedure Tpi_MBStest_f.sbtTimer(Sender: TObject);
begin
	case sbt.tag of
	0: ;
	1: sbt.Enabled := false;
	2: pt.SendCom(dec.value, dev.tag div 2 * 2 + 1, 0);
	3: pt.SendCom(dec.value, dev.tag div 2 * 2 + 2, 0);
	4: pt.SendCom(dec.value, dev.tag div 2 * 2 + 1, 1);
	5: pt.SendCom(dec.value, dev.tag div 2 * 2 + 2, 1);
	end;
	if sbt.Tag > 0
	then sbt.Tag := sbt.Tag - 1;
end;

procedure Tpi_MBStest_f.monitor1Click(Sender: TObject);
begin
	monitor1.Checked := monitor1.Checked xor true;
end;

procedure Tpi_MBStest_f.ptMon(Sender: TObject; str: String);
begin
	if monitor1.Checked
	then mon.Items.Add(str);
end;

procedure Tpi_MBStest_f.editKeyPress(Sender: TObject; var Key: Char);
begin
{	with sender as tedit
	do begin
		case key of
		'+':
			begin
				if tag < 127
				then tag := tag + 1;
				text := inttostr(tag);
			end;
		'-':
			begin
				if tag > 0
				then tag := tag - 1;
				text := inttostr(tag);
			end;
		end;
	end;
}end;

procedure Tpi_MBStest_f.devMouseDown(
	Sender: TObject;
	Button: TMouseButton;
	Shift: TShiftState;
	X, Y: Integer);
var
	c,
	r: longint;
	lr: integer;
begin
	dev.MouseToCell(X, Y, c, r);
	if dev.Cells[4, r] <= '-'
	then exit;
	if dev.Cells[c, r] <= '-'
	then exit;
	lr := dev.tag;
	dev.tag := r;
	if lr > -1
	then begin
		dev.Cells[4, lr] := dev.Cells[4, lr];
		dev.Cells[5, lr] := dev.Cells[5, lr];
		dev.Cells[4, r] := dev.Cells[4, r];
		dev.Cells[5, r] := dev.Cells[5, r];
	end;
	if (c < 4)
	then begin
		pt.SendCom(dec.value, r + 1, c);
		lastcol := c;
		dev.Cells[0, r] := '0';
		if dev.Cells[4, r] <> '?'
		then begin
			dev.Cells[1, r] := '1';
			dev.Cells[2, r] := '2';
			dev.Cells[3, r] := '3';
		end
		else begin
			dev.Cells[1, r] := '';
			dev.Cells[2, r] := '';
			dev.Cells[3, r] := '';
		end;
	end;
	if lr <> r
	then begin
		gbsrv.Visible := false;
		gbout.Visible := false;
		gbamp.Visible := false;
		finisrc(dec.value, r + 1);
		if finityp = 'srv'
		then begin
			sinv.Checked := fini.ReadBool(finidev, 'inv', false);
			sswf.Checked := fini.ReadBool(finidev, 'swf', false);
			sphi.Checked := fini.ReadBool(finidev, 'phi', false);
			sdif.Value := fini.ReadInteger(finidev, 'dif', 10);
			skrz.Value := fini.ReadInteger(finidev, 'krz', 90);
			slng.Value := fini.ReadInteger(finidev, 'lng', 100);
			gbsrv.Visible := true;
		end;
		if finityp = 'out'
		then begin
			oach.Checked := fini.ReadBool(finidev, 'ach', false);
			onon.Checked := fini.ReadBool(finidev, 'non', false);
			onof.Checked := fini.ReadBool(finidev, 'nof', false);
			ondv.Value := fini.ReadInteger(finidev, 'ndv', 0);
			oont.Value := fini.ReadInteger(finidev, 'ont', 0);
			ooft.Value := fini.ReadInteger(finidev, 'oft', 0);
			gbout.Visible := true;
		end;
		if finityp = 'amp'
		then begin
			atim.Value := fini.ReadInteger(finidev, 'tim', 20);
			gbamp.Visible := true;
		end;
	end;
end;

procedure Tpi_MBStest_f.devDrawCell(
	Sender: TObject;
	ACol, ARow: Integer;
	Rect: TRect;
	State: TGridDrawState);
begin
	with Sender as TDrawGrid
	do begin
		if acol > 3
		then Canvas.Brush.Color := clgreen
		else Canvas.Brush.Color := clsilver;
		if dev.tag = arow
		then begin
			if (acol > 4)
			or (acol = lastcol)
			then canvas.Font.Style := [fsbold]
			else canvas.Font.Style := [];
		end;
		Canvas.FillRect(Rect);
		Canvas.TextRect(Rect,
				rect.left + 6,
				rect.top + 2, dev.cells[acol, arow]);
  end;
end;

procedure Tpi_MBStest_f.devSelectCell(
	Sender: TObject;
	ACol, ARow: Integer;
	var CanSelect: Boolean);
begin
   canselect := false;
end;

procedure Tpi_MBStest_f.devMouseWheelDown(
	Sender: TObject;
	Shift: TShiftState;
	MousePos: TPoint;
	var Handled: Boolean);
begin
	handled := true;
end;

procedure Tpi_MBStest_f.devMouseWheelUp(
	Sender: TObject;
	Shift: TShiftState;
	MousePos: TPoint;
	var Handled: Boolean);
begin
	handled := true;
end;

procedure Tpi_MBStest_f.decpClick(Sender: TObject);
var
	s: string;
begin
	repeat
		dec.Add;
		application.ProcessMessages;
	until (fini.sectionexists('Decoder' + dec.Text)
			or (dec.Value = 127));
end;

procedure Tpi_MBStest_f.decmClick(Sender: TObject);
var
	s: string;
begin
	repeat
		dec.Sub;
		application.ProcessMessages;
	until (fini.sectionexists('Decoder' + dec.Text)
			or (dec.Value = 1));
end;

procedure Tpi_MBStest_f.sdifmClick(Sender: TObject);
begin
	sdif.Sub;
end;

procedure Tpi_MBStest_f.sdifpClick(Sender: TObject);
begin
	sdif.Add;
end;

procedure Tpi_MBStest_f.skrzmClick(Sender: TObject);
begin
   skrz.Sub;
end;

procedure Tpi_MBStest_f.skrzpClick(Sender: TObject);
begin
	skrz.Add;
end;

procedure Tpi_MBStest_f.slngmClick(Sender: TObject);
begin
	slng.Sub;
end;

procedure Tpi_MBStest_f.slngpClick(Sender: TObject);
begin
	slng.Add;
end;

procedure Tpi_MBStest_f.sparChange(Sender: TObject);
begin
	if assigned(dec)
	and gbout.Visible
	then pt.SendPar(dec.value, dev.tag + 1, sdif.tag, sdif.value);
end;

procedure Tpi_MBStest_f.sdifChange(Sender: TObject);
begin
	if assigned(dec)
	and gbsrv.Visible
	then pt.SendPar(dec.value, dev.tag + 1, sdif.tag, sdif.value);
	if Assigned(fini)
	then setfini('dif', sdif.value);
end;

procedure Tpi_MBStest_f.skrzChange(Sender: TObject);
begin
	if assigned(dec)
	and gbsrv.Visible
	then begin
		pt.SendPar(dec.value, dev.tag + 1, skrz.tag, skrz.value);
		pt.SendCom(dec.value, dev.tag + 1, 0);
	end;
	if Assigned(fini)
	then setfini('krz', skrz.value);
end;

procedure Tpi_MBStest_f.slngChange(Sender: TObject);
begin
	if assigned(dec)
	and gbsrv.Visible
	then begin
		pt.SendPar(dec.value, dev.tag + 1, slng.tag, slng.value);
		pt.SendCom(dec.value, dev.tag + 1, 1);
	end;
	if Assigned(fini)
	then setfini('lng', slng.value);
end;

procedure Tpi_MBStest_f.sinvClick(Sender: TObject);
begin
	if sinv.Checked
	then spar.Value := spar.Value or 1
	else spar.Value := spar.Value and (255 - 1);
	if assigned(dec)
	and gbsrv.Visible
	then pt.SendPar(dec.value, dev.tag + 1, spar.tag, spar.value);
	if Assigned(fini)
	then setfini('inv', byte(sinv.Checked));
end;

procedure Tpi_MBStest_f.sswfClick(Sender: TObject);
begin
	if sswf.Checked
	then spar.Value := spar.Value or 2
	else spar.Value := spar.Value and (255 - 2);
	if assigned(dec)
	and gbsrv.Visible
	then pt.SendPar(dec.value, dev.tag + 1, spar.tag, spar.value);
	if Assigned(fini)
	then setfini('swf', byte(sswf.Checked)*2);
end;

procedure Tpi_MBStest_f.sphiClick(Sender: TObject);
begin
	if sphi.Checked
	then spar.Value := spar.Value or 4
	else spar.Value := spar.Value and (255 - 4);
	if assigned(dec)
	and gbsrv.Visible
	then pt.SendPar(dec.value, dev.tag + 1, spar.tag, spar.value);
	if Assigned(fini)
	then setfini('phi', byte(sphi.Checked)*4);
end;

procedure Tpi_MBStest_f.oparChange(Sender: TObject);
begin
	if assigned(dec)
	and gbout.Visible
	then pt.SendPar(dec.value, dev.tag + 1, opar.tag, opar.value);
end;

procedure Tpi_MBStest_f.oachClick(Sender: TObject);
begin
	if oach.Checked
	then opar.Value := opar.Value or 4
	else opar.Value := opar.Value and (255 - 4);
	if Assigned(fini)
	then setfini('ach', oach.checked);
end;

procedure Tpi_MBStest_f.ononClick(Sender: TObject);
begin
	if onon.Checked
	then opar.Value := opar.Value or 2
	else opar.Value := opar.Value and (255 - 2);
	if Assigned(fini)
	then setfini('non', onon.checked);
end;

procedure Tpi_MBStest_f.onofClick(Sender: TObject);
begin
	if onof.Checked
	then opar.Value := opar.Value or 1
	else opar.Value := opar.Value and (255 - 1);
	if Assigned(fini)
	then setfini('nof', onof.checked);
end;

procedure Tpi_MBStest_f.ondvChange(Sender: TObject);
begin
	if assigned(dec)
	and gbout.Visible
	then pt.SendPar(dec.value, dev.tag + 1, ondv.tag, ondv.value);
	if Assigned(fini)
	then setfini('ndv', ondv.value);
end;

procedure Tpi_MBStest_f.oontChange(Sender: TObject);
begin
	if assigned(dec)
	and gbout.Visible
	then pt.SendPar(dec.value, dev.tag + 1, oont.tag, oont.value);
	if Assigned(fini)
	then setfini('ont', oont.value);
end;

procedure Tpi_MBStest_f.ooftChange(Sender: TObject);
begin
	if assigned(dec)
	and gbout.Visible
	then pt.SendPar(dec.value, dev.tag + 1, ooft.tag, ooft.value);
	if Assigned(fini)
	then setfini('oft', ooft.value);
end;

procedure Tpi_MBStest_f.ondvClick(Sender: TObject);
begin
	ondv.Add;
end;

procedure Tpi_MBStest_f.ondvmClick(Sender: TObject);
begin
	ondv.Sub;
end;

procedure Tpi_MBStest_f.oontpClick(Sender: TObject);
begin
	oont.Add;
end;

procedure Tpi_MBStest_f.oontmClick(Sender: TObject);
begin
	oont.Sub;
end;

procedure Tpi_MBStest_f.ooftpClick(Sender: TObject);
begin
	ooft.Add;
end;

procedure Tpi_MBStest_f.ooftmClick(Sender: TObject);
begin
	ooft.Sub;
end;

procedure Tpi_MBStest_f.atimChange(Sender: TObject);
begin
	if assigned(dec)
	and gbout.Visible
	then pt.SendPar(dec.value, dev.tag + 1, atim.tag, atim.value);
	if Assigned(fini)
	then setfini('tim', atim.value);
end;

procedure Tpi_MBStest_f.atimpClick(Sender: TObject);
begin
   atim.Add;
end;

procedure Tpi_MBStest_f.atimmClick(Sender: TObject);
begin
	atim.Sub;
end;

procedure Tpi_MBStest_f.ravh01Click(Sender: TObject);
begin
	if assigned(fini)
	then fini.Free;
	fini := tinifile.Create(anlage + 'ravh0.ini');
	dec.Value := 0;
	caption := fini.FileName;
end;

procedure Tpi_MBStest_f.tst1Click(Sender: TObject);
begin
	if assigned(fini)
	then fini.Free;
	fini := tinifile.Create(anlage + 'tst.ini');
	dec.Value := 0;
	caption := fini.FileName;
end;

procedure Tpi_MBStest_f.inibereinigen1Click(Sender: TObject);
var
	h: tinifile;
	i,
	dc,
	dv: integer;
	f1,
	f2,
	fn,
	s,
	sdc,
	sdv: string;
	ts: tstringlist;
begin
	fn := fini.FileName;
	fini.Free;
	for i := 9 downto 0
	do begin
		if i > 0
		then f1 := changefileext(fn, '.ini' + inttostr(i - 1))
		else f1 := fn;
		f2 := changefileext(fn, '.ini' + inttostr(i));
		if fileexists(f1)
		then copyfile(pchar(f1), pchar(f2), false);
	end;
	deletefile(fn);
	fini := tinifile.Create(fn);
	h := tinifile.Create(f2);
	ts := tstringlist.Create;
	for dc := 0 to 127
	do begin
		sdc := format('Decoder%3.3d', [dc]);
		if h.SectionExists(sdc)
		then begin
			fini.WriteString(sdc, 'dec', h.readstring(sdc, 'dec', ''));
			fini.WriteString(sdc, 'a51', h.readstring(sdc, 'a51', '0'));
			for dv := 1 to 13
			do begin
				sdv := format('dev%2.2d', [dv]);
				s := h.readstring(sdc, sdv, '');
				fini.WriteString(sdc, sdv, s);
				if s > ''
				then begin
					h.ReadSectionValues(s, ts);
					for i := 0 to ts.Count - 1
					do begin
						fini.WriteString(s, ts.Names[i], ts.Values[ts.Names[i]]);
					end;
					ts.Clear;
				end;
			end;
		end;
	end;
	ts.Free;
	h.Free;
end;

end.

